/*
 * $Id: 96445c4498236a18eb658613dc0f4d2b64a16613 $
 */

/* Encoding: UTF-8 (No BOM)  Notation (in 5th position):
     * Change, ! Fix, % Optimization, + Addition, - Removal, ; Comment
   Entries may not always be in chronological/commit order.
   See license at the end of file. */

2025-10-19 22:12 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbssl/hbssl.h
  * contrib/hbssl/hbssl.hbm
  * contrib/hbssl/ssl.c
    ! HB_OPENSSL_HAS_APPLINK was never checked,
      defining HB_OPENSSL_NO_APPLINK didn't do anything

    * make current OpenSSL 3.6.0 build under fresh MSYS2
      shell. MSYS2 does not distribute applink.c, claiming
      MingGW C runtime is safe for operation without it.
      Have to define HB_OPENSSL_NO_APPLINK and additional
      workaround for lacking __int64 type when including
      ssl.h. If you need similar workround outside of
      MSYS2 shell, setenv: HB_USER_CFLAGS=-DHB_OPENSSL_MSYS

      packages needed: openssl-devel (for headers)
                       mingw-w64-x86_64-openssl (for libs)
                       mingw-w64-aarch64-openssl

  * contrib/hbssl/hbssl.hbc
    * using Clang or Zig compiler on Windows, build will
      now reference libssl and libcrypto instead of old
      ssleay32/libeay32 pair when linking.

  * config/win/zig.mk
    % unnecessary check

2025-10-18 23:15 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  + config/bsd/zig-noauto.mk
  + config/bsd/zig.mk
  + config/common/zig-noauto.mk
  + config/common/zig.mk
  + config/darwin/zig-noauto.mk
  + config/darwin/zig.mk
  + config/linux/zig-noauto.mk
  + config/linux/zig.mk
  + config/win/zig-noauto.mk
  + config/win/zig.mk
  * config/global.mk
  * utils/hbmk2/hbmk2.prg
    ! typo fixed in Alpha target (this path was really untested)

    + added support for using Zig as LLVM C compiler frontend. Recent
      idea comes from Marcos Gambeta Harbour++ fork, though I haven't
      borrowed any code. Here the functionalty is complete, whole
      Harbour source tree can be compiled, together with shared libs.

      Zig has unique ability of managing cross-compiled builds, mostly
      without downloading anything else. For example you should be able
      to easily make a Linux+musl libc build of your Harbour application
      that will run on any distribution with Linux kernel >= 2.6.39 (untested).

      Zig is not auto-detected by the Harbour build process, HB_COMPILER=zig
      has to be defined. The only exception is that, hbmk2 on Windows can
      locate "zig.exe" while building final Harbour applications. Usually
      there are no conflicting tools on PATH on this platform.

      After downloading zig from https://ziglang.org/download/
      specific to your OS, assuming the tool being unpacked to
      /home/user/zig or C:\zig, usage is as follows:

      Linux/BSD native build:
      PATH=$PATH:/home/user/zig
      HB_COMPILER=zig make -j8

      Unix to Windows x64 cross:
      PATH=$PATH:/home/user/zig
      export HB_ZIG_TARGET=x86_64-windows
      # (or) export HB_ZIG_TARGET=x86_64-windows-gnu
      export HB_CPU=x86_64
      # have to build a Harbour for your host first, for a native hbmk2
      export HB_HOST_BIN=/home/user/harbour/bin/linux/zig
      export HB_PLATFORM=win
      export HB_BUILD_NAME=64cross
      export HB_COMPILER=zig
      make -j16

      Windows native build:
      PATH=C:\zig;%PATH%
      set HB_COMPILER=zig
      win-make -j8

      Windows to Windows-on-ARM cross:
      set HB_ZIG_TARGET=aarch64-windows
      set HB_CPU=arm64
      set HB_HOST_BIN=C:\harbour\bin\win\zig
      set HB_COMPILER=zig
      win-make -j8

      Windows to Linux ARM64:
      set HB_USER_CFLAGS=-fPIC
      set HB_ZIG_TARGET=aarch64-linux
      set HB_PLATFORM=linux
      set HB_CPU=arm64
      set HB_HOST_BIN=C:\harbour\bin\win\zig
      set HB_COMPILER=zig
      win-make -j8

      Instead of setting HB_ZIG_TARGET, the less convenient way is:
      HB_USER_CFLAGS=-target aarch64-linux
      HB_USER_LDFLAGS=-target aarch64-linux
      HB_USER_DFLAGS=-target aarch64-linux

      Some target platforms need PIC mode even for static builds,
      in such case add:
      HB_USER_CFLAGS=-fPIC

    ; TOFIX: shared lib symlinks are not created when cross-building from
             Windows to Linux, could copy or adapt modern Windows counterpart

             olectl.h is missing when cross-building hbwin contrib from
             Linux to Windows (likely needs headers from Windows SDK)

             basically a non issue, but HB_CPU and HB_PLATFORM are not guessed
             from HB_ZIG_TARGET - conversion table seems to be doable, if
             someone is interested in making a patch.

2025-10-16 22:04 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * utils/hbmk2/hbmk2.prg
    * remaining LEFTEQUAL() changed to hb_LeftEq() calls
    - removed LEFTEQUAL() macro

2025-10-16 21:40 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * config/global.mk
    * follow up to previous, define __ARCH64BIT__ for .prg files
      if applicable during first stage done by GNU Make

    * consider Alpha a 64-bit CPU too when it's a cross-build target
      (untested)

  * utils/hbmk2/hbmk2.prg
    * updated stored list of Visual Studio (2013-2022) versions to C comp
      revisions, which could be used in .hbp files HB_COMP_VER macro

    ; https://learn.microsoft.com/en-us/cpp/overview/compiler-versions
      more detailed versioning available if someone is interested in that
      please submit a patch that would translate C compiler path to
      version according to the linked rules - MSVC now has rolling
      releases

2025-10-16 21:09 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * utils/hbmk2/hbmk2.prg
    * updated approach to define __ARCH64BIT__ at .prg level when
      cross-compiling for such architecture.
      Thanks to Alexey Zapolskiy for noticing.

    + local hb_RightEq() deployed as macro

2025-10-04 09:09 UTC+0100 Antonio Linares (antonio.fivetech/at/gmail.com)
  * config/bin.mk
    ! fixed duplicate library warnings on macOS by defining platform-specific
      HB_LIBS_TPL template without duplicate hbrtl and hbvmmt libraries

  * utils/hbmk2/hbmk2.prg
    ! fixed timing of macOS-specific library deduplication in aLIB_BASE_RDD
      and aLIB_BASE_RDD_MT arrays to occur after platform detection, eliminating
      duplicate library warnings during program compilation

2025-09-16 13:16 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbcurl/core.c
    ! pacified warning

2025-09-10 09:08 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbbmp/core.c
    ! pacified BCC warnings

2025-09-09 19:55 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbbmp/core.c
    ! pacified BCC warnings

  * src/vm/macro.c
    * minor modification to test if it can pacify false warning in recent GCC

2025-09-09 18:58 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/3rd/png/pngrutil.c
    ! moved PNG_UNUSED() before return statement to avoid BCC W8070 Warning

  * src/3rd/png/png.diff
    ! rediffed with
         hbmk2 ../../../bin/3rdpatch.hb -rediff

2025-09-09 18:13 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/3rd/zlib/Makefile
  * src/3rd/zlib/README
  * src/3rd/zlib/deflate.c
  * src/3rd/zlib/deflate.h
  * src/3rd/zlib/gzguts.h
  * src/3rd/zlib/gzlib.c
  * src/3rd/zlib/inflate.c
  * src/3rd/zlib/inftrees.c
  * src/3rd/zlib/inftrees.h
  * src/3rd/zlib/trees.c
  * src/3rd/zlib/zconf.h
  * src/3rd/zlib/zlib.h
  * src/3rd/zlib/zutil.h
  * src/3rd/zlib/zlib.diff
    * updated to version 1.3.1

2025-09-09 17:38 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbmlzo/3rd/minilzo/README
  * contrib/hbmlzo/3rd/minilzo/lzoconf.h
  * contrib/hbmlzo/3rd/minilzo/lzodefs.h
  * contrib/hbmlzo/3rd/minilzo/minilzo.c
  - contrib/hbmlzo/3rd/minilzo/minilzo.diff
  * contrib/hbmlzo/3rd/minilzo/minilzo.h
  * contrib/hbmlzo/3rd/minilzo/minilzo.hbp
    * updated to version 2.10

2025-09-09 16:36 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/3rd/png/LICENSE
  * src/3rd/png/Makefile
  * src/3rd/png/png.c
  * src/3rd/png/png.diff
  * src/3rd/png/png.h
  * src/3rd/png/pngconf.h
  * src/3rd/png/pngdebug.h
  * src/3rd/png/pngerror.c
  * src/3rd/png/pngget.c
  * src/3rd/png/pnginfo.h
  * src/3rd/png/pnglconf.h
  * src/3rd/png/pngmem.c
  * src/3rd/png/pngpread.c
  * src/3rd/png/pngpriv.h
  * src/3rd/png/pngread.c
  * src/3rd/png/pngrio.c
  * src/3rd/png/pngrtran.c
  * src/3rd/png/pngrutil.c
  * src/3rd/png/pngset.c
  * src/3rd/png/pngstru.h
  * src/3rd/png/pngtrans.c
  * src/3rd/png/pngwio.c
  * src/3rd/png/pngwrite.c
  * src/3rd/png/pngwtran.c
  * src/3rd/png/pngwutil.c
    * updated to version 1.6.50

  * contrib/hbmlzo/3rd/minilzo/minilzo.c
  + contrib/hbmlzo/3rd/minilzo/minilzo.diff
    ! fixed compilation with ISO C++ 17 compilers

2025-09-09 13:50 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbdefs.h
    + added new types HB_WCHAR16 and HB_WCHAR32, existing type HB_WCHAR
      is mapped to HB_WCHAR16 (just like before)

  * include/hbapicdp.h
  * src/harbour.def
  * src/rtl/cdpapi.c
    + added new C functions for encoding and decoding UTF-8 string using
      which HB_WCHAR32:
         int hb_cdpU32CharToUTF8( char * szUTF8, HB_WCHAR32 wc );
         HB_BOOL hb_cdpUTF8GetU32( const char * pSrc, HB_SIZE nLen,
                                   HB_SIZE * pnIndex, HB_WCHAR32 * pWC );
         HB_BOOL hb_cdpUTF8GetUCS( const char * pSrc, HB_SIZE nLen,
                                   HB_SIZE * pnIndex, HB_WCHAR32 * pWC );
         HB_BOOL hb_cdpUTF8GetU16( const char * pSrc, HB_SIZE nLen,
                                   HB_SIZE * pnIndex, HB_WCHAR16 * pWC );
         HB_BOOL hb_cdpUTF8Validate( const char * pSrc, HB_SIZE nLen );
      They support full UCS and are much more restrictive against errors and
      wrong UTF-8 encoding, i.e. now overlong encoding is forbidden.
      The wrong characters are translated to 0xFFFD and later if such
      character does not exist in final CP to '?' ASCII character.
    * declaration of the following UTF-8 C functions have been changed to
      operate on HB_WCHAR32 instead of HB_WCHAR:
         int hb_cdpUTF8CharSize( HB_WCHAR32 wc );
         HB_WCHAR32 hb_cdpUTF8StringPeek( const char * pSrc, HB_SIZE nLen,
                                          HB_SIZE nPos );
    * the following C functions have been changed to internally operate on
      HB_WCHAR32 instead of HB_WCHAR:
         hb_cdpUTF8StringLength()
         hb_cdpUTF8StringAt()
         hb_cdpUTF8StringSubstr()
    * the following C functions have been changed to use new hb_cdpUTF8GetU*()
      instead of step by step decoding with hb_cdpUTF8ToU16NextChar()
         hb_cdpStrToUTF8Disp()
         hb_cdpUTF8AsStrLen()
         hb_cdpUTF8ToStr()
         hb_cdpStrToU16()
         hb_cdpUtf8Char()
    * use HB_CDP_ERROR_* macros to mark wrong encoding

  * src/rtl/cdpapihb.c
    * the following UTF-8 C functions have been changed to operate on
      HB_WCHAR32 instead of HB_WCHAR:
         hb_utf8Chr()
         hb_utf8Asc()
         hb_utf8Poke()
         hb_utf8Peek()
      Other UTF-8 PRG functions have been adopted to HB_WCHAR32 by changes
      in corresponding C functions.

  * src/codepage/cp_utf8.c
    * use new function hb_cdpUTF8GetU16() to decode UTF-8 strings in UTF8EX CP

  * src/rtl/arc4.c
    + added new macro HB_NO_SYSCTL which allow to disable sysctl() in Linux
      builds for GLIBC < 2.30

2025-09-03 12:21 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/cdpapi.c
    + added fallback translation table for different variants of Latin
      character, now when translation is made between different encoding
      and the variant of Latin character does not exist in destination
      code page then it's translated to their base Latin form, i.e.:
         hb_utf8ToStr( "ĄĆĘŁŃÓŚŹŻąćęłńóśźż", "EN" ) -> "ACELNOSZZacelnószz"

  * tests/uc16_gen.prg
    ; updated comment

2025-08-29 12:49 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbbmp/core.c
  * contrib/hbbmp/hbbmp.ch
  * contrib/hbbmp/hbbmp.h
  * contrib/hbbmp/hbbmp.hbx
    + added new PRG functions:
         hb_bmp_frombitmap( <cBitMap>, <nAlign>, <nWidth>, <nHeight>, ;
                            [<nDepth>=1], [<nDPI>=72], [<aPalette>], ;
                            [@<nError>] ) -> <pBMP> | NIL
         hb_bmp_colorreset( <pBMP> )

  * contrib/hbct/dattime3.c
    ! struct timespec initialization

  * contrib/hbplist.txt
    + added hbbmp library

  * contrib/hbzebra/coredraw.c
  * contrib/hbzebra/hbzebra.hbx
    + added new PRG function:
         hb_zebra_getbitmap( <hZebra>, <nAlign>=8, <lBottomUp>=.F., ;
                             @<nWidth>, @<nHeight>, <nScaleX>, <nScaleY>, ;
                             <nBorder> ) -> <cBitMap> | NIL

  * contrib/hbzebra/tests/bmp.prg
    + added example for much faster BMP creation using hb_zebra_getbitmap() and
      hb_bmp_frombitmap() functions

  * src/rtl/filebuf.c
    ! casting

  * src/vm/extrap.c
    * allocate stack buffer dynamically, in new Linux version IGSTKSZ is
      defined as sysconf( _SC_SIGSTKSZ ) so it cannot be used as legal size
      for static arrays

2025-08-23 18:49 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbbmp/core.c
    ! fixed copy & past typos reported by Grigory Filatov. Thanks a lot.

2025-08-22 21:50 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  + contrib/hbbmp/core.c
  + contrib/hbbmp/hbbmp.ch
  + contrib/hbbmp/hbbmp.h
  + contrib/hbbmp/hbbmp.hbc
  + contrib/hbbmp/hbbmp.hbp
  + contrib/hbbmp/hbbmp.hbx
  + contrib/hbbmp/readme.txt
  + contrib/hbbmp/tests/hbbmptst.prg
  + contrib/hbbmp/tests/hbmk.hbm
    + added new BMP image library for Harbour
    ; HBBMP is small library for Harbour dedicated to create and modify
      BMP images. It has not any 3rd party libs dependencies.
      See readme.txt for more information

  + contrib/hbzebra/tests/bmp.prg
    + added example code which uses HBBMP as backend for HBZEBRA and
      creates BMP images with generated barcodes.

2025-08-22 12:00 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbzebra/coredraw.c
  * contrib/hbzebra/hbzebra.hbx
    + added new PRG function:
         hb_zebra_getsize( <hZebra>, @<nWidth>, @<nHeight> ) -> <nError>
      it calculates size in points of the created barcode and returns 0 on
      success or error code

  + contrib/hbzebra/tests/gtgfx.prg
    + borrowed from Viktor's fork, thanks
      2014-09-18 22:32 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
       + added on-screen barcode example, created by elch
         (with some minor cleanups)
         https://groups.google.com/d/msg/harbour-users/_Wht51JZGgE/ZXyvaJNH9ggJ
         https://github.com/vszakats/hb/commit/feb4fc0e204388fd88ce0456564894469355affa

  * contrib/sddoci/core.c
    * map ostrlen() to strlen() or wcslen() in OCI_CHARSET_UNICODE builds
    ; TOFIX: this library uses wchar_t for unicode strings, it means that
             in *nixes where wchar_t is 32-bit integer mapping to Harbour
             HB_WCHAR is wrong and has to be fixed

  * include/hbapifs.h
  * src/harbour.def
  * src/rtl/filebuf.c
   + added new C function:
         HB_BOOL hb_fileSave( const char * pszFileName,
                              const void * buffer, HB_SIZE nSize );

  * include/harbour.hbx
  * src/harbour.def
  * src/rtl/vfile.c
    + added new PRG function:
         hb_vfSave(  <cFileName>, <cFileBody> ) --> <lOK>

  * src/rtl/vfile.c
    * set FError() code in hb_vfLoad()

2025-08-17 18:27 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc.h
  * contrib/gtqtc/gtqtc1.cpp
    + added support for disabling title and frames of console window by
         hb_gtInfo( HB_GTI_WINTITLE, <lNoFrame> )

  * src/rtl/transfrm.c
    ! fixed bug in "@S<n>" transformation when multibyte CDP is used

2025-07-19 19:44 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbhpdf/core.c
    + HPDF_GetPageByIndex( hDoc, nIndex ) --> hPage / NIL
      suggested by Luigi Ferraris

  * contrib/hbhpdf/tests/harupdf.prg
    + test the above (disabled by default)

  * README.md
    * updated CI badge(s) to GitHub Actions - they also cover
      the strict compilation mode, definitions are currently
      located in the same file as normal

    ! cleaned up links, mostly in tools section, some were
      broken, for others switched to https where applicable

    * mention HB_CCPREFIX= support for clang

  * contrib/hbdoc/hbdoc.prg
  * contrib/hbformat/utils/hbformat.prg
  * contrib/hbnetio/utils/hbnetio/hbnetio.prg
  * package/harbour.mft
  * package/harbour.rc
  * src/compiler/hbusage.c
  * utils/hbi18n/hbi18n.prg
  * utils/hbtest/hbtest.prg
    * bumped copyright year to 2025

2025-07-10 14:04 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbpost.hbm
    ! fix missing contrib/*/tests/files when using "make install"
      and HB_INSTALL_PREFIX.
      Thanks Jose Quintas for reporting (issue #310)

2025-07-09 15:04 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbclass.ch
    ! fixed class declaration to allow muliple PP run - thanks to Wen Sheng
      for slef conatin example

2025-07-07 16:17 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * config/win/clang.mk
    + add resource compiler detection chain to first stage,
      now harbour.exe binary should also have manifest resource
      compiled in when clang is used. Previously second stage rc
      calling was implemented only in hbmk2.

  * utils/hbmk2/hbmk2.prg
    ! fixed disappearing llvm-ar with fallback to ar, spotted
      in windows-ci/MSYS2

2025-07-07 13:42 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * .github/workflows/windows-ci.yml
    * libgd, qt5-base not available in MSYS x86

  * ChangeLog.txt
    + entry in prev skipped during merge

2025-07-05 20:20 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  + config/wasm/global.mk
  + config/wasm/libs.mk
  + config/wasm/emcc.mk
  * utils/hbmk2/hbmk2.prg
  * contrib/hbrun/hbrun.hbp
    + add basic support for build Harbour into JS/WebAssembly using
      emscripten, using these settings:
        HB_PLATFORM=wasm HB_COMPILER=emcc HB_BUILD_3RDEXT=no

    * {abstr} is now a hbmk2 keyword to possibly group all
      toolsets similar in flavour: WASI/clang, JS/emscripten
      These most likely will be targeting plaforms which are not
      full operating-systems, they are also commonly qualified as
      sandbox solutions.

    * introduced __PLATFORM__WASM and __PLATFORM__ABSTRACT .prg defines

  * utils/hbmk2/hbmk2.prg
    + allow to specify hb_ProgName() value at build-time for platforms
      where the function cannot return a meaningful value (f.e.
      JS/WebAssembly)
    ; TODO: Add support for passing hb_ProgName() value command-line
            parameter, f.e. `--hb:self=hbrun`

  * config/global.mk
  * include/hbsetup.h
    * consider abstract/emscripten targets similar to linux-like

  * src/rtl/arc4.c
    ! fix to build under emscripten (which is assumed to be a
      linux-like environment)

  * src/vm/extrap.c
    ! emscripten mimics UNIX/Linux to some extent, but there is no
      sigaltstack() implementation

  ; though platform/compiler names are not currently compatible
    with origin, this WebAssembly platform support was guided by
    Harbour 3.4:
    2017-06-09 01:10 UTC Viktor Szakats (vszakats users.noreply.github.com)
    as usual Viktor was here before, many thanks!

  ; example project, how to make a multi-platform GUI application which
    also targets WebAssembly, can be found here:
    https://github.com/alcz/harbour-cimgui-sokol-starterkit/

2025-03-25 13:54 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbcurl/core.c
    ! pacified warnings

  * contrib/hbssl/ssl.c
  * contrib/hbssl/sslctx.c
    ! use 64-bit integers in SSL_[CTX]_[s|g]et_options() for OpenSSL >= 3.0

2025-03-20 06:30 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/cdpapihb.c
    ! fixed hb_transalte() to not clear passed string
      when neither CPIN nor CPOUT is set

  * src/rtl/hbgtcore.c
    ! fixed hb_gtAttach() to properly work with empty GT pointer

2025-02-21 11:16 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbcurl/hbcurl.hbp
    + added Windows architecture specific libcurl names:
      libcurl-x64.dll, libcurl-arm64.dll as suggested
      by @carles9000 in #382

2025-02-11 04:21 UTC+0100 Antonio Linares (alinares/at/fivetechsoft.com)
  * contrib/hbcurl/core.c
    + implemented required explicit cast reported by Lorenzo Fiorini

2025-02-03 12:26 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbdefs.h
  * contrib/sddsqlt3/core.c
    - removed HB_WATCOM_64BUG macro - new versions of OW 2.0 supports 64bit
      integers in preprocessor directives - Many thanks to Aleksander who
      reported the problem on OpenWatcom V2 forum
    + added test for 64bit support in C preprocessor suggested by Aleksander

  * .github/workflows/windows-ci.yml
    * minor simplification

2025-02-03 10:50 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbcurl/core.c
    * formatting, use HB_IT_EVALITEM instead ( HB_IT_BLOCK | HB_IT_SYMBOL )

2025-02-03 10:18 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbcurl/core.c
    ! reverted static keyword

  * ChangeLog.txt
    ! formatting

2025-02-03 09:09 UTC+0100 Antonio Linares (alinares/at/fivetechsoft.com)
  * contrib/hbcurl/core.c
    ! HB_CURLOPT_WRITEFUNCTION implemented support
      Required to use AI Ollama from Harbour so the tokens are visible to the user
      as they are generated

2025-02-03 08:42 UTC+0100 Detlef Riekenberg 
  * src/common/hbver.c
    ! Open Watcom versions numbers started with "1.0" after the latest commercial
      Watcom 11.0c. TinyC has no 1.0 release yet and is currently at 0.9.28rc.

2025-02-01 08:37 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  + config/android/clang.mk
    + allow to create android builds with CLANG
  * config/common/watcom.mk
    ! fixed C compilation in sh like shells

2025-01-30 19:59 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * utils/hbmk2/hbmk2.prg
    ! issue #379 follow-up to OpenWatcom target platform
      autodetection, hbmk2 needed similar patching

2025-01-30 17:58 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/3rd/sqlite3/sqlite3.c
    * for GCC >= 14 builds added
         #pragma GCC diagnostic ignored "-Wstringop-overread"

  * contrib/3rd/sqlite3/sqlite3.hbp
    * removed
         -cflag=-Wno-stringop-overread
      used in all GCC builds when HB_BUILD_TEST='strict'

  * contrib/3rd/sqlite3/sqlite3.diff
    * regenerated

2025-01-30 16:19 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbcurl/core.c
    ! casting

  * include/hbcompdf.h
    * removed unnecassary parenthesies and indenting

  * src/rtl/errint.c
    * added
         #pragma GCC diagnostic ignored "-Wnull-dereference"

  * src/vm/dlmalloc.c
    - removed
         #pragma GCC diagnostic ignored "-Wnull-dereference"

  * src/vm/fm.c
    + added
         #pragma clang diagnostic ignored "-Wgnu-null-pointer-arithmetic"
         #pragma GCC diagnostic ignored "-Warray-bounds"
         #pragma GCC diagnostic ignored "-Wmaybe-uninitialized"
         #pragma GCC diagnostic ignored "-Walloc-size"

2025-01-30 11:54 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/vm/Makefile
  * src/vm/vmmt/Makefile
  * src/vm/dlmalloc.c
    * In GCC builds >= 6.1 use
         #pragma GCC diagnostic ignored "-Wnull-dereference"
      instead of foringg HB_FM_STD_ALLOC

2025-01-30 04:23 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbzebra/datamtrx.c
    * added '#pragma GCC diagnostic ignored "-Warray-bounds"'
      to disable GCC 12, 13 and 14 false warnings about array bounds for
      static constant data

  * contrib/hbzebra/hbzebra.hbp
    * removed -Wno-error=array-bounds C compiler parameter used in all GCC
      builds

2025-01-30 03:56 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbzebra/datamtrx.c
  * contrib/sddoci/core.c
    * reverted modifications committed by mistake

2025-01-30 03:51 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/vm/hvm.c
    * changed returned type of hb_vmCalcIntWidth() to avoid casting

2025-01-30 03:34 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbdefs.h
    * added final workarounds for OpenWatcom 2.0 bug in 64bit expressions used
      in #[el]if statements

2025-01-30 02:48 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/sddsqlt3/core.c
  * include/hbdefs.h
  * src/compiler/gencc.c
  * src/rtl/abs.c
  * src/vm/hvm.c
    * added workarounds for OpenWatcom 2.0 bug in 64bit expressions used
      in #[el]if statements

2025-01-29 13:50 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/bio.c
    ! respect OPENSSL_NO_SOCK macro

  * contrib/hbssl/bio.c
  * contrib/hbssl/err.c
  * contrib/hbssl/evp.c
  * contrib/hbssl/pem.c
    * disabled deprecated functions which do nothinng in OpenSSL 3.0

  * src/rtl/filesys.c
  * src/rtl/hbcom.c
  * src/rtl/hbproces.c
  * src/rtl/hbsocket.c
  * src/rtl/net.c
  * src/rtl/netusr.c
  * src/vm/dynlibhb.c
    * updated for OpenWatcom 2.0 builds

2025-01-28 20:27 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * config/global.mk
    ! fixed OpenWatcom target platform autodetection to conform with
      progress OW is making, as it was kindly reported in issue #379

2025-01-28 13:46 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/hbssl.h
  * contrib/hbssl/evppkey.c
  * contrib/hbssl/rsa.c
    * reenabled hb_RSA_par_remove() for old OpenSSL() versions (<=0.9.6) which
      do not support RSA_up_ref()

  * contrib/hbssl/ssl.c
    ! use
         x509 = X509_dup( x509 );
         X509_check_purpose( x509, -1, 0 );
      instead of
         X509_up_ref( x509 );
      in OpenSSL versions prior 0x10100000L - they do not support X509_up_ref()

  * contrib/hbssl/x509.c
    * check passed parameters more strictly
    * return NIL when X509 certificate cannot be allocated/accessed

2025-01-28 12:23 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/bio.c
    ! do not leave dummy BIO declaration for OpenSSL < 1.1.0

2025-01-28 12:01 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/bio.c
    ! use BIO_ADDR* in OpenSSL >= 1.1.0 and do not use it in LibreSSL

2025-01-28 11:34 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/hbssl.hbx
  * contrib/hbssl/bio.c
    ! fixed BIO_set_conn_int_port() to work with OpenSSL >= 1.1
      (emulation with BIO_set_conn_port())
    ! fixed BIO_get_conn_ip() to work with OpenSSL >= 1.1
      (emulation with BIO_get_conn_address() and BIO_ADDR_hostname_string())
    + added BIO_get_conn_address(), it returns HB_SOCKET compatible array
      with address

  * contrib/hbssl/hbssl.hbx
  * contrib/hbssl/sslctx.c
    + added new function SSL_CTX_use_RSAPrivateKey()
    ! respect OPENSSL_NO_RSA macro in other SSL_CTX_use_RSA*() functions

  * contrib/hbssl/evp.c
    ! use EVP_CIPHER_key_length() and EVP_CIPHER_iv_length() in
      EVP_BytesToKey() to detect the exact key and iv length.

  * contrib/hbssl/hbssl.h
  * contrib/hbssl/evppkey.c
  * contrib/hbssl/rsa.c
    * removed hb_RSA_par_remove() function, use RSA_up_ref() instead

  * contrib/hbssl/hbssl.h
  * contrib/hbssl/x509.c
  * contrib/hbssl/pem.c
  * contrib/hbssl/ssl.c
    * removed 2-nd parameter ( HB_BOOL fRelease ) from hb_X509_ret(),
      use X509_up_ref() instead

  * contrib/hbssl/pem.c
    * respect OPENSSL_NO_DSA, OPENSSL_NO_DH and OPENSSL_NO_RSA macros

  * contrib/hbssl/ssl_sock.c
    * added casting to pacify SSL_set_fd() warning and updated link with
      description of the problem

2025-01-26 09:57 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/3rd/sqlite3/sqlite3.hbp
    * use -Wno-unknown-warning-option also in GCC MacOSX builds

2025-01-26 09:37 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/vm1-ci.yml
    * reenabled freebsd builds
    * be sure N_CPUS is always set
    * show compiler version before build

  * contrib/3rd/sqlite3/sqlite3.hbp
    * enable -Wno-unknown-warning-option only for CLANG - older GCC versions
      does not like it
    * use -Wno-stringop-overread instead of -Wno-error=stringop-overread,
      Unlike Wno-error=* the unknown -Wno-* options are ignored by most of
      old GCC compilers

2025-01-25 23:25 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/vm1-ci.yml
    * add path to sysctl call

2025-01-25 17:45 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/vm1-ci.yml
    * enablkled freeimage
    * set HB_BUILD_TEST to ${{matrix.strictness}}
    * reenabled full strict build

2025-01-25 17:14 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/bio.c
  * contrib/hbssl/evpciph.c
  * contrib/hbssl/evpenc.c
  * contrib/hbssl/evpmd.c
  * contrib/hbssl/ssl.c
    * updated to compile with newer versions of LibreSSL

2025-01-25 12:08 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbcurl/core.c
    ! fixed curl_easy_getinfo( <curl>, CURLINFO_CERTINFO, <arg> ) call. The
      argument should be 'struct curl_certinfo **' not 'struct curl_slist **'

2025-01-25 11:14 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbcurl/core.c
    ! declare buffer for CURLOPT_ERRORBUFFER as 'char *' instead of
      'unsigned char *', the exact buffer type is chcked in typecheck-gcc.h
      and 'unsigned char *' does not pass this test
    ; QUESTION:
      Why curl_easy_setopt( <pCurl>, HB_CURLOPT_ER_BUFF_SETUP, [<nBufSize>] )
      accepts <nBufSize> parameter?
      Buffer smaller then CURL_ERROR_SIZE means GPF and larger waste of memory.
      The only acceptable value for <nBufSize> is CURL_ERROR_SIZE.
      The allocate buffer should be initialized with '\0' otherwise we will
      have other GPF trap when user call curl_easy_er_buff_get() before any
      error is set. This bug was fixed in CURL 7.60.0.

2025-01-25 10:19 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/vm1-ci.yml
  * .github/workflows/vm2-ci.yml
    * updated to always set number of CPUs for -j GNU make switch,
      using unlimited number of forks (-j without parameter) causes
      'Resource temporarily unavailable' error

2025-01-24 19:15 UTC-0300 Mario Wan Stadnik (wanstadnik gmail.com)
  * utils/hbmk2/hbmk2.prg
    * http://timestamp.verisign.com/scripts/timstamp.dll has limped 
      along for the last few years and had been working in a sort 
      of depreciated state, but the new owners of the certificate 
      issuing business, DigiCert, have issued a migration alert so
      we are switching to: http://timestamp.comodoca.com/authenticode
    ; It allows the user to choose the algorithm: SHA256 or SHA384,
      by appending ?td=sha384 to above URL

2025-01-24 15:02 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbct/dattime3.c
    ! fixed in block variable declaration for strict ANSI C compat
    * code formatting
    ; both borrowed from Viktor's fork, thanks
      https://github.com/vszakats/hb/commit/aa4665f16ff92443681fc0b7a2f4a6bd67c6a199
      https://github.com/vszakats/hb/commit/d9f37296b01bb5a5fef1afb50c91ec0ed4fe900e

  * src/rdd/dbcmd.c
    * note about C5.3/5.2 DBAPPEND( [<lUnlockAll>=.t.] ) updated again
      upon Przemek notification, thanks

2025-01-24 13:28 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/vm1-ci.yml
    * switched the runner from macos-latest to ubuntu-latest
      Support for macOS runners has been deprecated.

2025-01-24 13:23 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/vm1-ci.yml
    * updated to recent cross-platform-actions releae

2025-01-24 12:32 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    * pacified false MSVC warning. It's very seldom situation that I'm adding
      code to pacify false compiler warnings anyhow in this case it cost in
      practice nothing so I decided to do that.

  * contrib/xhb/hboutdbg.c
  * src/rtl/gtcrs/gtcrs.c
    * NULL pointer casting to pacify warning

  * src/pp/hbpp.c
    % do not created new iLen variable but reuse the one previously declared

  * src/vm/classes.c
    % allocate puiMsgIdx as array of HB_USHORT items instead of HB_SYMCNT.
      This modification only reduces the memory usage and has no effect on
      number of accepted symbols.
    * changed 'HB_SYMCNT uiHashKey' to 'HB_SIZE nHashKey' to avoid explicit
      casting in the code

2025-01-24 10:10 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/hbssl.hbm
    * added -Wno-error=deprecated-declarations to suppress errors in Solaris
      strict builds compiled with -Werror
      EVP_des_*() except EVP_des_ede3*()), EVP_desx_*(), EVP_rc[24]*() and
      EVP_md[245]*() are deprecated

2025-01-24 09:21 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/ssl.c
  * contrib/hbssl/sslctx.c
    * protect access to SSLv3_*() functions with #ifndef OPENSSL_NO_SSL3_METHOD

2025-01-24 07:02 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/vm2-ci.yml
    * reenabled solaris build with release 11.4-gcc

2025-01-23 17:45 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbdate.h
  * src/common/hbdate.c
  * src/harbour.def
    + added new C functions:
         HB_BOOL hb_timeStrGetUTC( const char * szTime,
                                   int * piHour, int * piMinutes,
                                   int * piSeconds, int * piMSec,
                                   int * piUTCOffset );
         HB_BOOL hb_timeStampStrGetUTC( const char * szDateTime,
                                        int * piYear, int * piMonth,
                                        int * piDay, int * piHour,
                                        int * piMinutes, int * piSeconds,
                                        int * piMSec, int * piUTCOffset );
      They can decode timestamp value with ISO 8601 UTC offset.

  * src/common/hbdate.c
    * use hb_timeStampStrGetUTC() in hb_timeStampStrGetDT() and return UTC
      time if it was with UTC offset
      Now Harbour compiler accept timestamp strings with with UTC offset, i.e.
         ? t"2025-01-22 00:45 UTC+0100" // => 2025-01-21 23:45:00.000
      Also HB_StrToTS() supports it.

  * src/pp/hbpp.c
    * use new hb_timeStampStrGetDT() to decode timestamp from ChangeLog to
      build revision number. It also fixes bug with decoding negative UTC
      offsets.

2025-01-23 11:47 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbcurl/core.c
  * contrib/hbcurl/hbcurl.ch
  * contrib/hbcurl/hbcurl.hbx
    * applied more cleanups, following Viktor Szakats guidance in his repo:
      https://github.com/vszakats/hb/commit/61276032177e2f4e8cfac22080c1e0b14eb0d432
      - add `HB_CURLM_ERROR` to indicate error in hbcurl wrapper.
      - replace use of `HB_CURLM_INTERNAL_ERROR` with `HB_CURLM_ERROR`.
      - sync Harbour variable integer sizes with curl ones.
      - tidy up a variable scopes.
      - drop unused variable.
      - omit `hb_ret()` (it's a no-op).
      - formatting.
      - add functions to `hbcurl.hbx`.

    + add curl_ws_send()/curl_ws_recv() - WebSocket connectivity,
      borrowed from Viktor's fork, thanks again!
      https://github.com/vszakats/hb/commit/2c71a5c9402cdbb7a649598e5a5ed6f3217d94b4

  * src/rdd/dbcmd.c
    * note about C5.3 and Harbour extensions to
      DBAPPEND( [<lUnlockAll>=.t.] ), thanks Viktor

  * ChangeLog.txt
    ! typos

2025-01-22 21:08 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * utils/hbmk2/hbmk2.prg
    * do not interrupt whole build process when optional dependency package
      is disabled explicitly by -depcontrol=<optdeppkg>:no

  * contrib/gtqtc/gtqtc.hbc
  * contrib/gtqtc/gtqtc.hbp
    * respect QT_SELECT envvar looking for QT dependencies

2025-01-21 09:45 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/windows-ci.yml
    * install freeimage only in 64-bit environment,
      it's not available in the 32-bit one

  * contrib/3rd/sqlite3/sqlite3.hbp
    * use -Wno-unknown-warning-option to pacify problems with old
      clang versions which do not understand -Wno-stringop-overread

2025-01-21 09:08 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/linux-ci.yml
    * disabled global -Wno-error=... C compiler parameters
    * set HB_BUILD_TEST="${{matrix.strictness}}" envvar

  * .github/workflows/macos-ci.yml
  * .github/workflows/vm2-ci.yml
    * disabled global -Wno-error=... C compiler parameters
    * set HB_BUILD_TEST="${{matrix.strictness}}" envvar
    * reenabled hbfimage contrib library

  * .github/workflows/windows-ci.yml
    * reenabled hbfimage contrib library

2025-01-21 08:46 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/3rd/sqlite3/sqlite3.hbp
    * do not enable -Wno-error=stringop-overread C compiler flag in MS-Windows
      clang builds and HB_BUILD_TEST='strict' - this C clang version does not
      support it

2025-01-21 08:12 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/linux-ci.yml
    * reenabled hbfimage contrib library

  * src/vm/Makefile
  * src/vm/vmmt/Makefile
    * set -DHB_FM_STD_ALLOC C compiler parameter for HB_BUILD_TEST='strict'

2025-01-21 06:45 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * .github/workflows/windows-ci.yml
    * disabled global -Wno-error=... C compiler parameters
    * set HB_BUILD_TEST="${{matrix.strictness}}" envvar

  * contrib/3rd/sqlite3/sqlite3.hbp
    * set -Wno-error=stringop-overread C compiler parameter for GCC builds
      when HB_BUILD_TEST='strict'

  * contrib/hbzebra/hbzebra.hbp
    * set -Wno-error=array-bounds C compiler parameter for GCC builds
      when HB_BUILD_TEST='strict'

2025-01-21 01:11 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapigt.h
    ! removed dummy declaration for hb_inkeyExit()

  * include/hbexprop.h
    ! removed dummy declarations for hb_compExprNewCodeblockExpr(),
      hb_compExprNewAssign() and hb_compExprEqual()
    ; marked compiler only hb_compExpr*() functions

  * include/hbgtcore.h
    ! removed dummy declaration for hb_gt_gcMark()

  * include/hbxvm.h
    ! removed dummy declarations for hb_xvmPushBlockLarge() and
      hb_xvmMacroPushArg()

  * src/harbour.def
    + added hb_iswinbuild()
    + added exported PCRE variable pcre_stack_guard
    + added exported ZLIB functions: gzfread(), gzwrite(),
      adler32_z(), crc32_z(), crc32_combine_gen(),
      crc32_combine_gen64(), crc32_combine_op(),
      uncompress2(), deflateGetDictionary(),
      inflateValidate(), inflateCodesUsed()

2025-01-20 10:43 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapifs.h
    ! added missing declaration for hb_fileParamGet()

  * include/hbgtcore.h
    * added HB_EXPORT attribute for hb_gt_getClipboard(), hb_gt_setClipboard()
      and hb_gt_dos_keyCodeTranslate()

  * include/hbrdddbf.h
    ! removed declaration for hb_dbfTranslateRec() function - this functions
      was removed many years ago

  * include/harbour.hbx
  * src/harbour.def
    ! fixed order of declared functions - they should be sorted.

2025-01-20 01:00 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbcurl/hbcurl.hbx
    ! added missing new functions: curl_easy_er_buff_get() and curl_multi_*()

2025-01-19 19:38 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/hbssl.h
    * set OPENSSL_API_COMPAT to 10100 instead of 10100 to reduce conflicts
      with OPENSSL_CONFIGURED_API

2025-01-19 14:33 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rdd/dbfcdx/dbfcdx1.c
    % Removed always false dummy condition. For
         pPage->TagParent->MaxKeys >= 2 &&
         ( ( iKeys + pPage->TagParent->MaxKeys - 1 )
                   / pPage->TagParent->MaxKeys ) == 1
      the expression
         iKeys > ( ( pPage->TagParent->MaxKeys * 3 ) >> 1 )
      was alwas false.
      As side effect this modification pacifies the buggy GCC warnings.

2025-01-19 02:08 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/hbssl.h
  * contrib/hbssl/rsa.c
    * renamed hb_RSA_par_free() to hb_RSA_par_remove()

  * contrib/hbssl/evppkey.c
    * few code clenups

  * contrib/hbssl/x509.c
    ! use GC pointer items instead of raw ones

2025-01-18 09:33 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/evp.c
    * clear key and iv buffers before passing them to EVP_BytesToKey()
      otherwise some uninitialized bytes are accessed and valgrind reports
      uninitialized memory access

  * contrib/hbssl/evpciph.c
    ! fixed typo in index in my previous commit

  * contrib/hbssl/tests/digest.prg
    ! use OPENSSL_VERSION_NUMBER() instead OPENSSL_VERSION() to retrieve
      OpenSSL version number

  * contrib/hbssl/tests/inetssl.prg
    * updated to use 2048 RSA certificates instead of 1024 ones which are
      no more supported by modern OpenSSL libraries

  * contrib/hbssl/tests/pem.prg
    * cleaned output

2025-01-18 05:03 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rdd/dbfnsx/dbfnsx1.c
  * src/rtl/dates.c
  * src/rtl/hbtoken.c
    ! pacified few stupid warnings

2025-01-18 04:59 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/bio.c
    ! added missing BIO_free() call in HB_BIO destructor
    ! fixed BIO_free() function to properly operate on HB_BIO structure

  * contrib/hbssl/evp.c
    ! fixed EVP_PKEY_free() to work with Harbour GC pointer items instead of
      raw pointer items

  * contrib/hbssl/evpciph.c
    ! fixed EVP_SealInit() and EVP_OpenInit() to work with Harbour GC pointer
      items instead of raw pointer items

  * contrib/hbssl/hbssl.h
  * contrib/hbssl/rsa.c
  * contrib/hbssl/evppkey.c
    + added new C functions:
         void hb_RSA_par_free( int iParam );
         EVP_PKEY * hb_EVP_PKEY_get( PHB_ITEM pItem );
         void hb_EVP_PKEY_free( PHB_ITEM pItem );

  * contrib/hbssl/evppkey.c
    ! fixed EVP_PKEY_assign_RSA to work with RSA Harbour GC pointer
      item instead of raw pointer items

  * contrib/hbssl/pem.c
    ! redirect old dummy functions to current ones using Harbour GC pointer
      items:
         PEM_read_bio_PrivateKey() => PEM_read_PrivateKey()
         PEM_read_bio_PUBKEY()     => PEM_read_PUBKEY()
         PEM_read_bio_X509()       => PEM_read_X509()
         PEM_read_bio_X509_AUX()   => PEM_read_X509_AUX()
      Now they should work.

  ; above are only few fixes for chosen problems and still there are many
    others, most of HBSSL code should be rewritten from scratch to work
    with OpenSSL 3.x API

2025-01-16 01:00 UTC+0100 Fazio Diego (diegohfazio gmail.com)
  * contrib/hbcurl/hbcurl.ch
    + added HB_CURLOPT_ER_BUFF_SETUP
      curl_easy_setopt( curl, HB_CURLOPT_ER_BUFF_SETUP ) <- Initialize ERRORBUFFER
  * contrib/hbcurl/core.c
    + added PRG functions:
      read error from ERRORBUFFER
      see https://curl.se/libcurl/c/CURLOPT_ERRORBUFFER.html
      curl_easy_er_buff_get( curl ) -> cErrorBuffer

2025-01-10 10:15 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * src/rtl/listbox.prg
    * merged #372 from Kamil, thanks for the patch.
      Applied minor reformat .NOT. -> ! and added a comment
      about buggy ListBox:hitTest() on no-box dropdown in
      Cl*pper 5.3.

2025-01-09 12:00 UTC+0100 Kamil Przybylski (kprzybylski quay.pl)
  * src/rtl/listbox.prg
    ! fixed nTop not being incremented in ListBox:hitTest() for no-box dropdown
    * replaced inconsistent references to ::nTop with nTop
    * renamed variables to better reflect their role

2025-01-08 13:14 UTC+0100 Kamil Przybylski (kprzybylski quay.pl)
  * src/rtl/listbox.prg
    ! fixed nTop variable not being assigned properly in ListBox:hitTest()

2025-01-07 22:49 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbcurl/hbcurl.ch
    * updated HB_CURLOPT_SSL_OPTIONS: HB_CURLSSLOPT_*

    + added HB_CURLMSG_RESP_HANDLE, HB_CURLMSG_RESP_HPOS
      mappings of array elements returned by
      curl_multi_info_read( <hMulti>[, <aHandles> ]) -> <aResults>

  * contrib/hbcurl/core.c
    * adapted @emazv72 contribution from:
      https://github.com/vszakats/hb/pull/344
      Many thanks, it could be useful for managing multiple transfers,
      by extending some kind of Inkey() loop or in many other
      scenarios.

    + added curl lib version guards

    * minor code and comment formattings

    + extended function
      curl_multi_info_read( <hMulti>[, <aHandles> ]) -> <aResults>
      with a possibility to return real GC pointer of specific
      transfer related to reported event. <aHandles> should be
      specified if this is expected.

  + contrib/hbcurl/tests/multi.prg
    + demo of the additions

2025-01-07 21:43 UTC+0100 Emanuele Zavallone (emanuele.zavallone gmail.com)
  * contrib/hbcurl/easy.c
  * contrib/hbcurl/hbcurl.ch
    + added multi interface implementation

2025-01-07 12:24 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * src/common/hbver.c
    * indent cleanup

  * src/rtl/filesys.c
  * src/rtl/fssize.c
    ! restore dynamic calling of GetFileAttributesEx() on
      Windows (significant only on very old systems)

2025-01-02 14:33 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * config/global.mk
  * config/win/clang-noauto.mk
  * config/win/clang.mk
    * supplemented config for Windows clang cross compilers
      distributed in multilib fashion, like Martin Storsjo's:
      https://github.com/mstorsjo/llvm-mingw

    + HB_CCPREFIX= support for clang on Windows, you can build
      ARM64 Harbour from AMD64 hosts using mentioned toolchain:
      set PATH=C:\llvm-mingw\bin;%PATH%
      set HB_COMPILER=clang
      win-make (build for your host first)
      set HB_CCPREFIX=aarch64-w64-mingw32-
      set HB_HOST_BIN=<HarbourPath>\bin\win\clang\ (if not autodetected)
      win-make

    ; cross compiling from Unix hosts is not yet tested, but
      looks very close to be possible

    ! fixed typo's

  * utils/hbmk2/hbmk2.prg
    * changed llvm-ar call to also respect HB_CCPREFIX

2024-12-29 00:28 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * src/rtl/hbproces.c
    ! in process creating functions like hb_processRun(), *Open(),
      on Android: don't use setuid( getuid() ) method for resetting
      attributes as it rises "Bad system call" and the process is not
      executed. This fixes building Harbour in hbmk2 stage on Android
      device itself (for example using Termux) and can fix deploying
      multi-process Android apps. For devices older than Android 8,
      where the kernel was not hardened, please report any regresions,
      if you have such multi-process deployments.

  * ChangeLog.txt
    % stripped spaces before EOLs

2024-12-19 10:24 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/rddsql/sqlbase.c
    % cleanup unnecessary braces

  * ChangeLog.txt
    + missing entry from pull request #364

2024-12-18 21:48 UTC-0800 Eric Lendvai (harbour.wiki)
  * contrib/rddsql/sqlbase.c
  * contrib/rddsql/sqlmix.c
    + added support to timestamp field type.
      You can now use "@" in DbCreate as the timestamp field type.
      Thanks to Grigory Filatov for fixing crash!

2024-12-17 03:07 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc.hbc
    ! fixed dependency macros - hbmk2 defines HB_HAS_* only for optional packages

2024-12-17 01:09 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc.hbc
  * contrib/gtqtc/gtqtc.hbp
    ! fixed dependency macros

  * contrib/gtqtc/hbmk2_qtgt.hb
    * set QT_SELECT envvar for systems which supports different QT versions

  * utils/hbmk2/hbmk2.prg
    + added "dept" => hbmk[ _HBMK_hDEPTMACRO ] to hbmk hash table passed to
      hbmk2 plugins

2024-12-15 20:54 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc.h
  * contrib/gtqtc/gtqtc.hbc
  * contrib/gtqtc/gtqtc.hbp
  * contrib/gtqtc/gtqtc1.cpp
    * updated to compile with Qt6

2024-12-13 09:06 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/compiler/harbour.y
  * src/macro/macro.y
    * replaced depreciated bison macro %pure-parser with %define api.pure

  * src/compiler/complex.c
  * src/macro/macrolex.c
  * src/compiler/harbour.y
  * src/macro/macro.y
    * replaced depreciated bison macro %name-prefix with %define api.prefix

  ; Warning: now Bison 2.6 or newer is required to regenerate Harbour grammar
             files. If someone wants/needs to work with older bison versions
             then it's enough to restore depreciated macros, Harbour compiler
             and macros lexers will work with both versions.

  * src/compiler/harbour.yyc
  * src/compiler/harbour.yyh
  * src/macro/macro.yyc
  * src/macro/macro.yyh
    * regenerated with Bison 3.02 (the same as before)
    * re-added HB_SYMBOL_UNUSED( yynerrs ) to pacify some compilers warnings

2024-12-12 21:30 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/compiler/genc.c
    ! fixed detection of C function written in C inside
      #pragma BEGINDUMP / #pragma ENDDUMP

2024-12-12 21:18 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * ChangeLog.txt
  * contrib/gtqtc/gtqtc.h
  * contrib/gtqtc/gtqtc1.cpp
  * contrib/hbzebra/datamtrx.c
  * contrib/sddoci/core.c
  * src/compiler/genc.c
    ! reverted my unintentional commit from dummy branch

2024-12-11 19:35 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/xhb/hbcompat.ch
    ! fixed HSetAACompatibility() #xtranslate

  * contrib/hbzebra/code39.c
    * pacified warning, it's also fix for possible buffer overflow.

  * include/hbcomp.h
  * src/compiler/genc.c
  * src/compiler/hbmain.c
    * replaced function hb_compFunctionMarkStatic() with
      hb_compFunctionSetScope()

  * src/compiler/genc.c
    * detect public prg functions written in C inside
      #pragma BEGINDUMP / #pragma ENDDUMP and mark them as LOCAL ones

  * src/vm/hvm.c
    ! removed my pseudo fix from 2023-01-30 15:18 UTC+0100 Przemyslaw Czerpak.
      It was ugly hack which can work only with some linkers.
      This modification fixes FILE() function used with C functions written
      without own symbol table

  * src/rdd/dbf1.c
    * minor code formatting

2024-12-07 20:32 UTC-0300 Mario Wan Stadnik (wanstadnik gmail.com)
  * utils/hbmk2/hbmk2.prg
    * patch for MingW64 14.2.0 to find windres.exe automatically,
      otherwise it failed with the resource compiler not found
      error because it only looked for i686-w64-mingw32-windres.exe
      instead of windres.exe.

2024-12-04 15:25 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * src/common/hbver.c
    ! added lacking VER_BUILDNUMBER definition that is missing
      in very old compiler sets/SDKs (pre Windows 2000),
      noticed by DF7BE - Wilfried Brunken in #362

  * README.md
    * slightly updated list of supported compilers and
      examples to mention MSVC for ARM64 and Clang

  * ChangeLog.txt
    * hb_scan -> hb_hscan in prev

2024-12-03 01:27 UTC-0300 Lailton Fernando Mariano (lailton/at/paysoft.com.br)
  * src/vm/hashfunc.c
    ! fixed issue hb_hscan when we are looking for a logical value as true.
      Many thanks to Marcos Gambeta who found the problem.

2024-10-28 16:57 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * src/rdd/dbf1.c
    ! reading varchar binary field ("Q:B") from a .dbf
      could free a wrong pointer in the record buffer.
      Bug located and fixed by Marek.

2024-10-25 14:09 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbziparc/ziparc.prg
    ! return value of hb_zipDeleteFile() is not logical,
      fix by Grigory Filatov.

2024-10-18 07:56 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * src/common/hbver.c
    * guard Win10 build number getter from the unknown,
      using old Win32 API that is not going to be deprecated.

2024-10-17 15:04 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * .github/workflows/windows-ci.yml
    * update windows MSYS2 integration runner set of
      requested packages. PGSQL, Firebird and MariaDB libs
      are no longer available in the 32-bit environment

    + add clang x86_64 compiler for testing under this CI

  * include/harbour.hbx
  * include/hbapi.h
  * src/common/hbver.c
  * src/harbour.def
  * src/rtl/version.c
    ! fixed Windows 11 detection, by vendor likings it has
      NT Kernel Version stamped with 10.0, so now Build Number
      is more significant as a recognition factor.

    + new C helper functions hb_winisbuild(), hb_iswin11()

    + added PRG function hb_osIsWin11()

    * also try to detect new Windows Server versions

  * config/win/clang.mk
  * utils/hbmk2/hbmk2.prg
  * ChangeLog.txt
    ! recursion happening in the Makefiles rendered recently
      introduced compatibility option unreliable. Changed to
      use separate variable: HB_USER_FIXES=--mingw-script
      You don't need it, the problem shouldn't exist, but
      anyway...

2024-10-10 14:21 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  + config/win/clang-noauto.mk
    + additional clang flavour checking when the compiler is specified
      via set HB_COMPILER=clang (not auto-detected)

      This is important for distributions of clang that bundle both
      gcc and clang in the same directory. Harbour 3.2 by default
      prioritize gcc over clang.

      For example you should be now able to build from winlibs.com by
      Brecht Sanders with environment setup such as:
      PATH=C:\winlibs\mingw64\bin;%PATH%
      HB_COMPILER=clang
      win-make

  * config/global.mk
    ! added workaround for common GNU Make issue with
      $(dir path with spaces/file) macro, commonly striking on Windows
      systems under "Program Files", but also possible in other setups.
      Workaround is to call $(call dir_with_spaces,$(HB_COMP_PATH)).
      I have only used this workaround in clang detection, but keep
      this in mind while revisiting detection of another compiler.

  * config/win/clang.mk
  * utils/hbmk2/hbmk2.prg
    * another rework of Clang on Windows detection (ARM64, x86_64, x86),
      solved problems with different availability of resource compiler,
      They are now probed in order: windres, llvm-windres, llvm-rc.

    * added option to use MinGW INPUT(file.o) link scripts for old tools
      To apply workaround with clang, set HB_USER_FIXES=--mingw-script
      It is not supported in at least some of current clang toolchains,
      but it's still needed to succesfully build on old ones (those
      using GNU ld on Windows).

2024-10-07 11:40 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * config/global.mk
    ! detect ARM64 CPU on Windows also under non-native shell (MSYS2 sh)

    * on unix also recognize aarch64 from uname

  * include/hbsetup.h
    * __MINGW64__ define is not x86_64 specific anymore

  * config/win/clang.mk
  * utils/hbmk2/hbmk2.prg
    * reworked Clang on Windows detection (ARM64, x86_64, x86),
      now it recognizes those flavours in PATH as distributed
      by MSYS2 project and also Visual Studio 2022 Build tools.

      Starting Harbour build process should be now possible
      both from MSYS2 shell (with the special note to use "make"
      command instead of "win-make" from sh) and regular batch
      script/cmd shell.

      Building on Clang distributed by MS x86_64:
      PATH=<InstallPath>\BuildTools\VC\Tools\Llvm\x64\bin;%PATH%
      win-make

      Clang/MS ARM64:
      PATH=<InstallPath>\BuildTools\VC\Tools\Llvm\ARM64\bin;%PATH%
      win-make

      Building on Clang x86_64 distributed by MSYS2 from cmd:
      PATH=C:\msys64\clang64\bin;%PATH%
      win-make

      Clang/MSYS ARM64 called from cmd:
      PATH=C:\msys64\clangarm64\bin;%PATH%
      win-make

  * src/common/hbver.c
    * patched clang version string builder to skip duplicate version
      number in some builds

    * append processor architecture to clang compiler string
      on non-Intel systems

2024-09-14 21:26 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * tests/speedtst.prg
    ! fix recursion bug i've made

  * contrib/hbdoc/hbdoc.prg
  * contrib/hbformat/utils/hbformat.prg
  * contrib/hbnetio/utils/hbnetio/hbnetio.prg
  * package/harbour.mft
  * package/harbour.rc
  * src/compiler/hbusage.c
  * utils/hbi18n/hbi18n.prg
  * utils/hbtest/hbtest.prg
    * bumped copyright year to 2024

2024-09-14 18:36 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  + config/win/msvcarm.mk
  + config/win/msvcarm64.mk
  * config/global.mk
  * include/hbsetup.h
  * utils/hbmk2/hbmk2.prg
    + introduced support for Windows (10,11) ARM 64-bit platform
      native compilers using Visual Studio 2022 Build Tools

      before calling win-make, setup environment with:
      <InstallPath>\BuildTools\VC\Auxiliary\Build\vcvarsarm64.bat

      toolchain should be autodetected as following:
      ! HB_HOST_PLAT: win (arm64)  HB_SHELL: nt
      ! HB_PLATFORM: win (arm64) (auto-detected)
      ! HB_COMPILER: msvcarm64 (auto-detected: C:/Program[...]/ARM64/)

      to build final application with hbmk2 adding a valid Windows
      Platform SDK / CRT paths to INCLUDE= and/or LIB= variable
      is needed

    ; cross compilation from AMD64 hosts is possible:
      vcvars64.bat
      win-make (build Harbour for your host first)
      set HB_HOST_BIN=<HarbourPath>\bin\win\msvc64
      vcvarsamd64_arm64.bat
      win-make

    + also added support for Windows for ARM 32-bit

      before calling win-make, setup environment using:
      <InstallPath>\BuildTools\VC\Auxiliary\Build\vcvarsarm.bat
      or when cross compiling from ARM64 host:
      <InstallPath>\BuildTools\VC\Auxiliary\Build\vcvarsarm64_arm.bat

    ; please test Windows CE builds if you're using compiler newer
      than VC2003 for ARM for possible regressions

  * contrib/hbmlzo/3rd/minilzo/lzodefs.h
    ! recognize ARM64 architecture on Windows to fix build error

    ; consider updating to upstream minilzo 2.10, issue is fixed there

  * src/common/hbver.c
    * changed to add processor architecture for MSVC compiler string
      on non-Intel systems, as exposed by hb_compiler(), harbour /build,
      finalapp.exe //build

  * tests/speedtst.prg
    * workaround that processor architecture can now appear
      in hb_compiler(), so it's not printed by speed test twice

2024-08-17 17:37 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/xhb/xhberror.c
    % cleaned code] to overload ERRORNEW() with XHB_ERRORNEW()

  * src/rtl/fscopy.c
    % removed unnecessary code

  * src/rtl/vfile.c
    ! fixed typo in comment

  * src/vm/dynsym.c
    + allow to use symbol items as parameter in functions:
      hb_IsFunction(), __dynsGetIndex(), __dynsIsFun()

2024-07-22 13:37 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/xhb/xhberror.c
    ! fixed very bad bug introduced in this modification:
         2023-01-31 23:19 UTC+0100 Przemyslaw Czerpak
      It corrupted dynamic symbol table due to stupid mistake.
      I overloaded whole function symbol instead of its address only.
      Many thanks to Juan Gálvez who found the problem.

  * include/hbdefs.h
    ! fixed INT64_MIN definition

  * src/vm/dynsym.c
    * minor change in function order

  * src/vm/memvars.c
    + allow to use symbol items in the following functions:
      __mvScope(), __mvExist(), __mvGet(), __mvGetDef(), __mvPut()

2024-05-31 11:55 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * doc/en/rdddb.txt
    ! update DBAPPEND( [<lUnlockAll>=.t.] ) documentation regarding
      the default value and action of the parameter

2024-05-31 11:49 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/rddmisc/arrayrdd.prg
    ! group of fixes contributed in #355 by @VarenL:
      IndexOrd() didn't work, DbZap() didn't update indexes, problem
      with larger number of indexes, erroneous AR_GOBOTTOM function.

  + doc/en/rdddb.txt
    + readded a 2017 copy

  * contrib/hbamf/amfstdio.c
    * flow-control is now optional, but still enabled by default

    ! fix missing free when exiting the loop

  * contrib/hbpgsql/rddcopy.c
    ! fix c&p bug/typo in HB_PQCOPYFROMWA, corrected handling field list
      passed in <aFiledNames> parameter

      <lResult> := HB_PQCOPYFROMWA( <pConn>, <cTargetTable>, [<bWhileBlock>],
                                   [<bForBlock>], [<aFieldNames>], [<nCount>],
                                   [<lTrimStrings>], [<nPreBuffer>] )

2024-05-13 02:39 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * ChangeLog.txt
  * src/rtl/fscopy.c
    ! fixed typos, thanks to Grigory Filatov and Pete

  * include/harbour.hbx
  * src/harbour.def
    ! added hb_vfCopyFileEx() and hb_fileCopyEx()

2024-05-09 23:23 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapifs.h
  * src/rtl/fscopy.c
    + added new C function:
         HB_BOOL hb_fileCopyEx( const char * pszSource, const char * pszDest,
                                HB_SIZE nBufSize, HB_BOOL fTime,
                                PHB_ITEM pCallBack );
      Unlike hb_fileCopy() it is never redirected to remote server and copy
      operation is always done locally.
      pCallBack is codeblock or function symbol, it's executed at the
      beginning and then on each nBufSize bytes written and receives two
      parameters: nBytesWritten, nTotalSize.
      Warning: nTotalSize could be 0 when non regular files like pipes or
               sockets are copied.

  * src/rtl/vfile.c
    + added new PRG function:
         hb_vfCopyFileEx( <cFileSrc>, <cFileDst>, [<nBufSize>=65536], ;
                          [<lTimePreserve>=.t.], [<bCallBack>] ) --> <nResult>
      It's wrapper to hb_fileCopyEx() C function.
      For very big files setting <nBufSize> to greater value, i.e. 16777216
      may increase performance.

2024-04-10 15:39 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * utils/hbmk2/hbmk2.prg
    ! fixed my last modification and check if HB_WITH_* contains
      non empty value

2024-03-07 13:41 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc.hbp
    ! do not detect QT5 when HB_BUILD_3RDEXT=no is set

  * debian/rules
    * removed LD_LIBRARY_PATH setting

  * src/rdd/dbcmd.c
  * src/rdd/wacore.c
    ! moved code checking WA number from DbSelectArea() PRG function
      to hb_rddSelectWorkAreaNumber() C function. It fixes few things
      like:
         DbSelectArea( 0 )
      and also:
         ? ( 0 )->( select() )

2024-02-16 18:23 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbexpat/3rd/expat/expat.diff
  * contrib/hbexpat/3rd/expat/loadlibr.c
    ! use HB_WINAPI_GETPROCADDRESS() instead of GetProcAddress()
      in WinCE builds

  * contrib/hbhpdf/3rd/libhpdf/hpdfstre.c
  * contrib/hbhpdf/3rd/libhpdf/libhpdf.diff
    ! include <windows.h> in WinCE builds, it's necessary for GetLastError()

  * src/3rd/jpeg/Makefile
    ! do not use getenv() in all WinCE builds

  * src/common/hbver.c
    * cast revision number to HB_ULONG to pacify warning

  * src/vm/extrap.c
    ! do not compile unused in WinCE builds hb_winExceptionHandler()

  * include/hbapi.h
    * added HB_EXPORT attribute to hb_macroTextValue() function

  * include/hbvm.h
  * src/vm/hvm.c
    + added C function:
         PHB_ITEM hb_vmCompileMacro( const char * szExpr, PHB_ITEM pDest );
      It returns Harbour item or NULL at error (wrong macro text).
      The result should be used with hb_vmEvalBlockOrMacro() and then freed
      by hb_vmDestroyBlockOrMacro(). It hides low level macro representation
      so we can change it in the future. Now it's still simple pointer item
      without autodestructor.

  * src/rdd/hsx/hsx.c
  * src/rdd/workarea.c
    * use hb_vmCompileMacro() instead of hb_macroCompile()

  * src/vm/runner.c
    * changed 6101 error message for "Unknown or unregistered symbol"
      to "Unknown or unregistered function symbol".
    * report above error when HRB module is loaded and its external function
      is not registered or not marked as DYNAMIC by earlier registered modules
      in HVM symbol table.
      Warning. This modification may exploit problems in code loading HRB files
      with cross references which has worked so far. In such case user should
      pass to hb_hrbLoad()/hb_hrbRun() as first parameters flags containing
      HB_HRB_BIND_LAZY or declare the problematic function in his main code
      as dynamic, i.e.:
         DYNAMIC <funcName>

  * src/rdd/dbf1.c
    * declare internal function hb_dbfTransCheckCounters() as static one

  * src/harbour.def
    ! added missing exported Harbour functions

2024-02-13 05:49 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * debian/compat
    * set 10 as compatibility level

  * contrib/3rd/sqlite3/sqlite3.c
  * contrib/3rd/sqlite3/sqlite3.diff
    * do not use noinline function attribute in GCC prior 3.1

  * contrib/xhb/xhberror.c
  * src/rtl/gtdos/gtdos.c
    ! fixed format specifiers in HB_TRACE() messages

  * src/common/expropt1.c
  * src/rtl/langapi.c
    * pass explicitly "(null)" string instead of NULL string pointer
      to HB_TRACE() messages, some C compilers can autoinline functions
      and generate warning detecting such situation

  * src/pp/hbpp.c
    * cast revision number to ( HB_ULONG ) to avoid warnings in some
      compilers which do not understand %I64u format specifier

  * utils/hbmk2/hbmk2.prg
    * preffer HB_WITH_* settings then platform native pkg-config,
      giving pkg-config precedence breaks cross and custom builds

2024-02-10 11:27 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbcurl/core.c
    ! fixed bad copy & past typo

2024-02-09 20:56 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbcurl/core.c
  * contrib/hbcurl/hbcurl.ch
    + added HB_CURLOPT_XFERINFODATA and HB_CURLOPT_XFERINFOFUNCTION
    ! use CURLOPT_XFERINFO* instead of depreciated CURLOPT_PROGRESS*
      to implement HB_CURLOPT_PROGRESSBLOCK
    ! do not use depreciated CURLOPT_RANDOM_FILE and CURLOPT_EGDSOCKET,
      they serve no purpose anymore
    + added macros for new protocols
    + added HB_CURLOPT_PROTOCOLS_STR and HB_CURLOPT_REDIR_PROTOCOLS_STR
    ! use CURLOPT_PROTOCOLS_STR and CURLOPT_REDIR_PROTOCOLS_STR instead
      of depreciated CURLOPT_PROTOCOLS and CURLOPT_REDIR_PROTOCOLS
    * emulate CURLOPT_PROTOCOLS and CURLOPT_REDIR_PROTOCOLS using
      CURLOPT_PROTOCOLS_STR and CURLOPT_REDIR_PROTOCOLS_STR in new curl
      versions
    + added support for HB_CURLOPT_MIMEPOST
    ! use CURLOPT_MIMEPOST to emulate depreciated in new curl versions
      CURLOPT_HTTPPOST
    + added support for HB_CURLOPT_PROXY_SERVICE_NAME
    ! use CURLOPT_PROXY_SERVICE_NAME to emulate depreciated in new curl
      versions CURLOPT_SOCKS5_GSSAPI_SERVICE
    + added HB_CURLINFO_ACTIVESOCKET
    ! use CURLINFO_ACTIVESOCKET instead of depreciated CURLINFO_LASTSOCKET
    + added HB_CURLINFO_SIZE_UPLOAD_T, HB_CURLINFO_SIZE_DOWNLOAD_T,
      HB_CURLINFO_SPEED_DOWNLOAD_T, HB_CURLINFO_SPEED_UPLOAD_T,
      HB_CURLINFO_CONTENT_LENGTH_DOWNLOAD_T and
      HB_CURLINFO_CONTENT_LENGTH_UPLOAD_T
    ! use CURLINFO_*_T actions instead of depreciated ones which operate
      double as file offset and emulate old actions using new ones in
      new curl versions

  * contrib/hbssl/evp.c
    ! Do no use EVP_cleanup() in OpenSSL 1.1.0 and newer.
      It no longer has any effect.

  * contrib/hbssl/hbssl.h
    * set OPENSSL_API_COMPAT to 1.2.0 to pacify OpenSSL 3.0 API.
      It hides OpenSSL 3.0 warnings but we should update the code to use
      new suggested API.

  * contrib/hbwin/olecore.c
    ! invoke assign methods with DISPATCH_PROPERTYPUTREF instead of
      DISPATCH_PROPERTYPUT if assigned value is OLE object. If such
      functionality is not implemented by the object (some OLE
      implementations do not support it and returns DISP_E_MEMBERNOTFOUND)
      then call it again but in previous form with DISPATCH_PROPERTYPUT

  * include/hbapirdd.h
  * src/rdd/dbcmd.c
    ! fixed error codes set by DbSetRelations() to be Cl*pper compatible

  * src/rdd/dbcmd.c
    + accept symbol items in Select() and DbSelectArea() just like in
      ( <alias> ) -> <exp>

  * include/hbcompdf.h
  * include/hbexprb.c
  * src/common/funcid.c
    + added compile time optimization for Select() function without parameters
    + added compile time optimization DbSelectArea( <nNum> | <sSym> )
    + added support for hb_PIsByRef( @localVarName ) -> <lPassedByRef>
      When the parameter is passed by reference Harbour verifies if it's
      existing local variable and change it to its index in parameter list
      so effectively it works like hb_IsByRef( @localVarName ) in xHarbour

  * contrib/xhb/hbcompat.ch
    + added translations for
      hb_PIsByRef( @<localVar> ) <=> hb_IsByRef( @<localVar> )

2024-01-29 17:13 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/harbour.def
    + added hb_socketNToHS() to exported functions

  * src/rtl/hbsocket.c
    + added hb_socketNToHS() for compilation without socket support
      (HB_SOCKET_OFF macro)

2024-01-28 12:58 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbfimage/core.c
    * use FreeImage_Rotate() instead of FreeImage_RotateClassic() in new
      FreeImage versions which do not support this function

  * contrib/hbsqlit3/core.c
    * added missing casting reported as bug in C++ mode

  * contrib/hbssl/hbssl.h
  * contrib/hbssl/rsa.c
    * added HB_SSL_CONST_BYTE() macro to pacify unconst warnings
      in old SSL versions

  * src/rdd/wacore.c
    * inlined macro to pacify still returning false warning

2023-12-08 23:17 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * contrib/sddsqlt3/core.c
    ! Fixed a different signedness compare warning.

2023-12-07 21:25 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * contrib/3rd/sqlite3/*
    * Updated local sqlite3 from 3.8.2 to 3.44.2.
    ! Updated diff to make Borland compile sqlite3.

2023-12-07 21:24 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * contrib/hbsqlit3/hbsqlit3.ch
    * Updated SQLite constants to version 3.44.2.
    % Reordered hbsqlit3.ch to simplify diffing from sqlite.h.
  * contrib/hbsqlit3/core.c
    + SQLITE3_CREATE_FUNCTION(): Added support for function flags.

2023-12-07 21:23 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * contrib/hbsqlit3/core.c
  * contrib/hbsqlit3/hbsqlit3.ch
    % Minor updates to hbsqlit3, borrowed from @vszakats's fork.
  ; parts of original commits:
  ; * https://github.com/vszakats/hb/commit/ca9f75850cf65ffc93b483d1a6b355fd1be2d203
  ;   2015-05-13 21:07 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
  ; * https://github.com/vszakats/hb/commit/949e77ae6975795ec4c11ced0d223207c12e20f9
  ;   2015-07-15 20:26 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
  ; * https://github.com/vszakats/hb/commit/dae1a8698520029b4053bbc7f8eeb01f619164c4
  ;   2017-08-14 18:59 UTC Viktor Szakats (vszakats users.noreply.github.com)

2023-12-07 21:21 UTC+0100 Phil Krylov (phil a t krylov.eu)
  ; merged:
  2015-04-09 11:34 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    * contrib/hbsqlit3/core.c
    * contrib/hbsqlit3/hbsqlit3.hbx
      + add sqlite3_status64()
      % adjust variable scopes
      ! fix to reset reference parameters in functions with
        functionality disabled
    ; origin: https://github.com/vszakats/hb/commit/5bcaa24c93bccdbdfe9ea52f3cbf4ebb8837dd5f

  2015-09-02 19:11 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    * contrib/hbsqlit3/core.c
      % use hb_fileLoad()
    ; Commit split from:
    ; origin: https://github.com/vszakats/hb/commit/8f534aaa77ff07ad86db5ad079d376d515561c5a

  2017-08-01 20:23 UTC Viktor Szakats (vszakats users.noreply.github.com)
    * contrib/hbsqlit3/core.c
    * contrib/sddsqlt3/core.c
      * use new sqlite3_prepare_v3() when built against
        sqlite 3.20.0 or upper.
    * contrib/hbsqlit3/core.c
      + SQLITE3_PREPARE() add 3rd parameter <nPrepFlags>
        Usable if build against sqlite 3.20.0 or upper, ignored otherwise
    * contrib/hbsqlit3/hbsqlit3.ch
      + add SQLITE3_PREPARE_PERSISTENT constant
    ; origin: https://github.com/vszakats/hb/commit/b33de96c81ac790f390e506160a4d1d8c2b5f4fe

2023-12-07 21:00 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * config/win/bcc.mk
  * utils/hbmk2/hbmk2.prg
    ! Fixed Borland C 32-bit compiler warning flags.

2023-12-07 20:00 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * .github/workflows/linux-ci.yml
    ! Linux CI build fix (outdated packages).
  * .github/workflows/vm1-ci.yml
  + .github/workflows/vm2-ci.yml
    + Added an OmniOS CI build.
    ! Switched FreeBSD CI build to vmactions/freebsd@v1 action as it's
      more stable.

2023-12-01 11:00 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * src/rtl/fserr.c
    * Mapped ERROR_INVALID_NAME on Windows to DOS error 2.
      Makes hbtest pass on Windows.

2023-11-30 22:36 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * src/3rd/Makefile
  - src/3rd/tiff/
  * package/harbour.spec
  * README.md
    - Removed third-party TIFF library. It's not clear why it was even
      included, it's not C90 compatible anymore, and a major pain to maintain.

2023-11-30 18:12 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * contrib/hbsqlit3/core.c
  * contrib/hbsqlit3/hbsqlit3.ch
  * contrib/hbsqlit3/hbsqlit3.hbx
    * Implemented SQLITE3_DB_FILENAME() on SQLite 3.7.10+.
    * Implemented SQLITE3_EXPANDED_SQL(), SQLITE3_TRACE_V2() on SQLite 3.14.0+.
    ; Thanks to Mindaugas Kavaliauskas for thorough reviewing!
  * contrib/hbsqlit3/tests/backup.prg
  * contrib/hbsqlit3/tests/demo.prg
    * Updated examples to use SQLITE3_TRACE_V2() on SQLite 3.14.0+.

2023-11-22 09:06 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/hbssl.hbm
  * contrib/hbssl/hbssl.hbx
  * contrib/hbssl/hbssl.h
  + contrib/hbssl/rsa.c
    + added PRG functions for RSA encryption/decryption:
         RSA_size( <pKey> ) -> <nCipherBlockSize>
         RSA_public_encrypt( <pKey>, <cData>, @<cDataEnc> ;
                              [, <nPadding> = HB_RSA_PKCS1_PADDING ] ) ;
                  -> <nSize> > 0 | <nError> <= 0
         RSA_private_decrypt( <pKey>, <cDataEnc>, @<cDataDec> ;
                              [, <nPadding> = HB_RSA_PKCS1_PADDING ] ) ;
                  -> <nSize> > 0 | <nError> <= 0
         RSA_private_encrypt( <pKey>, <cData>, @<cDataEnc> ;
                              [, <nPadding> = HB_RSA_PKCS1_PADDING ] ) ;
                  -> <nSize> > 0 | <nError> <= 0
         RSA_public_decrypt( <pKey>, <cDataEnc>, @<cDataDec> ;
                              [, <nPadding> = HB_RSA_PKCS1_PADDING ] ) ;
                  -> <nSize> > 0 | <nError> <= 0
    + added C functions for manipulating RSA keys inside HB_ITEMs:
         HB_BOOL hb_RSA_is( int iParam );
         RSA *   hb_RSA_par( int iParam );
         void    hb_RSA_ret( RSA * rsa );

  * contrib/hbssl/pem.c
    + added support for RSA keys.
      Now the following PRG functions return RSA key which can be passed to
      RSA_* functions:
         PEM_READ_BIO_RSAPRIVATEKEY()
         PEM_READ_BIO_RSAPUBLICKEY()
         PEM_READ_BIO_RSA_PUBKEY()

  * contrib/hbssl/evppkey.c
    + added functions for EVP_PKEY encryption/decryption:
         EVP_PKEY_base_id( <pKey> ) -> <nType>
         EVP_PKEY_CTX_new( <pKey> ) -> <pKeyCTX>
         EVP_PKEY_encrypt_init( <pKeyCTX> ) -> <nResult> (1 - OK, <=0 - Error)
         EVP_PKEY_encrypt( <pKeyCTX>, @<cDataEnc>, <cData> ) ;
                  -> <nSize> > 0 | <nError> <= 0
         EVP_PKEY_decrypt_init( <pKeyCTX> ) -> <nResult> (1 - OK, <=0 - Error)
         EVP_PKEY_decrypt( <pKeyCTX>, @<cDataDec>, <cDataEnc> ) ;
                  -> <nSize> > 0 | <nError> <= 0
      Above functions can be used with keys loaded by:
         PEM_READ_PRIVATEKEY()
         PEM_READ_PUBKEY()
      In OpenSSL 3.0 typed functions like *RSA*, *DSA*, *DH*, ... are
      depreciated and common for different methods EVP ones should be
      used instead.
    + added support for RSA encryption/decryption in above functions in
      OpenSSL libraries prior 1.0.0 which do not have EVP_PKEY_CTX. RSA
      support is emulated by direct calls to RSA_* functions so now for
      RSA it's possible to use new functions with old OpenSSL libraries.

  * contrib/hbssl/hbssl.ch
    + added constants for RSA padding: HB_RSA_*_PADDING
    + added constants for EVP PKEY types: HB_EVP_PKEY_*

  * contrib/hbssl/hbssl.hbx
    + added new functions

2023-11-15 15:57 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * contrib/hbsqlit3/tests/backup.prg
    + Simple change in test to provoke access to dangling pointer saved
      by SQLITE3_TRACE().
  * contrib/hbsqlit3/core.c
    ! Fixed dangling pointer access with SQLITE3_TRACE(), SQLITE3_PROFILE().

2023-11-14 22:27 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * .github/workflows/linux-ci.yml
    * On Linux CI workflow, run tests with Valgrind.
    + Added contrib/hbsqlit3/tests/backup.prg as a test.

2023-11-13 23:58 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbct/ctwin.c
    ! typo in comment

  * include/hbexprb.c
  * include/hbexprop.h
  * src/common/expropt2.c
  * src/harbour.def
    * moved code for reducing NOT expression to new separate function
      hb_compExprReduceNot()
    ; added comments to mark places for possible compiletime warnings when
      incompatible types are used inside in logical expressions
      (.AND. / .OR. / .NOT.)

2023-11-12 16:40 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * .github/workflows/linux-ci.yml
  * .github/workflows/macos-ci.yml
  * .github/workflows/vm1-ci.yml
  * .github/workflows/windows-ci.yml
    * Enforce local SQLite3 usage in CI builds.

2023-11-12 14:38 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * .github/workflows/linux-ci.yml
  * .github/workflows/macos-ci.yml
  * .github/workflows/vm1-ci.yml
  * .github/workflows/windows-ci.yml
    * Made strict CI build not that strict by adding
      -Wno-error=deprecated-declarations.
    ! Fixed ccache configuration under msys2.

2023-11-11 21:41 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * contrib/hbwin/win_bmp.c
    ! Fixed dangling pointer access (introduced in commit 64dba82) in
      WIN_DRAWBITMAP().

2023-11-11 21:08 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * .github/workflows/linux-ci.yml
  * .github/workflows/macos-ci.yml
  * .github/workflows/vm1-ci.yml
  * .github/workflows/windows-ci.yml
    * Use `-Wno-error=array-bounds` in GCC strict mode CI builds as the array
      bounds checker is buggy in GCC 12-13.

2023-11-11 20:05 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * contrib/gtwvg/gtwvg.h
  * contrib/gtwvg/wvgcore.c
  * contrib/gtwvg/wvgutils.c
  * contrib/gtwvg/wvgwing.c
  * contrib/hbwin/wapi_winuser_dlg.c
    ! Minor 64-bit Win32 API fixes.

2023-11-11 19:42 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * config/win/mingw.mk
  * utils/hbmk2/hbmk2.prg
    ! Use -D__USE_MINGW_ANSI_STDIO=0 to opt out of C99 printf emulation on
      MinGW-W64 10.0+.

2023-11-11 18:38 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * include/hbwinuni.h
  * src/vm/maindllp/dllpcode.c
    * In `HB_WINAPI_GETPROCADDRESS[T]`, cast the return value to `void *`
      to pacify further cast warnings, as the exact function signature is almost
      never a `FARPROC` anyway.
  * src/compiler/harbour.yyc
  * src/macro/macro.yyc
    * Added `HB_SYMBOL_UNUSED( yynerrs )` to pacify compiler warnings.
  * src/rtl/replic.c
    * Added a cast to a comparison to pacify compiler warning.
  * src/vm/classes.c
    ! Fixed outdated format specifier in a trace message.

2023-11-11 18:25 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * .github/workflows/vm1-ci.yml
    ! Fixed ccache and sysctl path in BSD CI builds.

2023-11-11 17:07 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * src/3rd/pcre
    ! Updated pcre to 8.45.
  * src/3rd/tiff
    ! Updated tiff to 4.6.0. Removed C99-isms.
  * src/3rd/jpeg
    ! Updated jpeg to 9e.
  * src/3rd/png
    ! Updated libpng to 1.6.40
  * src/3rd/zlib
    ! Updated zlib to 1.3.

2023-11-11 16:48 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * config/win/mingw.mk
    + Added support for HB_CCACHE in MinGW builds.

2023-11-11 16:37 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * config/win/bcc.mk
    ! Fixed quoting when building under POSIX shell.

2023-11-11 16:00 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * .github/workflows/linux-ci.yml
  * .github/workflows/macos-ci.yml
  + .github/workflows/vm1-ci.yml
  * .github/workflows/windows-ci.yml
    + Added bcc (32-bit) Windows CI build.
    + Added FreeBSD, NetBSD, and OpenBSD CI builds.
    * Cosmetic changes to keep different workflows easily diffable.

2023-11-11 13:59 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc.h
    ! synced declaration of QTConsole::repaintChars() with its implementation

2023-11-11 13:43 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc.h
    * use QT_VERSION >= 0x050000 instead of QT_VERSION <= 0x040900
    * indenting

2023-11-11 13:33 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/common/hbdate.c
    * accept timestamp values with trailing "Z" indicating UTC time
      (zero hour offset)

2023-11-09 15:07 UTC+0100 Phil Krylov (phil a t krylov.eu)
  * .github/workflows/linux-ci.yml
  * .github/workflows/macos-ci.yml
  * .github/workflows/windows-ci.yml
    + Added GitHub Actions CI workflows.

2023-10-29 14:27 UTC+0100 Enrico Maria Giordano (e.m.giordano@emagsoftware.it)
  * contrib/hbssl/hbssl.hbp
    ! added support for Openssl 3

2023-07-07 00:07 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/vm/classes.c
    ! fixed GPF when object item variable is passed by reference but the object
      is neither instance of standard class nor scalar class

2023-05-19 16:29 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbclass.ch
    ! fixed declaration stripping when HB_CLS_NO_DECLARATIONS is defined

  * src/compiler/hbmain.c
    ! do not generate warnings for undeclared methods when -w[12] is used.
      They should be emitted only for -w3 or higher (if any in the future).
      Thanks to Toninho for the information about the problem.

2023-05-12 18:13 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/compiler/hbmain.c
    ! fixed GPFs in dummy and never finished code for strong typing and message
      call validation.

2023-04-21 13:01 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/tbrowse.prg
    ! disabled HB_CLS_NOTOBJECT in TBrowse class definition

2023-04-21 11:45 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/harbour.hbx
  * src/harbour.def
  * src/rtl/vfile.c
    + added new PRG function:
         hb_vfIsLocal( <cFileName> ) --> <lLocalFileSystem>
      It returns TRUE if <cFileName> is not redirected to any Harbour File IO
      driver but access local file system API.

  * contrib/xhb/traceprg.prg
    * merged with Victor's branch so now Harbour File IO API is used to
      access log file.
    * convert relative log file name to absolute file path name
    % write whole log entry in single IO operation.

2023-04-20 23:35 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/xhb/hbcompat.ch
    ! fixed translations of xHarbour operators inside brackets,
      thanks to Ron.

  * contrib/xhb/xhb.hbx
  * contrib/xhb/xcstr.prg
    + added support for timestamp translations
    ! fixed few wrong translations
    ! fixed serialization of hash items with cyclic references
      in ValToPrg()
    % optimized cyclic references detection in ValToPrg()
    ! generate dummy code which cannot be compiled for codeblocks serialized
      by ValToPrg()

  * contrib/xhb/xhb.ch
    + added SET TRACE ... command, thanks to Ron.

  * contrib/xhb/xhberror.c
    * do not show __ERRRT_BASE() and __ERRRT_SBASE() in error call stack.

  * src/vm/classes.c
    ! added protection against possible GPF when manually created serialized object
      data with super class symbols longer then HB_SYMBOL_NAME_LEN is deserialized

2023-04-20 15:12 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc1.cpp
    % minor optimization in HB_GTI_PALETTE

  * src/rtl/checkbox.prg
  * src/rtl/listbox.prg
  * src/rtl/pushbtn.prg
  * src/rtl/radiobtn.prg
  * src/rtl/radiogrp.prg
  * src/rtl/scrollbr.prg
  * src/rtl/tbcolumn.prg
  * src/rtl/tbrowse.prg
  * src/rtl/teditor.prg
  * src/rtl/tget.prg
  * src/rtl/tgetlist.prg
  * src/rtl/tlabel.prg
  * src/rtl/tmenuitm.prg
  * src/rtl/tmenusys.prg
  * src/rtl/tpopup.prg
  * src/rtl/treport.prg
  * src/rtl/tsymbol.prg
  * src/rtl/ttextlin.prg
  * src/rtl/ttopbar.prg
    ! use :Init() method instead of :New() to initialize object instance
      variables. In Class(y) :New() is class message not object one.

2023-03-09 15:50 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbvm.h
  * src/harbour.def
    * added HB_EXPORT to functions dedicated to overload dynamic symbols

  * src/rdd/hbsix/sxord.c
    ! use hb_itemRelease() instead of unnecessary hb_itemReturnRelease()

2023-02-03 02:46 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/vm/arrays.c
    ! fixed buffer allocation in AClone()/hb_HClone() with possible cyclic
      references.
      I created the problem on 2023-01-30 15:18 UTC+0100 and it was reported
      as internal error 9024: hb_xrealloc requested to resize to zero bytes


2023-02-01 13:49 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/xhb/xhb.hbx
    * added reference to SetErrorMode()

2023-02-01 13:43 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/xhb/xhberrc.c
    + implemented Harbour version of SetUnhandledExceptionFilter() and
      SetErrorMode()

  * src/rtl/diskspac.c
    % use GetDiskFreeSpaceEx() directly on Win64 instead of accessing it
      by GetProcAddress()

  * ChangeLog.txt
    ! typo in file name in previous commit

2023-01-31 23:19 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  + contrib/xhb/xhberror.c
    ! added file missing in previous commit:
      added code which extends Harbour error objects adding functionality
      known from xHarbour:
         oError:ProcName
         oError:ProcLine
         oError:ProcModule
      Above instance variables are initialized automatically when error
      object is created.
      To enable this functionality it's enough to add to PRG code:
         REQUEST xhb_ErrorNew

2023-01-31 14:59 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapierr.h
  * src/harbour.def
  * src/rtl/errapi.c
    + added new C function:
         void hb_errReinit( PHB_ITEM pError );
      it allows to replace default error object with user custom one which
      support :Init() method

  * contrib/xhb/xhb.hbp
  + contrib/xhb/xhb.h
  + contrib/xhb/xhberror.c
    + added code which extends Harbour error objects adding functionality
      known from xHarbour:
         oError:ProcName
         oError:ProcLine
         oError:ProcModule
      Above instance variables are initialized automatically when error
      object is created.
      To enable this functionality it's enough to add to PRG code:
         REQUEST xhb_ErrorNew

  * contrib/xhb/xhberr.prg
    * use error object :Proc*() methods if they are available
    - removed PRG version of xhb_ErrorNew()

  * contrib/xhb/xhbmemo.prg
  * contrib/xhb/xhbtedit.prg
    ! use xhb_ErrorNew() instead of ErrorNew() which does not support
      any parameters

  * include/hbapicls.h
    ; typo in comment

2023-01-31 07:17 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/vm/fm.c
  * src/vm/garbage.c
    ! pacified warnings

2023-01-30 15:18 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/arc4.c
    ! include hbarc4.h instead of arc4.h which does not contain
      required for dynamic libraries export attributes in function
      declaration

  * src/vm/classes.c
    ! cleaned module symbol range checking

  * src/vm/arrays.c
    % optimized AClone() and hb_HClone()

  * src/vm/hvmall.c
    % changed the order of included files to keep alive function macros
      undefined in garbage.c and fm.c

  * src/vm/hvm.c
    ! fixed hb_vmGetRealFuncSym() to work with PRG functions written in C
      and registered in HVM without their own symbol table

  * src/vm/dynsym.c
    ; comment updated

2023-01-23 12:46 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/harbour.hbx
    ! added missing hb_socketSetNoSigPipe()

  * src/rdd/dbfcdx/dbfcdx1.c
    * redirect all debug output to stderr
    * reenabled light debug code for early detection of index corruption

2023-01-23 12:28 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc.h
  * contrib/gtqtc/gtqtc1.cpp
    * replaced depreciated in 5.15 methods for mouse wheel events processing
      by modern ones
    * replaced depreciated in 5.15 methods for accessing screen geometry by
      modern ones

  * contrib/gtqtc/gtqtc1.cpp
    + added support for TAB key processing when other widgets are shown and
      TAB is use to switch focus

  * src/rtl/alert.prg
  * src/rtl/hbgtcore.c
    + added support for hb_Alert() parameters passed in hash array, i.e.
         hb_Alert( { "TXT" => <cMessage>, ;
                     "BTN" => <aButtons>, ;
                   [ "TIM" => <nTimeOut> ] } ) => <nButton>

  * contrib/gtqtc/gtqtc.h
  * contrib/gtqtc/gtqtc1.cpp
  * include/hbgtinfo.ch
    + added new hb_gtInfo() action: HB_GTI_MSGBOX
      It opens QMessageBox with given by user text and buttons, i.e.
         hb_gtInfo( HB_GTI_MSGBOX, <cMessage>, <aButtons> ) => <nButton>
      or:
         hb_gtInfo( HB_GTI_MSGBOX, ;
                    { "TXT" => <cMessage>, ;
                      "BTN" => <aButtons>, ;
                    [ "TIM" => <nTimeOut>, ] ;
                    [ "TIT" => <cTitle>, ] ;
                    [ "INF" => <cInfoText>, ] ;
                    [ "DTL" => <cDetailedText> ] } ) => <nButton>
    + added support for redirecting Alert() and hb_Alert() calls to QT GUI
      QMessageBox(). This functionality can be enabled by:
         hb_gtInfo( HB_GTI_MSGBOX, .t. )
      and then
         Alert( <cMessage>, <aButtons> )
      is redirected to QT GUI QMessageBox().

  * include/hbgtinfo.ch
  * contrib/gtqtc/gtqtc.h
  * contrib/gtqtc/gtqtc.hbc
  * contrib/gtqtc/gtqtc.hbp
  * contrib/gtqtc/gtqtc1.cpp
    + added new hb_gtInfo() action: HB_QT_SOUND
      It allows to play sound using the low level GUI library, i.e.
         hb_gtInfo( HB_QT_SOUND, <cSoundFile> )
      This modification needs additional QT5 library Qt5Multimedia so I decided
      to enable it conditionally by HB_QT_SOUND=yes environment variable.

2023-01-17 13:10 UTC-0300 Lailton Fernando Mariano (lailton/at/paysoft.com.br)
  * include/hbsocket.h
  * src/harbour.def
  * src/rtl/hbsocket.c
  * src/rtl/hbsockhb.c
    + added functions: Harbour socket API
      HB_SOCKETSETNOSIGPIPE( hSocket, lValue ) --> lSuccess

2023-01-17 13:00 UTC-0300 Lailton Fernando Mariano (lailton/at/paysoft.com.br)
  * contrib/hbcurl/hbcurl.hbm
  * contrib/hbssl/hbssl.hbm
    * updated system include path for new Linux distributions

2023-01-17 12:54 UTC-0300 Lailton Fernando Mariano (lailton/at/paysoft.com.br)
  * src/rdd/dbfcdx/dbfcdx1.c
    ! disabled debug code HB_CDX_DBGCODE

2023-01-16 14:35 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/wapi_shellapi.c
    ! replaced struct = { 0 } with memset( &struct, 0, sizeof( struct ) )
      Such BCC syntax does not clear the whole structure body in most of
      other C compilers.

  * src/pp/hbpp.c
    ! fixed compilation for compilers using "i64" to format long long numbers,
      thanks to Toninho for the information.

2023-01-15 11:17 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/win_prn1.c
    ! fixed parameter type in font enum callback

  * include/harbour.hbx
  * src/harbour.def
  * src/rtl/hbgtcore.c
    + added two new PRG functions:
         hb_gtExists( <cGtName> ) -> <lExists>
         hb_gtList() -> <aGtNames>

  * src/rtl/hbgtcore.c
    * changed the order of defualt GT initialization. Now GT specified by -gt*
      hbmk2 option has higher priority then GT chosen by
         request HB_GT_<name>_DEFAULT

  * include/hbapi.h
  * src/vm/set.c
    + added two C functions for OS codepage translations:
         char * hb_osStrEncode2( const char * pszName,
                                 char * pszBuffer, HB_SIZE nSize );
         HB_WCHAR * hb_osStrU16Encode2( const char * pszName,
                                        HB_WCHAR * pszBufferW, HB_SIZE nSize );

  * include/hbwinuni.h
    + added HB_CHARDUP2() macro for UNICODE/ANSI OS codepage translation

  * src/common/hbgete.c
    ! fixed memory allocation in MS-Windows version of hb_getenv_buffer()

  * src/pp/hbpp.c
    ! added integer range to HB_VER_REVID definition to pacify warning

  * src/rtl/cdpapi.c
    * minor simplification

2022-11-25 18:14 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapi.h
  * src/vm/cmdarg.c
    ! changed returned type in hb_verSvnID() form int to HB_MAXINT

  * src/nortl/nortl.c
    ! fixed void* pointer incrementation
    ! pacified warnings

  * src/rdd/dbcmd.c
    * accept NIL value in hb_FieldPut() according to Aleksander recommendation

2022-11-11 21:15 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbcurl/core.c
    ! use hb_vmPushString() instead of hb_vmPushStringPcode()
      hb_vmPushStringPcode() is only for static buffer which cannot be freed.
      Variables passed to PRG debug functions can be stored by PRG code in
      other variables which lives longer then passed buffer and later cause
      GPF when curls structure is freed.
    ! indenting

2022-11-11 20:47 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapi.h
  * src/common/hbver.c
  * src/main/harbour.c
  * src/pp/hbpp.c
  * src/rtl/version.c
  * src/vm/cmdarg.c
    ! fixed integer overflow in revision number calculated from
      the last ChangeLog entry date

2022-11-07 09:24 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbcurl/core.c
    ! CURLOPT_MAXLIFETIME_CONN is available in curl 7.80.0,
      fix older builds by adding a version check

  * ChangeLog.txt
    * entry for previous merge was "old" (i wouldn't touch
      it alone), but it also had paths with backslashes
      in place of slashes

2022-11-04 20:15 UTC+0100 Antonino Perricone
  * contrib/hbcurl/hbcurl.ch
  * contrib/hbcurl/core.c
    + added HB_CURLOPT_MAXLIFETIME_CONN to setup max lifetime of connection
      see https://curl.se/libcurl/c/CURLOPT_MAXLIFETIME_CONN.html for more
      information.
    + added HB_CURLOPT_DEBUGBLOCK to setup a block for debug information
      It takes a callback in the form of {|type, msg| ... }
      see https://curl.se/libcurl/c/CURLOPT_DEBUGFUNCTION.html for more
      information.
  * contrib/hbcurl/hbcurl.ch
    + added HB_CURLINFOTYPE_* macros for debug block

2022-10-23 11:30 UTC-0300 Lailton Fernando Mariano (lailton/at/harbour.page)
  * config/global.mk
    + add auto detect cpu arm64
  * config/darwin/global.mk
  * utils/hbmk2
    ! fix build dylibs with VM builtin to Darwin ( Mac OS )

2022-10-17 20:28 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * ChangeLog.txt
    * fixed log entry order

2022-10-17 20:13 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbcurl/hbcurl.hbm
    * updated system include path for new Linux distributions

2022-10-17 20:11 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/harbour.hbx
  * src/harbour.def
  * src/rdd/dbcmd.c
    + added two new functions:
         hb_FieldGet( <cFieldName> | <nFieldPos> )
               -> <xFieldValue> | NIL
         hb_FieldPut( <cFieldName> | <nFieldPos>, <xFieldValue> )
               -> <xFieldValue> | NIL
      They works like FieldGet() and FieldPut() but allows to use field
      name instead of field index.

2022-10-17 19:58 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rdd/workarea.c
    * pacified warning

2022-10-17 19:57 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbvm.h
  * include/harbour.hbx
  * src/harbour.def
  * src/vm/hvm.c
    + added new C function:
         extern HB_EXPORT HB_BOOL hb_vmSetKeyPool( HB_BOOL fEnable );
      It allows to disable keyboard pooling by GT driver in main HVM loop.
      It's important in programs which mix GT terminal with GUI library
      which use common event loop. Many GUI objects are not reentrant
      safe and activating event loop during big changes may cause crash.
      Such things can happen in applications which try to mix HBQT
      and GTQTC. To avoid such problems before PRG code is called it's
      enough to disable keyboard pooling in main HVM loop, eg.
         if( hb_vmRequestReenter() )
         {
            HB_BOOL fKeyPool = hb_vmSetKeyPool( HB_FALSE );
            hb_vmPushEvalSym();
            hb_vmPush( pBlockItm );
            hb_vmSend( 0 );
            hb_vmSetKeyPool( fKeyPool );
            hb_vmRequestRestore();
         }
    + added new PRG function:
         __vmKeyPool( [<fEnable>] ) -> <fPrevState>
      It's PRG interface to above C function. If application uses GT driver
      and GUI library using the same event loop and such GUI library does not
      disable keyboard pooling in main HVM loop before PRG code is activated
      then it's enough to call this function at the beginning of application,
      eg.
         PROCEDURE INIT Clip()
            __vmKeyPool( .f. )
         RETURN
      With above peace of code you can mix HBQT or other QT wrapper with GTQTC.

2021-04-28 20:02 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * include/hbgtinfo.ch
    ! fixed comment, Alt+Numpad HB_GTI_KBDALT workaround was disabled by
      default here:
      2015-11-02 17:13 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)

2021-04-14 22:25 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  + src/rtl/vfilehi.prg
  * src/rtl/Makefile
  * src/harbour.def
  * include/harbour.hbx
    + added FILE API counterparts to hb_DirBuild() and hb_FNameExists()
      hb_vfDirBuild( <cDir> ) -> <lSuccess>
      hb_vfDirUnbuild( <cDir> ) -> <lSuccess>
      hb_vfNameExists( <cName> ) -> <lExists>
    ; their implementations are imported from 3.4
      https://github.com/vszakats/hb/blob/master/src/rtl/hbfilehi.prg
      but were renamed to fit in the hb_vf* namespace

  * src/rtl/hbfilehi.prg
    * use hb_LeftEq() instead of Left() ==
    ; partial merge of 3.4
      2015-07-27 14:26 UTC+0200 Viktor Szakats
    ! fix several sloppy checks where Empty() were
      used on strings while in fact a zero length
      check would have been correct.
    ; Empty() is a "weasel-word" when used on strings,
      should be used carefully and sparingly.

  * ChangeLog.txt
    % avoid spaces before EOLs

2021-04-12 21:18 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * src/rtl/hbfilehi.prg
    * hb_DirBuild() will now honor UNC "\\server\share\dir\tree" parameter
      on Windows and correctly create specified "\dir\tree" on remote
      server. If your code used a malformed "\\local\path" a regression
      in .prg code may happen on Windows. Previously a "\local\path"
      folder was created on current drive, as if the UNC specifier was
      omitted. It was more or less consistent with other platforms but
      not expected for this platform. Spotted by Maurizio la Cecilia (#233)
      [INCOMPATIBLE]

  * contrib/hbdoc/hbdoc.prg
  * contrib/hbformat/utils/hbformat.prg
  * contrib/hbnetio/utils/hbnetio/hbnetio.prg
  * package/harbour.mft
  * package/harbour.rc
  * src/compiler/hbusage.c
  * utils/hbi18n/hbi18n.prg
  * utils/hbtest/hbtest.prg
    * bumped copyright year to 2021

2021-04-10 23:32 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbfbird/firebird.c
    + added optional <cCollate> as 7-th parameter of FBCREATEDB( <cDB>,
       <cUser>, <cPass> <iPageSize>, <cCharSet>, <nDialect> [, <cCollate> ] )
      Based on request and example code from Ivanil Marcelino (#240)

  * contrib/hbpgsql/tpostgre.prg
    % var assignment readability

  * ChangeLog.txt
    ! corrected wrong date in prev entry

2021-04-02 20:37 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbpgsql/tpostgre.prg
    ! reverted previous commit 2021-04-01 15:55 UTC-0300 as invalid
      together with a little cleanup plus another minor cleanup

2021-04-01 15:55 UTC-0300 Marco Aurelio V (marcoprodata/at/gmail.com)
  * contrib/hbpgsql/tpostgre.prg
    ! corrected buggy in refresh method when execute commands to change
      struct
      [REVERTED]

2021-03-31 23:43 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbpgsql/postgres.c
    ! guard PQEXECPARAMS() wrapper from generating unrecoverable error
      on empty parameter array "hb_xgrab requested to allocate zero bytes"

  * contrib/hbpgsql/tpostgre.prg
    ! corrected buggy parameter order in TPQserver():Query()

    * make TPQQuery, TPQRow classes more aware of NIL to NULL conversions,
      added support for inserting and updating empty xBase date value
      should fix issue #234, oRow:FieldPut( <n>, NIL ) also looks good

2021-03-31 21:26 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbpgsql/hbpgsql.hbx
  * contrib/hbpgsql/postgres.c
  * contrib/hbpgsql/postgres.ch
    + add most new wrappers from this repository of Petr Chornyj:
      https://github.com/petr-ch/hbpgsql9
      Version guards have been added and "params" functions reworked
      to accept hashes instead of two arrays. Other minor corrections
      to fit into the contrib env.
    + add PQsslAttribute()
    * some existing functions were modified to make the parameter
      check (and fail if wrong) even if the underlying API is not
      available, instead of silently returning a default value.
    ; all of the above was build-tested only and some features
      require at least postgresql 8, 9 or 9.1

    + add PQlibVersion() -> <nVersion> (returns 0 for pre-9.1 postresql versions)
      Ref: https://github.com/harbour/core/pull/127/ by @VerchenkoAG

    + PQEXECPARAMS(): add 4th parameter to set <resultFormat>
      Refs:
        https://www.postgresql.org/docs/9.1/static/libpq-exec.html
        https://groups.google.com/d/msg/harbour-users/hXhuVzU9pHA/RrDGLIiUAwAJ

    + add PQresStatus( <nNum> ) -> <cString>

    + added wrapper function
      PQresultErrorField( result, nFieldCode ) -> cString
      based on: https://groups.google.com/d/msg/harbour-users/XSvRpbzfcHc/ztSL32fYpl4J
    + added PG_DIAG_* constants

    + added pg_encoding_to_char() wrapper to convert numeric
      encoding ID to string

    ! fixed to use hb_fopen() instead of fopen()

    + TPQserver():New(): all parameters are now optional
    ! TPQserver():New(): fixed to escape connect parameter values
    + TPQserver():New(): added 7th optional hash parameter to pass custom
      connection parameters (e.g. SSL)
         https://www.postgresql.org/docs/devel/static/libpq-connect.html

  * contrib/hbpgsql/tests/test.prg
    + use pg_encoding_to_char(), plus some more feedback regarding encodings

  * contrib/hbpgsql/tests/dbf2pg.prg
    + use VF IO
    + support more source field types

  ; synced with Viktor's 3.4 branch at https://github.com/vszakats/hb
    2017-02-15 15:14 UTC Viktor Szakats (vszakats users.noreply.github.com)
    2016-09-05 18:55 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-09-05 10:43 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-09-02 01:58 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-06-20 22:50 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2015-07-19 11:56 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2015-04-06 18:39 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2015-03-31 23:31 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2014-11-29 02:47 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    2014-07-08 13:21 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2014-02-11 18:18 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    ; tons of cleanups in this library, many thanks

2021-03-31 20:38 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbpgsql/hbpgsql.h
  * contrib/hbpgsql/postgres.c
  * contrib/hbpgsql/tpostgre.prg
    + recognize NAMEOID columns
    + added :SetNull( <lSet> ) to TPQServer class
      and a param to :Query( <cQuery>, [ <lNull> ] )
      TPQQuery class constructor is also extended.

      With :SetNull( .T. ) retains NULL information as NIL. Standard
      behaviour of hbpgsql library, until now, was to substitute NULL
      as blank xBase value - thus :SetNull( .F. ) is the default setting.

  ; changes imported from https://github.com/alcz/harbour
    2015-05-07 22:24 UTC+0200 Aleksander Czajczynski (hb fki.pl)

2021-01-26 18:27 UTC+0200 Oleksii Myronenko (m.oleksa ukr.net)
  * src/debug/dbgtarr.prg
  * src/debug/dbgthsh.prg
    ! fixed RTE when press enter in empty array or empty hash
      https://github.com/harbour/core/pull/225

2021-01-25 02:45 UTC+0100 Phil Krylov (phil a t newstar.rinet.ru)
  * contrib/hbct/dattime3.c
    ! Fixed building with glibc 2.31+ (stime() is no longer exported).

2020-11-03 10:37 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * src/rtl/arc4.c
    * updated to the current state of glibc, versions >= 2.30 have
      no sysctl(). Should fix build issues on current Linux distros
      like Fedora 33, etc.

2020-08-19 02:02 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/filesys.c
    ! use _exit() instead of exit() in forked process inside hb_fsPOpen().
      I've noticed that programs linked with QT 5.9.5 does not cleanly ends
      when exit() is used probably due to atexit() procedures.
    * use EXIT_SUCCESS and EXIT_FAILURE macros

  * src/rtl/gtcrs/gtcrs.c
  * src/rtl/hbproces.c
    * use _exit() instead of exit() in forked processes when exec*() fails
    * use EXIT_SUCCESS and EXIT_FAILURE macros

  * src/rtl/gtchrmap.c
    * use 'return 0' instead of 'exit( 0 )' in commented debug code

2020-06-30 18:01 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc.hbc
    * added default Qt5 path in Ubuntu64

  * contrib/gtqtc/gtqtc1.cpp
    + added support for horizontal wheel events
    * do not try to load image when zero length string is used as image name
      to refresh screen in HB_GTI_DISPIMAGE

2020-04-20 15:01 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc.hbp
    * added default Qt5 path in Ubuntu64

  * debian/compat
    * changed compatibility level from 5 to 9

  * src/rdd/workarea.c
    ! do not use casting to functions with incompatible parameters.
      Such casting does not work with some ABIs, i.e. when pascal
      calling convention is used and called function should clean
      parameters from the stack.
      This modification should also pacify warnings generated by
      recent GCC versions.

2020-04-19 16:32 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbct/dattime2.c
    % minor optimization

  * src/rdd/dbsql.c
    ; added somment with syntax info

  * include/inkey.ch
  * src/rtl/hbgtcore.c
    + added support for mouse wheel left and right events to base GT code

2020-04-19 16:00 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/vm/dynsym.c
  * src/vm/task.c
    ! pacified warnings

  * src/vm/hashfunc.c
    ! fixed possible GPF in hb_HCopy() and hb_HMerge() functions when source
      and destinnation is the same hash array.

2020-03-27 15:00 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * ChangeLog.txt
    ! fixed the position of my last ChangeLog entry - sorry but my script
      which adds ChangeLog entry automatically was not updated for year 2020
      and added the description before last entry in 2019.

2020-03-24 23:34 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * config/linux/clang.mk
    ! fixed rule for dynamic library

  * src/3rd/png/Makefile
    + added -DPNG_ARM_NEON_OPT=0 to build flags

  * contrib/3rd/sqlite3/sqlite3.c
  * contrib/3rd/sqlite3/sqlite3.diff
    ! pacified warning

  * contrib/gtwvg/gtwvgd.c
  * contrib/gtwvg/wvgwing.c
    ! fixed missing break/return in case statements - please verify it.

  * contrib/hbct/dattime3.c
    * added #define _DEFAULT_SOURCE necessay in new Linux distors

  * contrib/hblzf/3rd/liblzf/liblzf.diff
  * contrib/hblzf/3rd/liblzf/lzfP.h
    * do not use nested #define in #if statements - some C compilers do not
      support it

  * contrib/hbssl/bio.c
    ! tuned #if condition

  * contrib/hbmisc/hbeditc.c
    * simpliefied for condition and pacified warning

  * contrib/hbodbc/hbodbc.hbp
  * contrib/sddodbc/sddodbc.hbp
    + added check for iodbc library

  * utils/hbmk2/hbmk2.prg
    + added support for clang in android builds

  * include/hbdefs.h
    + added check for __BYTE_ORDER__ macro used in some new lib C
      implementations

  * include/hbapi.h
  * include/hbdefs.h
  * include/hbstack.h
  * include/hbvmpub.h
  * src/vm/classes.c
  * src/vm/dynsym.c
  * src/vm/estack.c
  * src/vm/memvars.c
    + extended the size of dynamic symbol table from 65535 to 4294967295.
      Adopting class code I decided to keep current algorithm of method indexes
      hashing with only some minor modifications. It's very fast anyhow it may
      cause noticeable (though static) quite big memory allocation for class
      definitions in applications using millions of symbols and which increase
      dynamic symbol table at runtime loading new classes dynamically form .hrb,
      .dll, .so or other dynamic libraries supported by Harbour. It's random
      and rather impossible to exploit situation in real life anyhow I cannot
      exclude it so I'd like to report it in ChangeLog. The solution is very
      simple, i.e. it's enough to use classic divide et impera algorithm using
      symbol numbers to find method definition anyhow it will be slower then
      current one and address only very seldom hypothetical situations so I
      decided to not implement it. Such static memory cost begins to be
      completely unimportant in the world of 64-bit architectures and extremely
      big memory address space.
      The modification was sponsored by TRES company.

  * src/vm/estack.c
    ! fixed __mvClear() in MT builds - due to stupid typo GetList variable
      was removed in MT programs by CLEAR MEMORY command (__mvClear())
      So far noone reported it and I've found it analyzing the code before
      increasing symbol table size.

  * contrib/hbwin/hbolesrv.c
    * updated for new size of dynamic symbol table

2020-02-24 08:32 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * src/lang/l_de.c
  * src/lang/l_de_at.c
    + added German translations of error messages contributed
      by DF7BE - Wilfried Brunken. Contents have been slightly
      revised by Jan Fornoff.

2020-02-10 15:34 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  + src/codepage/cpde858.c
  * src/codepage/Makefile
  * include/hbcpage.hbx
  * src/harbour.def
    + added codepage DE858, it is essentially DE850 but with EURO SIGN
      (U+20AC) at position 0xD5 instead of Turkish dotless-i (U+0131)
      Issue #201

  * src/vm/fm.c
    * OpenWatcom remaining pragmas related to 201 warning (unreachable code)
      assigned to C mode (wcc386) build only - issue #202

2020-02-05 11:25 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * src/vm/fm.c
  * src/macro/macro.y
  * src/macro/macro.yyc
    ! guarded more C++ mode only pragmas for OpenWatcom. Issue #202

  * utils/hbmk2/hbmk2.prg
    ! reverted C++ check

2020-02-05 08:08 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * config/dos/watcom.mk
  * config/linux/watcom.mk
  * config/os2/watcom.mk
  * config/win/watcom.mk
  * src/compiler/harbour.y
  * src/compiler/harbour.yyc
  * utils/hbmk2/hbmk2.prg
    ! fix OpenWatcom disabled warning listings, numeric specifiers have
      different meanings in C (wcc386) and C++ mode (wpp386) compiler
      executables. "-wcd201" - not fully sure about it, is now assigned
      to C mode: "unreachable code". References issue #202.

  * ChangeLog.txt
    ! fix UTF-8 char broken by Maurizio

2020-02-04 21:12 UTC+0100 Maurizio la Cecilia (m.lacecilia/at/gmail.com)
  * contrib/hbformat/hbfmtcls.prg
    ! fixed wrong spacing between comment indicators

2020-02-03 13:13 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * include/hbcpage.hbx
  * src/harbour.def
    ! updated to make some dynamic linkers happy about (not that)
      recently added EE, LV languages

2020-01-31 15:34 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * src/rtl/listbox.prg
    ! fix listbox scroll bar position calculation to not rely on
      default Cl*pper compatible division by zero error handler.
      Thanks to tarpauwatratar for the report and fix suggestion
      on the developers list.

  * contrib/hbdoc/hbdoc.prg
  * contrib/hbformat/utils/hbformat.prg
  * contrib/hbnetio/utils/hbnetio/hbnetio.prg
  * package/harbour.mft
  * package/harbour.rc
  * src/compiler/hbusage.c
  * utils/hbi18n/hbi18n.prg
  * utils/hbtest/hbtest.prg
    * bumped copyright year to 2020

  * ChangeLog.txt
    * function name typo + file case corrected

2020-01-13 19:15 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * src/rtl/gtwin/gtwin.c
  * src/rtl/gtwvt/gtwvt.c
    ! hopefully make left ALT+[Y/Z] WM_SYSCHAR values handling aware
      of QWERTZ layout. Should fix issues with Serbian Latin and similar
      keyboards, while still retain the original fix for Greek layout.
      References:
      2016-07-04 19:01 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
      https://github.com/harbour/core/commit/8465bce36bbfab6026673f1c597a91028f96079a

2019-12-03 11:42 UTC+0100 Maurizio la Cecilia (m.lacecilia/at/gmail.com)
  * ChangeLog.txt
    * restored UTF-8 encoding after previous wrong commit (Sorry!!!)

2019-12-03 10:55 UTC+0100 Maurizio la Cecilia (m.lacecilia/at/gmail.com)
  * contrib/hbformat/hbfmtcls.prg
    ! many fixes as suggested by Viktor Szakats and already applied to
      his 3.4 fork
      many fixes derived by usergroup threads
      (fixed formatting in comments, codeblocks, operators, etc.)
    ! fixed case of unknown function as in pull request of Niko (nicolasrod)
      https://github.com/harbour/core/pull/139
  * contrib/hbformat/utils/hbformat.prg
    * imported some enhancements from Viktor Szakats 3.4 fork:
      . use hb_leftEq(), hb_vf*() functions where possible
      . localization of message text
  * contrib/hbwin/hbwin.hbx
  * contrib/hbwin/wapi_shellapi.c
    + added the function wapi_ShellExecuteWait()
      code by Antonino Perricone changed by me to be independent of FiveWin
      https://groups.google.com/d/msg/harbour-users/w-fOOaC1M_g/K8B8jHgFCQAJ
      Syntax:
      wapi_ShellExecuteWait([<hWnd>], [<cOperation>], [<cFile>], [<cParameters>],
                            [<cWorkDirectory>], [<nShowCmd>]) ? nResult
      The function acts as wapi_ShellExecute() but it waits for the completion
      before returning
  * src/rtl/tmenusys.prg
    * forced the menu system to not close current popup after menu action
      suggestion by Mario Wan Stadnik, see at:
      https://groups.google.com/d/topic/harbour-users/EEv1bKjci-Y/discussion

2019-09-26 18:30 UTC+0200 Maurizio la Cecilia (m.lacecilia/at/gmail.com)
  * contrib/xhb/hbxml.c
    ! fixed the compliance to the element tag naming rules:
      . the element name must begin with alpha or underscore characters
      . the element name can contain also period characters
      . the closing tag can contain spaces between the name and the closing bracket

2019-09-11 10:16 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  + src/codepage/l_ee.h
  + src/codepage/l_lv.h
    + once again, sorry! actually those files were missing from the previous
      commit - instead of being moved - due to git kludges

2019-09-09 18:08 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * src/lang/l_ee.h -> src/codepage/l_ee.h
  * src/lang/l_lv.h -> src/codepage/l_lv.h
    ! corrected paths for include files

2019-09-09 17:50 UTC+0200 Pavel Tsarenko (tpe2 at mail.ru)
  * include/hblang.hbx
  * src/codepage/Makefile
  + src/codepage/cpee775.c
  + src/codepage/cpeewin.c
  + src/codepage/cplv775.c
  + src/codepage/cplvwin.c
  * src/lang/Makefile
  + src/lang/l_ee.c
  + src/lang/l_ee.h
  + src/lang/l_lv.c
  + src/lang/l_lv.h
    + added estonian and latvian lang and codepage modules

2019-04-11 17:33 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/common/hbverdsp.c
  * src/nortl/nortl.c
    * use HB_MEM_STATISTICS instead of HB_MEM_USEDMAX to check if memory
      statistic module is enabled in harbour compiler -build message

2019-04-11 17:23 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/dbinfo.ch
  * src/rdd/dbf1.c
    + added DB_SETHEADER_EOL flag, it's used to force setting EOL marker
      when header is written. In Harbour's DBF* RDDs is set in CLOSE()
      method so just like in Clipper when DBF is closed and header has to
      be updated the EOL() marker is set.
      As side effect reducing header updates to minimal level (in such
      case DBF header is not updated after APPEND what is safe for Harbour,
      Clipper and compatible RDDs because they use file size to calculate
      number of records but some other DBF drivers may be confused)
      increase the APPEND speed and also forces EOL setting in all cases
      when CLOSE() method is called. Header updates can be reduce to minimal
      level by:
         hb_rddInfo( RDDI_SETHEADER, DB_SETHEADER_MINIMAL )

  * src/rdd/usrrdd/usrrdd.c
    ! fixed GPF in UsrRDD redirector for DROP(), EXISTS() and RENAME() methods

  * src/vm/cmdarg.c
    * use HB_MEM_STATISTICS instead of HB_MEM_USEDMAX to check if memory
      statistic module is enabled in //info message

2019-03-27 18:27 UTC-0300 Lailton Fernando Mariano (lailton/at/paysoft.com.br)
  * config/android/libs.mk
  * utils/hbmk2/hbmk2.prg
    ! fixed a link error for Android. added lib log

2019-03-19 18:12 UTC+0200 Mindaugas Kavaliauskas (dbtopas/at/dbtopas.lt)
  * config/win/global.mk
  * utils/hbmk2/hbmk2.prg
    ! moved winmm library before kernel32. This fixes Harbour compile and
      application run on Win7 and previous Windows versions if latest MinGW
      is used.
    ; Win8+ exports timeGetTime() from both kernel32.dll and winmm.dll.
      Previous windows version exports this function only from winmm.dll.
      See discussion at https://github.com/msys2/MINGW-packages/issues/4984

  * utils/hbmk2/hbmk2.prg
    ! Fixed dependency detection. Setting HB_WITH_<package>=local was ignored
      if packages were detected using pkg-config

  * contrib/hbexpat/3rd/expat/siphash.h
    ! fixed compile error for BCC <= 5.6
    * rediffed

2019-02-11 13:51 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc1.cpp
  * src/rtl/gtxwc/gtxwc.c
    ! added /* fallthrough */ comments to pacify warnings

2019-02-11 13:43 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * bin/commit.hb
    ! fixed UTC offset formatting

  * contrib/hbwin/win_os.prg
    * updated win_osNetRegOk() for modern MS-Windows versions:
      - on Win7 and upper set
        System\CurrentControlSet\Services\LanmanServer\Parameters\DisableLeasing
        to disable opportunistic locks.
      - do not force SMB1 to disable oplocks on Win7 and upper - new MS-Win10
        does not support SMB1 at all so this setting on the server with
        such system completely disables SMB network and forcing SMB1 on the
        client side blocks access to new Win10 servers.
        Warning! this setting is still activated on Vista so it cannot
                 connect work with new Win10 but I do not know any other
                 working method to disable oplocks in Windows Vista.
    * synced with Viktor's branch

  * contrib/xhb/hbserv.c
    ! added missing return

  * include/harbour.hbx
  * src/harbour.def
  * src/rtl/version.c
    + added new PRG functions:
         hb_osIsWin7(), hb_osIsWin8(), hb_osIsWin81(), hb_osIsWin10()

  * src/rtl/gttrm/gttrm.c
    + added autodetection for few other XTerm compatible terminals
    + respect color extension in TERM name of all XTerm compatible
      terminals

  * utils/hbmk2/hbmk2.prg
    + added support for -cpp=isoXX borowed from Viktor's branch

  * contrib/gtqtc/gtqtc.hbc
  * contrib/gtqtc/gtqtc.hbp
    * use -cpp=iso11 required for QT 5.7.0 or upper
    * extended QT detection and partial syncing with Viktor's branch

2019-02-11 13:09 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/sddsqlt3/core.c
    ! fix DBUSEAREA() operation with SQLITE3 SDD to return empty result
      when query conditions are false or the source table has no rows.

      Previously an logically correct example caused RTE:
      DBUSEAREA(,, "SELECT * FROM existing_table WHERE FALSE")

    ! fix double-free error in sqLite3Disconnect(), looks like the
      sqlite3_close() return value checking was reverted, SQLITE_OK is 0

    * use CDP API to get UTF8 string length

    * use new sqlite3_prepare_v3() when built against
      sqlite 3.20.0 or upper (change borrowed from Viktor's 3.4 fork)

    + add HB_SQLT3_MAP_DECLARED_EMULATED define (not yet enabled by default)
      which make this SDD additionally parse SQLite column declarations.
      Right now it can make HB_FT_DATE fields working using standard
      ISO 8601 "yyyy-mm-dd" syntax. Also declarations not significant for
      SQLite, but useful in xBase-style programming - SQL numeric(len,dec)
      columns are detected in this mode and will be reflected in dbStruct().

    + add support for alternative StoD() like syntax for HB_FT_DATE columns

    + add support for ISO 8601 "YYYY-MM-DD HH:MM:SS.FFF" timestamp declared
      columns, SQLite stored strings are converted to proper HB_FT_TIMESTAMP
      fields

    + added HB_SQLT3_FIELDNAME_STRICT define, which enables shortening
      of field to "name" if SQLite returns "table.name". Such fields are
      not completly usable in xBase code - WA->T.FIELD syntax is not
      valid, but FieldPos("t.field") is OK. I think it should be default
      behaviour or some runtime setting should be introduced for convenience
      when working with specific SQL queries.

  * contrib/rddsql/sqlbase.c
  * contrib/rddsql/sqlmix.c
    + added ZAP functionality to SQLBASE and SQLMIX RDDs,
      index tags are preserved while ZAP-ing SQLMIX area.
      They are cleaned, no REINDEX is needed

    * changed to allow values of any type in "V" SIX3 / HB_FT_ANY fields
      in SQLBASE/SQLMIX RDD workareas

  * contrib/hbfoxpro/relfunc.c
    ! fix InList() FoxPro compatible function not looking at the last
      parameter passed. Thanks to Attila Szabo for the information
      posted on the developers list.

2019-01-25 12:26 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/xhb/hbxml.c
    ! fixed memory leak

2019-01-15 12:50 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * README.md
    * verified links to referenced libraries, go https where applicable.
      Thanks to Pawel Wojciechowski for the location of ADS client library.

  * src/rtl/arc4.c
    ! fix builds on Alpine Linux and possibly others using musl libc,
      which in turn doesn't expose deprecated sysctl() anymore.

  * contrib/hbdoc/hbdoc.prg
  * contrib/hbformat/utils/hbformat.prg
  * contrib/hbnetio/utils/hbnetio/hbnetio.prg
  * package/harbour.mft
  * package/harbour.rc
  * src/compiler/hbusage.c
  * utils/hbi18n/hbi18n.prg
  * utils/hbtest/hbtest.prg
    * bumped copyright year to 2019

2019-01-14 12:18 UTC-0800 Pritpal Bedi (bedipritpal/at/hotmail.com)
  * contrib/gtwvg/wnd.prg
    ! Fixed: x,y,w,h values if aPos and aSize parameters were
      containing negatve values.
  * contrib/gtwvg/paint.prg
    ! Fixed to return proper color index if a compound color string
      is supplied to wvt_GetRGBColorByString().
    ; Above patch provided by Jose Quintas - many thanks.

2019-01-11 13:52 UTC-0800 Pritpal Bedi (bedipritpal/at/hotmail.com)
  * contrib/gtwvg/wnd.prg
  * contrib/gtwvg/activex.prg
    ! modified to honor plain hWnd as container window instead of an
      WvgWnd() object.
  * contrib/gtwvg/gtwvgd.c
    + added - HB_GTI_VIEWPORTHEIGHT and HB_GTI_VIEWPORTWIDTH handelling.
    ! Pacified some warnings reported by BCC-720.
  * contrib/gtwvg/wvgcore.c
  * contrib/gtwvg/wvgcuig.c
    ! Pacified some warnings reported by BCC-720.

2018-12-31 15:32 UTC+0100 Maurizio la Cecilia (m.lacecilia/at/gmail.com)
  * contrib/hbssl/hbssl.hbc
    * made compliant also for Windows static builds
  * ChangeLog.txt
    * restored UTF-8 encoding after previous wrong commit (Sorry!!!)

2018-12-29 19:35 UTC+0100 Maurizio la Cecilia (m.lacecilia/at/gmail.com)
  * contrib/hbssl/hbssl.hbp
    * added import libraries to link with OpenSSL current version
  * contrib/hbcurl/hbcurl.hbp
    * added import libraries to link with cUrl current version
  * contrib/hbwin/wapi_winuser_1.c
  * contrib/hbwin/hbwin.hbx
    * added wapi_ShowWindow() wrapper

2018-12-17 12:00 UTC+0100 Maurizio la Cecilia (m.lacecilia/at/gmail.com)
  * contrib/xhb/hbxml.c
    ! fixed the lacking of correct settings of previous node in
      mxml_node_insert_before(), that was causing the omitting
      of the inserted nodes in saves and searches.

2018-11-16 16:33 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/bio.c
  * contrib/hbssl/err.c
  * contrib/hbssl/evp.c
  * contrib/hbssl/evpciph.c
  * contrib/hbssl/evpenc.c
  * contrib/hbssl/evpmd.c
  * contrib/hbssl/evppkey.c
  * contrib/hbssl/hbssl.ch
  * contrib/hbssl/hbssl.h
  * contrib/hbssl/hbssl.hbx
  * contrib/hbssl/pem.c
  * contrib/hbssl/rand.c
  * contrib/hbssl/ssl.c
  * contrib/hbssl/ssl_hb.c
  * contrib/hbssl/ssl_inet.c
  * contrib/hbssl/ssl_sock.c
  * contrib/hbssl/sslciph.c
  * contrib/hbssl/sslctx.c
  * contrib/hbssl/sslsess.c
  * contrib/hbssl/x509.c
    * synced with Viktor's 3.4 branch and updated to OpenSSL 1.1

  * include/hbsocket.h
  * src/rtl/hbsocket.c
    + added new C function:
         HB_U16 hb_socketNToHS( HB_U16 netshort )

  * include/hbapiitm.h
  * src/vm/itemapi.c
    + added new C functions:
         const char * hb_itemGetCRef( PHB_ITEM pItem, void ** phRef,
                                      HB_SIZE * pnLen );
         void hb_itemFreeCRef( void * hRef );
      hb_itemGetCRef() locks string inside character item so it cannot be
      released when item is cleared an hb_itemFreeCRef() unlocks it and
      free if item holding it was cleared.

2018-09-14 15:36 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/harbour.hbx
  * include/hbchksum.h
  * src/harbour.def
  * src/rtl/hbmd5.c
    + added new C function
         void hb_hmac_md5( const void * key, HB_SIZE nKeyLen,
                           const void * message, HB_SIZE nMsgLen,
                           char * digest );
    + added new PRG function
         HB_HMAC_MD5( <cMessage>, <cKey> ) -> <cMAC>
    ; HMAC MD5 is used in some authentication methods i.e. CRAM-MD5
      authentication in SMTP protocol

  * src/rtl/gttrm/gttrm.c
    + enable extended XTERM colors automatically when xterm-16color,
      xterm-256color, xterm+256color, xterm-88color, rxvt-16color,
      rxvt-256color, rxvt-98color or putty terminal is detected
    + added support for HB_GTI_SCREENDEPTH

  * contrib/gtqtc/gtqtc1.cpp
    + set clipboard data also into selection buffer on platforms which
      support it
    + when main clipboard buffer is empty retrieve clipboard data from
      selection buffer and if it's empty too from find buffer

  * include/harbour.hbx
  * src/harbour.def
  * src/vm/memvars.c
    + added new PRG function
         __mvGetDef( <cMemvar> [, <xDefault> ] ) -> <xValue>
      it works in similar way to __mvGet() but if <cMemvar> does
      not exist then it returns <xDefault> or NIL instead of RTE

  * contrib/hbwin/hbwin.hbx
    + added missing declarations for win_osIs10() and win_osIs81()

  * contrib/hbssl/ssl.c
    ! fixed compilation with OpenSSL < 0.9.8k

  * contrib/sddodbc/core.c
    * pacified warning

  * contrib/xhb/hbxml.c
  * contrib/xhb/hbxml.h
    ! fixed CDATA terminator, it should be "]]>" instead of " ]]>"
    + added support for HBXML_STYLE_NONEWLINE flag

  * src/3rd/pcre/Makefile
    ! typo wince -> wce

  * src/main/Makefile
    * use harbour.rc only in MS-Windows builds - it fixes OS2 OpenWatcom
      builds

  * config/global.mk
    ! in DOS builds check if the 'uname' exists before running it

  * include/hbapigt.h
  * include/hbgtcore.h
  * src/rtl/hbgtcore.c
  * src/rtl/inkey.c
  * src/rtl/inkeyapi.c
  * contrib/xhb/xhbfunc.c
    + added 3-rd parameter to hb_inkeySetText() function. When this parameter
      is true then ';' is not translated to Chr( 13 ) but DOS and UNIX EOLs
      are translated to Chr( 13 )
    + added logical parameter to HB_GTI_CLIPBOARDPASTE which allows to set
      text without ';' translation but with platform independent EOLs

  * src/rtl/memoedit.prg
  * utils/hbmk2/hbmk2.prg
  * contrib/hbnetio/utils/hbnetio/_console.prg
  * extras/dbu/dbu52.patch
  * extras/dbu/dbu53.patch
    * use hb_gtInfo( HB_GTI_CLIPBOARDPASTE, .T. ) instead of
      hb_gtInfo( HB_GTI_CLIPBOARDPASTE ) for pasting data from clipboard
      with platform independent EOLs and ';' characters

2018-09-02 23:07 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * include/hbsetup.h
    * changed to recognize ARM64 platform with modern GCC builds

2018-06-04 01:30 UTC-0300 Lailton Fernando Mariano (lailton/at/paysoft.com.br)
  * contrib/hbexpat/3rd/expat/xmltok.c
    ! fixed compiler error for BCC <= 5.8.2

2018-06-01 00:25 UTC+0300 Phil Krylov (phil a t newstar.rinet.ru)
  * src/rtl/trim.c
    ! Fixed HB_SIZE format specifier in HB_TRACE format string.

2018-05-11 12:23 UTC+0200 maurilio (maurilio.longo@libero.it)
  * contrib/hbssl/hbssl.hbx
  * contrib/hbssl/ssl.c
    + Added function SSL_set_tlsext_host_name() which is needed to access
      a virtual host when using HTTPS.
      See https://en.wikipedia.org/wiki/Server_Name_Indication
    + Added function SSL_set_verify().
  * src/rtl/fstemp.c
    ! hb_fsTempName() was not returning a valid temp name on OS/2

2018-03-16 19:10 UTC+0200 Phil Krylov (phil a t newstar.rinet.ru)
  * include/hbexprb.c
  * src/compiler/complex.c
  * src/vm/memvars.c
  * src/vm/strapi.c
    ! fixed compiler warnings emitted by GCC 7+

2018-02-23 15:15 UTC+0200 Alexey Myronenko (m.oleksa/at/ukr.net)
  * src/debug/dbgwa.prg
    ! fixed position of the cursor in (reopened) F6-WA window

2018-02-13 13:23 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/sddodbc/core.c
    ! fix DBCreate() GPF when RDDSQL is active and connection is via SDDODBC

2018-02-12 10:00 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbnetio/netiocli.c
    ! fix indentation

2018-02-11 23:40 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * include/hbapi.h
  * src/common/hbver.c
  * src/harbour.def
  * contrib/hbwin/win_osc.c
    * synced Windows version detection code with Viktor's work in 3.4

  * src/main/Makefile
  + src/main/harbour.rc
    * include Windows manifest in standalone compiler - "harbour.exe /build"
      should now correctly report Windows 10. "yourapp.exe //build" plus
      in-app results still depend on manual manifest inclusion within .rc

2018-02-11 12:55 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * package/harbour.mft
    + added version manifest to Harbour compiler binaries, which is more
      important on Windows 10 builds, to not include false Windows version
      in build info.
      This doesn't affect programs built with Harbour, where similar manifest
      should be included or not, according to your needs.

  * utils/hbmk2/hbmk2.prg
    * define _UNICODE (activates unicode C RTL functions in OpenWatcom
      and some MS C compilers) together with UNICODE in -winuni mode.
      Similar change was done in Viktor's forked Harbour 3.4. Harbour
      core/contrib code doesn't use any of these C RTL, but in most 3rd
      party code it's expected that these are enabled both.

2018-02-11 12:15 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbdoc/hbdoc.prg
  * contrib/hbformat/utils/hbformat.prg
  * contrib/hbnetio/utils/hbnetio/hbnetio.prg
  * package/harbour.mft
  * package/harbour.rc
  * src/compiler/hbusage.c
  * utils/hbi18n/hbi18n.prg
  * utils/hbtest/hbtest.prg
    * bumped copyright year to 2018

2018-02-11 12:00 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * README.md
  * config/global.mk
  * contrib/gtwvw/doc/gtwvw.txt
  * contrib/hbwin/tests/ole.prg
  * contrib/hbzebra/tests/cairo.prg
  * contrib/hbzebra/tests/harupdf.prg
  * contrib/hbzebra/tests/wingdi.prg
  * package/harbour-wce.spec.in
  * package/harbour-win.spec.in
  * package/harbour.rb
  * package/harbour.spec
  * package/mpkg_win.nsi
  * package/winuni/mpkg_win_uni.nsi
  * src/3rd/zlib/ChangeLog.txt
  * src/compiler/hbusage.c
  * src/pp/hbpp.c
  * tests/html.prg
    * changed Harbour Project website URL references to
      https://harbour.github.io/
      This change is very symbolic mark of time passing, but it had to be
      done. Original harbour-project.org domain went out from reach
      together with Phil Barnett passing away on April 16, 2015.
      Respect Phil, RIP.
      Phil's efforts are directly tied to The Harbour Project origins.
      To memorize him, please take a tour to archived The Oasis
      https://harbour.github.io/the-oasis/

2018-02-11 11:00 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbnetio/netiocli.c
    ! fix spontaneous Error 1003 in NETIO client code failing to receive
      full length of incoming data packet. Such odd behaviour was spotted
      on Windows.

2018-01-05 15:38 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/compiler/complex.c
    * pacified warning and removed commented debug code I committed by mistake

2018-01-05 14:12 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapiitm.h
  * src/rtl/hbdef.c
  * src/vm/itemapi.c
  * src/harbour.def
    + added new public C function
         HB_BOOL hb_itemTypeCmp( PHB_ITEM pItem1, PHB_ITEM pItem2 );
      which uses low level item type comparison code taken from hb_default()
      and hb_defaultValue() PRG functions

  * include/harbour.hbx
  * src/harbour.def
  * src/vm/hashfunc.c
    + added new PRG function
         hb_HSetDef( <hVal>, <xKey> [, <xDefVal> ] )
      it checks if <xKey> exists and if not then adds it to hash array
      and optionally sets key value to <xDefVal> otherwise (the key
      exists in hash array) and <xDefVal> is given then it checks if
      the type of key's value is compatible with <xDefVal> and if not
      then replaces key's value with <xDefVal>.
      In other words it's combination of hb_HGetDef() and hb_default()
      and works like this PRG code:
            FUNCTION hb_HSetDef( hVal, xKey, xDefVal )
               IF xKey $ hVal
                  hb_default( @hVal[ xKey ], xDefVal )
               ELSE
                  hVal[ xKey ] := xDefVal
               ENDIF
            RETURN hVal
      but much faster.

  * src/rtl/dirscan.prg
    * remove READONLY attribute from deleted directories.
      Be careful. Now this function allows to recursively remove
      all directories even if they have READONLY attribute.

2017-12-20 12:31 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbexpat/3rd/expat/loadlibr.c
  * contrib/hbexpat/3rd/expat/xmlparse.c
    * casting for C++ builds

  * contrib/hbexpat/3rd/expat/expat.diff
    ! rediffed with
         hbmk2 ../../../../bin/3rdpatch.hb -rediff

2017-12-20 11:34 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbexpat/3rd/expat/loadlibr.c
    ! define _UNICODE macro when UNICODE is also defined - it should be fixed
      in EXPAT core code. It fixes Windows builds.

  * contrib/hbexpat/3rd/expat/xmlparse.c
    ! restored fix for WINCE builds

  * contrib/hbtip/client.prg
    ! restored #undef __HBEXTREQ__ before #include "hbssl.hbx".
      It fixes non SSL builds and binding HBTIP with all HBSSL
      functions.

  * contrib/hbexpat/hbexpat.hbc
    * added /usr/local/opt/expat/lib library path to darwin builds
      (synced with Viktor's 3.4 branch)

2017-12-19 21:42 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * config/darwin/clang.mk
  * config/darwin/gcc.mk
  * config/darwin/global.mk
  * config/darwin/icc.mk
  * config/darwin/libs.mk
  * utils/hbmk2/hbmk2.prg
    * synced with Viktor's modifications in 3.4 branch:
    ; 2017-11-11 13:14 UTC Viktor Szakats:
    * switch to call the C compiler to link dynamic libs on darwin,
      which is the recommended way to do this, as suggested by Apple.
      This also aligns the platform better with other *nix platforms.
      'libtool' was used before, but that started having intermittent
      issues around Sierra (mitigated by disabling parallel build),
      which returned and got worse in High Sierra (with no remedy).
      The symptom was 'ld: file not found: ' errors with the filename
      not shown or appearing as garbage, then a 'libtool: internal link
      edit command failed'. This was reported and will be fixed in a
      future Xcode release.
      Ref: Apple Radar 34944562

  * config/global.mk
  * config/rules.mk
    + added new user build envvar HB_USER_DCFLAGS
      It allows to set C compiler parameters to compile .c code for
      dynamic libraries.

  * src/rtl/hbsocket.c
    ! fixed fcntl(F_SETFL) 3-rd parameter in hb_socketSetBlockingIO(),
      By mistake I used long instead of int. it created problem on big
      endian 64 bit machines.

  * include/hbgtcore.h
  * src/rtl/hbgtcore.c
    + added new C functions for GT programmers:
         void hb_gt_BaseUnlock( PHB_GT pGT );
         void hb_gt_BaseLock( PHB_GT pGT );
         void hb_gtSleep( PHB_GT pGT, double dSeconds );

  * src/rtl/hbgtcore.c
  * src/rtl/gtcrs/gtcrs.c
  * src/rtl/gtdos/gtdos.c
  * src/rtl/gtgui/gtgui.c
  * src/rtl/gtos2/gtos2.c
  * src/rtl/gtpca/gtpca.c
  * src/rtl/gtsln/gtsln.c
  * src/rtl/gtstd/gtstd.c
  * src/rtl/gttrm/gttrm.c
  * src/rtl/gtwin/gtwin.c
  * src/rtl/gtwvt/gtwvt.c
  * src/rtl/gtxwc/gtxwc.c
    * use new functions to unblock GT when low level TONE() code is
      executed. It allows other threads to access shared GT driver
      when one of them executes TONE()

  * contrib/hbexpat/hbexpat.hbx
    * regenerated automatically

2017-12-15 19:53 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbexpat/3rd/expat/expat.hbp
    ! add missing bits, previous commit failed to include expat_co[nfig].h
      on non-win platforms

  * ChangeLog.txt
    ! typo

2017-12-14 14:20 UTC+0100 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbamf/amfenc.c
    * update amf3_Encode() serialize function with great idea of Przemek
      implemented recently in hb_Serialize(). Checking garbage collector
      reference count can save time here too, unique arrays and hashes won't
      be indexed as references.

  * contrib/hbexpat/3rd/expat/*
    ! updated to 2.2.5 (from 2.2.1) using 3rdpatch.hb, expat.diff from
      Viktor's 3.4 fork was used - but (again) adapted for DOS 8.3 naming
      scheme. Also i've kept local patches for WinCE, OpenWatcom DOS/OS2,
      please test. Compilation in CPP mode is explicitly disabled for libexpat
      now, as upstream decided to ignore such use cases completly.

   * contrib/hbexpat/*
     * synced with Viktor's 3.4 fork

   + include/hbarc4.h
   * src/harbour.def
     + export ARC4 core routines like in 3.4 fork, updated expat lib reuses it.

   * contrib/hbtip/hbtip.hbp
     ! adapt *.hbx file specifier to hbmk2 3.2 syntax

2017-12-12 12:26 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbnf/fttext.c
  * contrib/hbnf/hbnf.hbx
    * synced with Viktor's modifications:
         - use FILE API instead of FS API
         - protection against GPF when FT area has no valid file handle
         - alternative function names which exceeds 10 character Cl*pper limit
    ! fixed handle and memory leak when new file is open in FT area which
      already has open file

  * include/harbour.hbx
  * src/harbour.def
  * src/vm/hvm.c
    + added new PRG function: __vmItemRefs( <xVal> ) -> <nRefs>
      Please remember that passed <xVal> parameter increases the counter so
      if you want to eliminate it then pass it by reference, i,e.:
         aVal := {}
         ? __vmItemRefs( aVal ), __vmItemRefs( @aVal )

  * include/hbapi.h
  * src/harbour.def
  * src/vm/arrays.c
  * src/vm/codebloc.c
  * src/vm/hashes.c
    + added new C functions:
         HB_COUNTER hb_arrayRefs( PHB_ITEM pArray );
         HB_COUNTER hb_hashRefs( PHB_ITEM pHash );
         HB_COUNTER hb_codeblockRefs( PHB_ITEM pItem );

  * src/rtl/itemseri.c
    * added new internal function to replace 3 times repeated code for
      resizing array of references.
    % use new functions to check number of references to hashes, arrays and
      objects to ignore in system detecting multiple references the items
      which have reference counter smaller then 2. Such items cannot have
      multiple references.
      In practice this modification resolves the time problem when very big
      items are serialized to the level comparable to HB_SERIALIZE_IGNOREREF
      so now this flag is useless though I'll keep it because only in such
      mode serialization code can be used as filter in streams.
      I also created binary tree to store references but after this
      modifications it is not necessary so I decided to not commit it yet.
      Please only remember that practice limit of such serialization code
      is created by physical memory attached by OS to the process. When this
      limit is exceed then swap is actively used what completely kill the
      performance. The CPU usage is reduced to less then 1% because it waits
      for restoring swapped memory pages by extremely heavy used disks. In
      such case I cannot help.

2017-11-22 11:33 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/rddads/ads1.c
  * src/rdd/workarea.c
    * generate RTE code when SELF_ADDFIELD() used in SELF_CREATEFIELDS()
      (dbCreate() backend) returns HB_FAILURE. It fixes silent dbCreate()
      exit when some wrong table structure arrays are passed to this
      function.

  * src/rdd/dbf1.c
    ! added protection against too long unicode character and fields defined
      in dbCreate() table structure array - fix problem reported by KevinC -
      thanks
    * change RTE number from EDBF_DATATYPE to EDBF_DATAWIDTH record size is
      exceed
    + added additional protection when corrupted table with unicode fields
      is open

2017-11-15 23:34 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rdd/dbf1.c
    ! pacified warning after last commit - thanks to Grigory Filatov

2017-11-15 14:34 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/wapi_winbase_2.c
  * contrib/hbwin/wapi_winuser_2.c
    ! fixed WinCE builds

2017-11-15 11:32 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbjson.h
  * src/rtl/hbjson.c
    * changed 3-rd parameter 'HB_BOOL fHuman' in hb_jsonEncode() and
      hb_jsonEncodeCP() C functions to 'int iIndent'
         char * hb_jsonEncode( PHB_ITEM pValue, HB_SIZE * pnLen,
                               int iIndent );
         char * hb_jsonEncodeCP( PHB_ITEM pValue, HB_SIZE * pnLen,
                                 int iIndent, PHB_CODEPAGE cdp );
      Positive iIndent value defines number of spaces used for indenting,
      0 disables indenting and  -1 means TAB ( ASCII:9 ) indenting.
      This modification is binary compatible though in C code using HB_TRUE
      as 3-rd parameter it changes indenting from 2 spaces to 1 so please
      update the code if it's significant.

    + added optional support for numeric value in 2-nd parameter of
      hb_jsonEncode() PRG function. Current syntax is:
         hb_jsonEncode( <xValue>, [ <lHuman> | <nIndent> ], [ <cDestCP> ] )
               -> <cJSONString>

  * contrib/rddads/ads1.c
    * minor simplification

  * include/hbapigt.h
    * formatting

2017-11-14 20:44 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/hbwin.hbx
  * contrib/hbwin/wapi_winbase_2.c
    + added PRG wrapper to QueryDosDevice() WINAPI function
         wapi_QueryDosDevice( <cDeviceName> ) -> <aResults>

2017-11-14 20:30 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rdd/dbf1.c
    ! fixed typo in index used inside DBS_ISNULL
    ! fixed blanking new record for variable length unicode fields (Q:U)
    ; above fix problems reported by KevinC - many thanks for information
      about the problems and self contain examples - such support really
      helps
    * added protection against possible GPF when corrupted Q:U fields are
      read from DBF file

2017-11-14 19:44 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbmzip/mzip.c
    * use 'char *' instead of 'zipcharpc' to compile with minizip versions
      which do not define 'zipcharpc' type

2017-10-18 10:07 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/hbwin.ch
  * contrib/hbwin/hbwin.hbx
  * contrib/hbwin/wapi_winuser_2.c
    + added PRG wrapper
         wapi_MessageBoxTimeout( <phWnd>, <cText>, <cCaption>, ;
                                 <nType>, <nLangId>, <nTimeout> )
               -> <messageBox_results> | WIN_MB_TIMEDOUT
      to undocumented MS-Windows function MessageBoxTimeout().
      This function exists in all MS-Windows versions and is used internally
      by MessageBox() and MessageBoxEx() with 0xFFFFFFFF timeout.

  * contrib/hbwin/win_svc_2.c
  * src/common/hbfopen.c
    ! fixed POCC and XCC builds

2017-09-28 15:11 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/pp/ppcore.c
    ! fixed memory leak in unclosed extended block

2017-09-28 14:55 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/pp/ppcore.c
    ! fixed line numbering in unclosed extended block
    * interrupt extended block processing if it contains internal
      FUNCTION or PROCEDURE declaration

  * include/hbcompdf.h
  * src/compiler/complex.c
  * src/compiler/harbour.y
  * src/compiler/hbmain.c
    ! fixed possible GPF when FUNCTION/PROCEDURE starts in unclosed
      control structure - thanks to Abe Buchinger for information
      about the problem
    * report all unclosed control structures when FUNCTION/PROCEDURE starts

  * src/compiler/harbour.yyc
  * src/compiler/harbour.yyh
    * regenerated

2017-09-27 09:24 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * include/hbgtinfo.ch
    * sync HB_GTI_* values between 3.2 and 3.4

2017-09-26 14:54 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbmemio/memio.c
    ! fixed FO_TRUNC attribute in MEM: file IO - thanks to Miroslav Georgiev
      for information about the problem

  * include/hbgtinfo.ch
  * src/rtl/gtwvt/gtwvt.h
  * src/rtl/gtwvt/gtwvt.c
    + added new hb_gtInfo() action HB_GTI_SYSMENUADD
      It allows to add new items to window system menu which
      selected add defined by user key code into keyboard queue, i.e.
         hb_gtInfo( HB_GTI_SYSMENUADD, HB_K_MENU, "Settings" )
    * In WinCE builds use DeleteMenu() + AppendMenu() instead of
      missing ModifyMenu()
    ! pacified warning in non UNICODE builds

2017-09-22 17:39 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * src/compiler/hbcomp.c
    ! revert an accidental sync with 3.4 resulting in .prg source
      filenames being included in the compiled source only in debug mode.
      It's now restored to have these at all times.
      The comment typo in the same line remains synced.
      Ref: https://groups.google.com/d/msg/harbour-devel/7c-EyPWxjfg/ei84cbsvAQAJ

2017-09-18 17:15 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/hbfimage/core.c
    ! fix merge mistake in 0caff16650eedfee8a48494efb213e79a51f5ff4
      Ref: https://groups.google.com/d/msg/harbour-users/_7sIZaql0JU/DiCwMgyEAgAJ

2017-09-15 22:05 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * src/pp/Makefile
    ! sync a missing variable rename with 3.4 fork
      Ref: https://groups.google.com/d/msg/harbour-users/_7sIZaql0JU/zZSvz1SbAQAJ

2017-09-14 23:00 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/hbmisc/tests/pe.prg
  * contrib/hbpost.hbm
  * contrib/hbpre.hbm
  * contrib/make.hb
    * sync text and minor code/comment updates with the 3.4 fork

2017-09-13 21:33 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * bin/check.hb
  * contrib/gtwvw/*
    * sync some text with the 3.4 fork

2017-09-13 21:17 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * bin/3rdpatch.hb
      ; 2017-08-24 19:43 UTC Viktor Szakats (vszakats users.noreply.github.com)
    + add support for .tar.lz/.tlz archive format
      ; 2017-02-13 12:05 UTC Viktor Szakats (vszakats users.noreply.github.com)
    * remove enforcing 8+3 naming on vendored sources.
      This may break MS-DOS builds where original long source filenames
      get restored and also for new components. one solution is to use
      non-vendored builds of the affected components, where this problem
      should be solved.
      The upside is that the patches become simpler and vendored code
      won't as much diverge from originals and their forks/copies.
      It generally makes working with these vendored sources much less
      cumbersome.
      ; 2017-01-04 01:04 UTC Viktor Szakats (vszakats users.noreply.github.com)
    + make sure to keep original timestamps while copying and
      doctoring files. Generated .dif files now contain correct
      timestamps for original files.
    + always strip exec attribute from sources (libharu needs this)
      ; 2017-01-03 16:01 UTC Viktor Szakats (vszakats users.noreply.github.com)
    * do not leak local TZ in generated .dif files
      ; 2016-01-24 11:56 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    ! allow source URLs with '?' in them by not stripping the parameter
      part. Some files require this (ie. jpeg source package). Such URLs
      are not used in this repository anymore and committers should make
      sure they are not readded.
      ; 2015-12-18 18:42 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    * update shebang to work regardless of where Harbour resides on the system,
      will now work if hbmk2 is found anywhere in PATH
      ; 2015-11-29 19:10 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    ! another attempt to fix EOL issue in `diff`, this time the
      option introduced in the last update turns out to not be
      supported by the older `diff` version found in El Capitan,
      so falling back another option (untested)
    + show error and exit in case of a `diff` command failure
      ; 2015-11-29 18:34 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    ! fix to not use an unsupported 'tar' option on darwin and bsd platforms
      ; 2015-11-15 18:39 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    ! fix regression to ignore only the line-trailing whitespaces
      (not all of them)
      ; 2015-11-02 23:54 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    + add -w option to 'patch' command to ignore whitespace changes,
      thus avoiding problems caused by EOL-style differences
      ; 2015-10-18 15:49 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    * diff to ignore all whitespace, mainly to avoid excessive
      diffs due to different eol-style (it may also be useful
      to avoid unnecessary diffs due to whitespaces at eol and eof)
      ; 2015-10-15 21:34 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    % optimize function that normalizes filenames in diff files
    ! fix function that normalizes filenames in diff files to not lose
      content when it doesn't end with a newline
      ; 2015-04-20 00:23 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    + make sure not to allow protocol downgrade on redirects
      ; 2014-11-26 14:59 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    * deleted editor-specific configuration comment
    ! fixed infinite loop due to 1b5142c162463dc7abed564c30f09146e74d9ab7
    % use hb_cwd(), hb_FName*(), hb_DirSep*() (also fixes potential portability issues)
      ; 2014-07-15 23:04 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    * use VF IO, ATail(), cleanups, URL updates, etc

2017-09-13 18:04 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/hbrun/hbrun.hbp
  * ChangeLog.txt
  * package/harbour-wce.spec.in
  * package/harbour-win.spec.in
  * package/harbour.spec
  * package/mpkg_rpm_wce.sh
  * package/mpkg_rpm_win.sh
  * package/mpkg_rpm.sh
  * package/mpkg_src.sh
  * package/mpkg_ver.sh
  * package/mpkg_win.nsi
  * package/winuni/mpkg_win_uni.nsi
  * utils/hbmk2/hbmk2.hbp
  * utils/hbmk2/hbmk2.prg
  * utils/hbmk2/Makefile
  * package/harb_osx.icns -> package/harbour.icns
  * package/harb_win.ico -> package/harbour.ico
  * package/harb_win.mft -> package/harbour.mft
  * package/harb_win.rc -> package/harbour.rc
  * utils/hbmk2/hbmk2.rc -> utils/hbmk2/harbour.rc
    * sync more file renames with the 3.4 fork
      NOTE: some projects used to rely on harb_win.ico. This will
      not work anymore and these will need to be updated or even
      better fixed to rely on it local .ico file instead.
    * sync bash formatting and fixes. Formatting guidelines here
      https://google.github.io/styleguide/shell.xml
    * sync two hbmk2 macro names

2017-09-13 17:02 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * config/dyn.mk
    * sync a missed variable rename

2017-09-13 14:39 UTC Viktor Szakats (vszakats users.noreply.github.com)
  + contrib/hbcomm/DEPRECATED.txt
  * contrib/hbgd/tests/counter.prg
  * contrib/hbgd/tests/imgs_in/57chevy.gif -> contrib/hbgd/tests/imgs_in/d57chevy.gif
  * contrib/hbgd/tests/imgs_in/7seg.gif -> contrib/hbgd/tests/imgs_in/d7seg.gif
  * contrib/hbgd/tests/imgs_in/brsd.gif -> contrib/hbgd/tests/imgs_in/dbrsd.gif
  * contrib/hbgd/tests/imgs_in/fdb.gif -> contrib/hbgd/tests/imgs_in/dfdb.gif
  * contrib/hbgd/tests/imgs_in/jelly.gif -> contrib/hbgd/tests/imgs_in/djelly.gif
  * contrib/hbgd/tests/imgs_in/odb.gif -> contrib/hbgd/tests/imgs_in/dodb.gif
  * contrib/hbgd/tests/imgs_in/odw.gif -> contrib/hbgd/tests/imgs_in/dodw.gif
  * contrib/hbgd/tests/imgs_in/pdg.gif -> contrib/hbgd/tests/imgs_in/dpdg.gif
  * contrib/hbgd/tests/imgs_in/pdw.gif -> contrib/hbgd/tests/imgs_in/dpdw.gif
    * some more sync with 3.4 fork

2017-09-13 14:32 UTC Viktor Szakats (vszakats users.noreply.github.com)
  - extras/guestbk/cgi.ch
  - extras/guestbk/guestbk.hbp
  - extras/guestbk/guestbk.txt
  * .gitattributes
  * contrib/hbgd/tests/counter.prg
  * contrib/hbhttpd/core.prg
  * contrib/hbgd/tests/digits/57chevy.gif -> contrib/hbgd/tests/imgs_in/57chevy.gif
  * contrib/hbgd/tests/digits/7seg.gif -> contrib/hbgd/tests/imgs_in/7seg.gif
  * contrib/hbgd/tests/digits/brsd.gif -> contrib/hbgd/tests/imgs_in/brsd.gif
  * contrib/hbgd/tests/digits/digib.gif -> contrib/hbgd/tests/imgs_in/digib.gif
  * contrib/hbgd/tests/digits/fdb.gif -> contrib/hbgd/tests/imgs_in/fdb.gif
  * contrib/hbgd/tests/digits/jelly.gif -> contrib/hbgd/tests/imgs_in/jelly.gif
  * contrib/hbgd/tests/digits/odb.gif -> contrib/hbgd/tests/imgs_in/odb.gif
  * contrib/hbgd/tests/digits/odw.gif -> contrib/hbgd/tests/imgs_in/odw.gif
  * contrib/hbgd/tests/digits/pdg.gif -> contrib/hbgd/tests/imgs_in/pdg.gif
  * contrib/hbgd/tests/digits/pdw.gif -> contrib/hbgd/tests/imgs_in/pdw.gif
  * contrib/hbhttpd/tests/tpl/_main.tpl -> contrib/hbhttpd/tests/tpl/_main.html
  * contrib/hbhttpd/tests/tpl/app/account/edit.tpl -> contrib/hbhttpd/tests/tpl/app/account/edit.html
  * contrib/hbhttpd/tests/tpl/app/account.tpl -> contrib/hbhttpd/tests/tpl/app/account.html
  * contrib/hbhttpd/tests/tpl/app/cart.tpl -> contrib/hbhttpd/tests/tpl/app/cart.html
  * contrib/hbhttpd/tests/tpl/app/login.tpl -> contrib/hbhttpd/tests/tpl/app/login.html
  * contrib/hbhttpd/tests/tpl/app/logout.tpl -> contrib/hbhttpd/tests/tpl/app/logout.html
  * contrib/hbhttpd/tests/tpl/app/main.tpl -> contrib/hbhttpd/tests/tpl/app/main.html
  * contrib/hbhttpd/tests/tpl/app/register.tpl -> contrib/hbhttpd/tests/tpl/app/register.html
  * contrib/hbhttpd/tests/tpl/app/shopping.tpl -> contrib/hbhttpd/tests/tpl/app/shopping.html
  * extras/gtwvw/docs/funclist.txt -> contrib/gtwvw/doc/funclist.txt
  * extras/gtwvw/docs/gtwvw.txt -> contrib/gtwvw/doc/gtwvw.txt
  * extras/gtwvw/docs/whatsnew.txt -> contrib/gtwvw/doc/ChangeLog.txt
  * extras/gtwvw/gtwvw.hbc -> contrib/gtwvw/gtwvw.hbc
  * extras/gtwvw/gtwvw.hbx -> contrib/gtwvw/gtwvw.hbx
  * extras/gtwvw/gtwvwd.c -> contrib/gtwvw/gtwvwd.c
  * extras/gtwvw/hbgtwvw.h -> contrib/gtwvw/hbgtwvw.h
  * extras/gtwvw/hbole.h -> contrib/gtwvw/hbole.h
  * extras/gtwvw/tests/_wvwmous.prg -> contrib/gtwvw/tests/_wvwmous.prg
  * extras/gtwvw/tests/def2.bmp -> contrib/gtwvw/tests/def2.bmp
  * extras/gtwvw/tests/dia_excl.ico -> contrib/gtwvw/tests/dia_excl.ico
  * extras/gtwvw/tests/drawimg.prg -> contrib/gtwvw/tests/drawimg.prg
  * extras/gtwvw/tests/ebtest7.prg -> contrib/gtwvw/tests/eb7.prg
  * extras/gtwvw/tests/hbmk.hbm -> contrib/gtwvw/tests/hbmk.hbm
  * extras/gtwvw/tests/vouch1.bmp -> contrib/gtwvw/tests/vouch1.bmp
  * extras/gtwvw/tests/vouch1.gif -> contrib/gtwvw/tests/vouch1.gif
  * extras/gtwvw/wvt2wvw.ch -> contrib/gtwvw/wvt2wvw.ch
  * extras/gtwvw/wvwcheck.c -> contrib/gtwvw/checkbox.c
  * extras/gtwvw/wvwdraw.c -> contrib/gtwvw/wvwdraw.c
  * extras/gtwvw/wvwedit.c -> contrib/gtwvw/editbox.c
  * extras/gtwvw/wvwfuncs.c -> contrib/gtwvw/wvwutils.c
  * extras/gtwvw/wvwmenu.c -> contrib/gtwvw/menubar.c
  * extras/gtwvw/wvwpush.c -> contrib/gtwvw/pushbut.c
  * extras/gtwvw/wvwstbar.c -> contrib/gtwvw/statbar.c
  * extras/gtwvw/wvwtbar.c -> contrib/gtwvw/toolbar.c
  * extras/guestbk/guestbk.html -> tests/guestbk.html
  * extras/hbdoc/hbdoc.css -> contrib/hbdoc/hbdoc.css
  * extras/gtwvw/gtwvw.hbp -> contrib/gtwvw/gtwvw.hbp
  * extras/gtwvw/tests/cbtest1.prg -> contrib/gtwvw/tests/cb1.prg
  * extras/gtwvw/tests/cbtest6.prg -> contrib/gtwvw/tests/cb6.prg
  * extras/gtwvw/tests/inpfocus.prg -> contrib/gtwvw/tests/inpfocus.prg
  * extras/gtwvw/tests/maincoor.prg -> contrib/gtwvw/tests/maincoor.prg
  * extras/gtwvw/tests/maximize.prg -> contrib/gtwvw/tests/maximize.prg
  * extras/gtwvw/tests/prog0.prg -> contrib/gtwvw/tests/prog0.prg
  * extras/gtwvw/tests/prog1.prg -> contrib/gtwvw/tests/prog1.prg
  * extras/gtwvw/tests/prog2.prg -> contrib/gtwvw/tests/prog2.prg
  * extras/gtwvw/tests/readme.txt -> contrib/gtwvw/tests/readme.txt
  * extras/gtwvw/tests/wvwtest9.prg -> contrib/gtwvw/tests/demo.prg
  * extras/guestbk/_cgi.prg -> tests/cgi.prg
  * extras/guestbk/_inifile.prg -> tests/inifile.prg
  * extras/guestbk/guestbk.ini -> tests/guestbk.ini
  * extras/guestbk/guestbk.prg -> tests/guestbk.prg
  * extras/hbdoc/_genbase.prg -> contrib/hbdoc/_base.prg
  * extras/hbdoc/_genhtml.prg -> contrib/hbdoc/_html.prg
  * extras/hbdoc/_gentxt.prg -> contrib/hbdoc/_txt.prg
  * extras/hbdoc/_genxml.prg -> contrib/hbdoc/_xml.prg
  * extras/hbdoc/hbdoc.hbp -> contrib/hbdoc/hbdoc.hbp
  * extras/hbdoc/hbdoc.prg -> contrib/hbdoc/hbdoc.prg
    * more file/dir rename sync with 3.4 fork, plus some related file content

2017-09-13 12:49 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/gtqtc/gtqtc.hbp
  * contrib/hbssl/ssl_hbcon.prg
  * contrib/gtqtc/hbmk2_qtmoc.hb -> contrib/gtqtc/hbmk2_qtgt.hb
    * more syncs with 3.4 fork. One rename, some content syncs
      after renames.

2017-09-13 12:41 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/hbmxml/3rd/minixml/mxml.hbp
  * contrib/hbmxml/3rd/minixml/minixml.diff -> contrib/hbmxml/3rd/minixml/mxml.diff
    * one more sync with 3.4 fork

2017-09-13 12:38 UTC Viktor Szakats (vszakats users.noreply.github.com)
  - doc/en/hashes.txt
  - doc/en/rdddb.txt
  * .gitattributes
  * contrib/3rd/sqlite3/sqlite3.hbp
  * contrib/hbbz2/3rd/bz2/bz2.hbp
  * contrib/hbexpat/3rd/expat/expat.hbp
  * contrib/hbfimage/hbfimage.hbp
  * contrib/hbhpdf/3rd/libhpdf/libhpdf.hbp
  * contrib/hblzf/3rd/liblzf/lzf.hbp
  * contrib/hbmxml/3rd/minixml/mxml.hbp
  * contrib/hbmzip/3rd/minizip/minizip.hbp
  * contrib/hbodbc/hbodbc.hbp
  * contrib/hbtinymt/3rd/tinymt/tinymt.hbp
  * contrib/hbxdiff/3rd/libxdiff/xdiff.hbp
  * contrib/sddsqlt3/tests/test.prg
  * ChangeLog.txt
  * doc/Makefile
  * doc/oldnews.txt
  * extras/ps32/readme.txt
  * extras/superlib/readme.txt
  * src/3rd/jpeg/Makefile
  * src/3rd/pcre/Makefile
  * src/3rd/png/Makefile
  * src/3rd/tiff/Makefile
  * src/3rd/zlib/Makefile
  + contrib/hbsms/DEPRECATED.txt
  + contrib/hbtpathy/DEPRECATED.txt
  + contrib/xhb/WARNING.txt
  * contrib/3rd/sqlite3/sqlite3.dif -> contrib/3rd/sqlite3/sqlite3.diff
  * contrib/hbbz2/3rd/bz2/bz2.dif -> contrib/hbbz2/3rd/bz2/bz2.diff
  * contrib/hbexpat/3rd/expat/expat.dif -> contrib/hbexpat/3rd/expat/expat.diff
  * contrib/hbhpdf/3rd/libhpdf/libhpdf.dif -> contrib/hbhpdf/3rd/libhpdf/libhpdf.diff
  * contrib/hblzf/3rd/liblzf/liblzf.dif -> contrib/hblzf/3rd/liblzf/liblzf.diff
  * contrib/hbmxml/3rd/minixml/minixml.dif -> contrib/hbmxml/3rd/minixml/minixml.diff
  * contrib/hbmzip/3rd/minizip/minizip.dif -> contrib/hbmzip/3rd/minizip/minizip.diff
  * contrib/hbtinymt/3rd/tinymt/tinymt.dif -> contrib/hbtinymt/3rd/tinymt/tinymt.diff
  * contrib/hbxdiff/3rd/libxdiff/libxdiff.dif -> contrib/hbxdiff/3rd/libxdiff/xdiff.diff
  * contrib/sddsqlt3/tests/test.sq3 -> contrib/sddsqlt3/tests/test.sqlite3
  * extras/dbu/dbu52.dif -> extras/dbu/dbu52.patch
  * extras/dbu/dbu53.dif -> extras/dbu/dbu53.patch
  * extras/ps32/ps32.dif -> extras/ps32/ps32.patch
  * extras/rl/rl.dif -> extras/rl/rl.patch
  * extras/superlib/superlib.dif -> extras/superlib/superlib.patch
  * extras/template/readme.txt -> extras/template/README.md
  * src/3rd/hbdossrl/README -> src/3rd/hbdossrl/README.txt
  * src/3rd/jpeg/jpeg.dif -> src/3rd/jpeg/jpeg.diff
  * src/3rd/pcre/pcre.dif -> src/3rd/pcre/pcre.diff
  * src/3rd/png/png.dif -> src/3rd/png/png.diff
  * src/3rd/tiff/tiff.dif -> src/3rd/tiff/tiff.diff
  * src/3rd/zlib/zlib.dif -> src/3rd/zlib/zlib.diff
  * tests/hbpptest/_pp_test.prg -> tests/hbpp/_pp_test.prg
  * tests/hbpptest/compare.hb -> tests/hbpp/compare.hb
  * tests/hbpptest/hbpptest.hbp -> tests/hbpp/hbpptest.hbp
  * tests/hbpptest/hbpptest.prg -> tests/hbpp/hbpptest.prg
  * tests/tflock.prg -> tests/flock.prg
  * contrib/hbfimage/fi_wrp.c -> contrib/hbfimage/core.c
  * contrib/hbodbc/browodbc.prg -> contrib/hbodbc/browse.prg
  * doc/cmdline.txt -> doc/cmdline.md
  * extras/dbu/readme.txt -> extras/dbu/README.md
  * extras/rl/readme.txt -> extras/rl/README.md
    * some file renames synced with 3.4 fork, plus the content of
      some of them. Some new text files added as well.
      Note, 3rd party code rediffing won't work anymore on 8.3
      filesystems.

2017-09-13 11:57 UTC Viktor Szakats (vszakats users.noreply.github.com)
  + src/rdd/usrrdd/rdds/arrayrdd.prg -> contrib/rddmisc/arrayrdd.prg
  + src/rdd/usrrdd/rdds/dbtcdx.prg -> contrib/rddmisc/dbtcdx.prg
  + src/rdd/usrrdd/rdds/fptcdx.prg -> contrib/rddmisc/fptcdx.prg
  + src/rdd/usrrdd/rdds/hscdx.prg -> contrib/rddmisc/hscdx.prg
  + src/rdd/usrrdd/rdds/logrdd.prg -> contrib/rddmisc/logrdd.prg
  + src/rdd/usrrdd/rdds/rlcdx.prg -> contrib/rddmisc/rlcdx.prg
  + src/rdd/usrrdd/rdds/smtcdx.prg -> contrib/rddmisc/smtcdx.prg
  + src/rdd/usrrdd/rdds/vfpcdx.prg -> contrib/rddmisc/vfpcdx.prg
  * src/rdd/usrrdd/rdds/arrayrdd.prg
  * src/rdd/usrrdd/rdds/dbtcdx.prg
  * src/rdd/usrrdd/rdds/fptcdx.prg
  * src/rdd/usrrdd/rdds/hscdx.prg
  * src/rdd/usrrdd/rdds/logrdd.prg
  * src/rdd/usrrdd/rdds/rlcdx.prg
  * src/rdd/usrrdd/rdds/smtcdx.prg
  * src/rdd/usrrdd/rdds/vfpcdx.prg
    * move usrrdd sources to contrib/rddmisc to have the source tree
      in sync with 3.4 fork, where these were converted to a contrib.
      In 3.2 they will still be compiled into core with an #include
      trick.

2017-09-13 11:40 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * config/*/*.mk
  * config/*.mk
  * config/postinst.hb
  * ChangeLog.txt
  * src/rdd/usrrdd/rdds/*.prg
    * sync with 3.4 fork minor code changes, comments, some strings

2017-09-12 23:01 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * utils/hbmk2/hbmk2.prg
    * sync with 3.4 fork minor code changes, comments, some strings

2017-09-12 15:34 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * ChangeLog.txt
    * sync with 3.4 fork all entried on or before 2013-04-10 (the time
      of the fork)

2017-09-12 15:17 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * doc/Makefile
  * doc/howtorep.txt -> doc/howtovcs.txt
    * sync with 3.4 fork

2017-09-12 15:13 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * bin/check.hb
  * config/*/*.mk
  * contrib/gtwvg/wvgwing.c
  * contrib/hbcomm/comm.prg
  * contrib/hbfbird/tfirebrd.prg
  * contrib/hbfimage/fi_wrp.c
  * contrib/hbformat/hbfmtcls.prg
  * contrib/hbformat/utils/hbformat.prg
  * contrib/hbhttpd/core.prg
  * contrib/hbnetio/utils/hbnetio/hbnetio.prg
  * contrib/hbnetio/utils/hbnetio/netiomgm.hb
  * contrib/hbsqlit3/hdbc.prg
  * contrib/hbwin/win_bmp.c
  * contrib/xhb/htmutil.prg
  * contrib/xhb/thtm.prg
  * contrib/xhb/xhbarr.c
  * contrib/xhb/xhbtedit.prg
  * ChangeLog.txt
  * debian/control
  * debian/copyright
  * doc/*.txt
  * LICENSE.txt
  * package/harbour.spec
  * README.md
  * src/compiler/hbusage.c
  * src/pp/hbpp.c
  * src/rtl/memoedit.prg
  * src/rtl/teditor.prg
  * src/rtl/tget.prg
  * src/rtl/version.c
  * utils/hbi18n/hbi18n.prg
  * utils/hbmk2/hbmk2.prg
  * utils/hbmk2/po/hbmk2.hu.po
  * utils/hbtest/hbtest.prg
    * sync with 3.4 fork (no change in functionality)
      CC3 -> CC4 license, copyright banners, some strings, minor
      code changes, doc folder, TOFIX -> FIXME

2017-09-12 10:19 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/gtwvg/class.prg
  * contrib/gtwvg/menubar.prg
  * contrib/gtwvg/paint.prg
  * contrib/gtwvg/tests/_activex.prg
  * contrib/gtwvg/tests/_dyndlgs.prg
  * contrib/gtwvg/tests/_modal.prg
  * contrib/gtwvg/tests/_tbrowse.prg
  * contrib/gtwvg/tests/_utils.prg
  * contrib/gtwvg/tests/_wvtcls.prg
  * contrib/gtwvg/tests/_xbp.prg
  * contrib/gtwvg/tests/demowvg.prg
  * contrib/gtwvg/tests/demowvg1.prg
  * contrib/gtwvg/tests/demoxbp.prg
  * contrib/hbhttpd/core.prg
  * contrib/hbhttpd/tests/eshop.prg
  * contrib/hbhttpd/widgets.prg
  * contrib/hbtip/thtml.prg
  * src/debug/dbgtobj.prg
  * src/rdd/hbsix/sxini.prg
  * src/rtl/hbi18n2.prg
  * src/rtl/tbrowse.prg
  * utils/hbtest/rt_array.prg
    * sync with 3.4 fork (no change in functionality)

2017-09-11 20:36 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/hbwin/hbwin.hbp
  * contrib/hbwin/wapi_winbase.c -> contrib/hbwin/wapi_winbase_1.c
  * contrib/hbwin/wapi_winuser.c -> contrib/hbwin/wapi_winuser_1.c
  * contrib/hbwin/win_misc.c -> contrib/hbwin/win_misc_1.c
  + contrib/hbwin/wapi_winbase_2.c
  + contrib/hbwin/wapi_winuser_2.c
  + contrib/hbwin/win_misc_2.c
    % sync file-splits with 3.4 fork

  * src/rtl/val.c
    * sync with 3.4 fork (no change in functionality)

2017-09-11 18:35 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/gtwvg/*.prg
  * contrib/gtwvg/gtwgud.c
  * contrib/gtwvg/gtwvg.hbx
  * contrib/gtwvg/gtwvgd.c
  * contrib/gtwvg/wvgcore.c
  * contrib/gtwvg/wvgcuig.c
    * more sync with 3.4 fork, mostly code-style/whitespace with
      some minor optimizations

2017-09-11 13:12 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/gtqtc/gtqtc1.cpp
  * contrib/gtwvg/gtwgud.c
  * contrib/gtwvw/wvwdraw.c
  * contrib/hbamf/amfdec.c
  * contrib/hbamf/amfstdio.c
  * contrib/hbbz2io/bz2io.c
  * contrib/hbgzio/gzio.c
  * contrib/hbhpdf/core.c
  * contrib/hbmemio/memio.c
  * contrib/hbmisc/irm.c
  * contrib/hbmisc/spd.c
  * contrib/hbnetio/netiosrv.c
  * contrib/hbssl/ssl_sock.c
  * contrib/hbwin/olecore.c
  * contrib/hbwin/wapi_commctrl.c
  * contrib/hbwin/wapi_winuser.c
  * contrib/hbwin/win_bmpd.c
  * contrib/hbwin/win_misc.c
  * contrib/hbzebra/qrcode.c
  * contrib/rddads/ads1.c
  * contrib/rddads/adsfunc.c
  * contrib/rddsql/sqlmix.c
  * contrib/sddfb/core.c
  * contrib/xhb/cstructc.c
  * contrib/xhb/hboutdbg.c
  * contrib/xhb/hbserv.c
  * include/hbdefs.h
  * include/hbexprb.c
  * include/hbrddcdx.h
  * include/hbthread.h
  * include/hbwmain.c
  * src/common/hbffind.c
  * src/compiler/complex.c
  * src/compiler/hbmain.c
  * src/compiler/hbopt.c
  * src/debug/dbgentry.c
  * src/rdd/dbf1.c
  * src/rdd/dbfcdx/dbfcdx1.c
  * src/rdd/dbffpt/dbffpt1.c
  * src/rdd/dbfnsx/dbfnsx1.c
  * src/rdd/dbfntx/dbfntx1.c
  * src/rdd/hbsix/sxcompr.c
  * src/rdd/wacore.c
  * src/rdd/workarea.c
  * src/rtl/cputime.c
  * src/rtl/dates.c
  * src/rtl/gtchrmap.c
  * src/rtl/gtcrs/gtcrs.c
  * src/rtl/gtpca/gtpca.c
  * src/rtl/gtsln/gtsln.c
  * src/rtl/gtsln/kbsln.c
  * src/rtl/gtsln/keytrans.c
  * src/rtl/gtstd/gtstd.c
  * src/rtl/gttrm/gttrm.c
  * src/rtl/gtwvt/gtwvt.c
  * src/rtl/gtxwc/gtxwc.c
  * src/rtl/hbcom.c
  * src/rtl/hbproces.c
  * src/rtl/itemseri.c
  * src/rtl/langapi.c
  * src/rtl/run.c
  * src/rtl/sha1.c
  * src/rtl/space.c
  * src/vm/classes.c
  * src/vm/hvm.c
  * src/vm/itemapi.c
  * src/vm/set.c
  * src/vm/thread.c
    * convert commented C code to #if 0 blocks, or clean them up in
      different ways
      (from 3.4 fork)
2017-09-11 13:12 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/gtqtc/gtqtc1.cpp
  * contrib/gtwvg/gtwgud.c
  * contrib/gtwvw/wvwdraw.c
  * contrib/hbamf/amfdec.c
  * contrib/hbamf/amfstdio.c
  * contrib/hbbz2io/bz2io.c
  * contrib/hbgzio/gzio.c
  * contrib/hbhpdf/core.c
  * contrib/hbmemio/memio.c
  * contrib/hbmisc/irm.c
  * contrib/hbmisc/spd.c
  * contrib/hbnetio/netiosrv.c
  * contrib/hbssl/ssl_sock.c
  * contrib/hbwin/olecore.c
  * contrib/hbwin/wapi_commctrl.c
  * contrib/hbwin/wapi_winuser.c
  * contrib/hbwin/win_bmpd.c
  * contrib/hbwin/win_misc.c
  * contrib/hbzebra/qrcode.c
  * contrib/rddads/ads1.c
  * contrib/rddads/adsfunc.c
  * contrib/rddsql/sqlmix.c
  * contrib/sddfb/core.c
  * contrib/xhb/cstructc.c
  * contrib/xhb/hboutdbg.c
  * contrib/xhb/hbserv.c
  * include/hbdefs.h
  * include/hbexprb.c
  * include/hbrddcdx.h
  * include/hbthread.h
  * include/hbwmain.c
  * src/common/hbffind.c
  * src/compiler/complex.c
  * src/compiler/hbmain.c
  * src/compiler/hbopt.c
  * src/debug/dbgentry.c
  * src/rdd/dbf1.c
  * src/rdd/dbfcdx/dbfcdx1.c
  * src/rdd/dbffpt/dbffpt1.c
  * src/rdd/dbfnsx/dbfnsx1.c
  * src/rdd/dbfntx/dbfntx1.c
  * src/rdd/hbsix/sxcompr.c
  * src/rdd/wacore.c
  * src/rdd/workarea.c
  * src/rtl/cputime.c
  * src/rtl/dates.c
  * src/rtl/gtchrmap.c
  * src/rtl/gtcrs/gtcrs.c
  * src/rtl/gtpca/gtpca.c
  * src/rtl/gtsln/gtsln.c
  * src/rtl/gtsln/kbsln.c
  * src/rtl/gtsln/keytrans.c
  * src/rtl/gtstd/gtstd.c
  * src/rtl/gttrm/gttrm.c
  * src/rtl/gtwvt/gtwvt.c
  * src/rtl/gtxwc/gtxwc.c
  * src/rtl/hbcom.c
  * src/rtl/hbproces.c
  * src/rtl/itemseri.c
  * src/rtl/langapi.c
  * src/rtl/run.c
  * src/rtl/sha1.c
  * src/rtl/space.c
  * src/vm/classes.c
  * src/vm/hvm.c
  * src/vm/itemapi.c
  * src/vm/set.c
  * src/vm/thread.c
    * convert commented C code to #if 0 blocks, or clean them up in
      different ways
      (from 3.4 fork)

2017-09-08 21:38 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * debian/copyright
  * LICENSE.txt
    * partial resync with 3.4 updates

2017-09-08 18:22 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * bin/commit.hb
  * config/detect.mk
  * config/detfun.mk
  * config/detplat.mk
  * config/dir.mk
  * config/dirsh.mk
  * config/global.mk
  * config/globsh.mk
  * config/instsh.mk
  * config/lang.hb
  * config/lang2po.hb
  * config/po2lang.hb
  * config/postinst.hb
  * contrib/hbexpat/tests/tohash.prg
  * contrib/hbformat/utils/hbformat.ini
  * contrib/hbmisc/hbedit.prg
  * contrib/hbmxml/tests/testmxml.prg
  * contrib/hbnetio/utils/hbnetio/_console.prg
  * contrib/hbnetio/utils/hbnetio/_winsvc.prg
  * contrib/hbnetio/utils/hbnetio/hbnetio.prg
  * contrib/hbnetio/utils/hbnetio/netiomgm.hb
  * contrib/hbwin/tests/ole.prg
  * contrib/hbwin/tests/oletst2.js
  * contrib/hbwin/tests/oletst2.vbs
  * contrib/hbxpp/doc/en/binnumx.txt
  * contrib/hbxpp/doc/en/dbcmdx.txt
  * contrib/xhb/htmutil.prg
  * contrib/xhb/tfile.prg
  * contrib/xhb/tframe.prg
  * contrib/xhb/thtm.prg
  * ChangeLog.txt
  * debian/copyright
  * doc/class_tp.txt
  * doc/hdr_tpl.txt
  * doc/xhb-diff.txt
  * LICENSE.txt
  * package/harbour-wce.spec.in
  * package/harbour-win.spec.in
  * package/harbour.spec
  * package/mpkg_rpm_wce.sh
  * package/mpkg_rpm_win.sh
  * package/mpkg_rpm.sh
  * package/mpkg_src.sh
  * package/mpkg_ver.sh
  * src/rtl/achoice.prg
  * src/rtl/getsys53.prg
  * src/rtl/tgetlist.prg
  * src/rtl/tlabel.prg
  * src/rtl/tmenusys.prg
  * tests/hbdoc.prg
  * tests/langmsg.prg
  * tests/rto_get.prg
  * tests/rto_tb.prg
  + doc/en/ati.txt
  + doc/en/dirdrive.txt
  + doc/en/hashfunc.txt
  + doc/en/hbtoken.txt
  + doc/en/left.txt
  + doc/en/proc.txt
  + doc/en/strtran.txt
  + doc/en/transfrm.txt
  + doc/en/typefile.txt
  * doc/en/*
    * more partial sync with 3.4 fork

2017-09-08 16:00 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * *
    * partial sync with the 3.4 fork codebase. These are the things
      synces for the most part:
      - copyright headers
      - grammar/typos in comments and some readmes
      - comment/whitespace/decorations
      - variable scoping in C files
      - DO CASE/SWITCH and some other alternate syntax usage
      - minimal amount of human readable text in strings
      - minor code updates
      - HB_TRACE() void * casts for pointers and few other changes to
        avoid C compiler warnings
      - various other, minor code cleanups
      - only Harbour/C code/headers were touched in src, utils, contrib,
        include. No 3rd party code, no make files, and with just a few
        exceptions, no 'tests' code was touched.
      - certain components were not touched were 3.4 diverged too much
        already, like f.e. hbmk2, hbssl, hbcurl, hbexpat, hbnf, hbhttpd,
        etc.
      - the goal was that no actual program logic should be altered by
        these changes. Except some possible minor exceptions, any such
        change is probably a bug in this patch.
      It's a massive patch, if you find anything broken after it, please
      open an Issue with the details. Build test was done on macOS.
      The goal is make it easier to see what actual code/logic was changed
      in 3.4 compared to 3.2 and to make patches easier to apply in both
      ways.

2017-09-07 08:38 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/hbct/charsprd.c
  * contrib/hbct/dattime3.c
  * contrib/hbct/expand.c
  * contrib/hbct/misc2.c
  * contrib/hbct/screen2.c
  * contrib/hbcurl/core.c
  * contrib/hbfship/strpeek.c
  * contrib/hbnetio/netiocli.c
  * contrib/hbwin/olecore.c
  * contrib/rddads/adsx.c
  * contrib/rddads/rddads.h
  * contrib/rddsql/sqlmix.c
  * contrib/sddmy/core.c
  * contrib/sddpg/core.c
  * contrib/xhb/hbcompat.h
  * contrib/xhb/hbxml.c
  * contrib/xhb/xhb.h
  * src/common/hbstr.c
  * src/compiler/harbour.y
  * src/compiler/harbour.yyc
  * src/compiler/hbcmplib.c
  * src/macro/macrolex.c
  * src/rdd/dbffpt/dbffpt1.c
  * src/rdd/hbsix/sxcompr.c
  * src/rdd/hbsix/sxcrypt.c
  * src/rdd/hbsix/sxtable.c
  * src/rdd/hsx/hsx.c
  * src/rtl/cdpapi.c
  * src/rtl/gtcrs/gtcrs.c
  * src/rtl/gtxwc/gtxwc.c
  * src/rtl/hbtoken.c
  * src/rtl/net.c
  * src/rtl/netusr.c
  * src/vm/hvm.c
    * update HB_SIZE variable name prefixes to use `n` instead of `ul`
    % adjust some variables
    % sync variables scopes and some other minor things with 3.4 fork

2017-08-25 17:57 UTC-0800 Pritpal Bedi (bedipritpal/at/hotmail.com)
  * contrib/gtwvg/gtwgud.c
  * contrib/gtwvg/gtwvgd.c
    + Added : hb_gtinfo( HB_GTI_WINTITLE ) now returns Windows handle.
      Was a missing implementation since long.

2017-08-13 18:53 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * config/global.mk
  * config/postinst.hb
  * debian/copyright
  * doc/oldnews.txt
  * package/mpkg_win.nsi
  * package/winuni/mpkg_win_uni.bat
  * package/winuni/mpkg_win_uni.nsi
  * README.md
  * COPYING.txt -> LICENSE.txt
    * COPYING.txt -> LICENSE.txt

2017-08-13 18:27 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * *
    * update copyright headers with new FSF postal address
    * COPYING.txt -> LICENSE.txt (rest of repo to be synced)

2017-08-03 20:24 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/dirscan.prg
    ! fixed type in hb_DirRemoveAll() result - it always returned .F.

  * src/rtl/itemseri.c
    ! fixed internal error when HB_SERIALIZE_COMPRESS is passed to
      hb_Serialize() and ZLIB was not linked with application

  * src/rtl/tpersist.prg
    ! fixed deserialization of multidimensional arrays - thanks to Peter

  * contrib/rddads/ads1.c
    * pacified 'fall through' warnings

2017-07-27 18:57 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbexpat/3rd/expat/_hbconf.h
  * contrib/hbexpat/3rd/expat/xmlparse.c
    ! fixed WINCE builds
    ! fixed OpenWatcom DOS builds
    ! fixed OpenWatcom OS2 builds

  * contrib/hbexpat/3rd/expat/expat.dif
    * rediffed

  * include/harbour.hbx
  * include/hbvm.h
  * src/harbour.def
  * src/vm/hvm.c
  * src/vm/thread.c
    + added new C function
         HB_BOOL hb_vmThreadIsMain( void * );
      it checks if given or current thread is main HVM thread
    + added new PRG function
         hb_threadIsMain( [ <pThID> ] ) -> <lMainHvmThread>
      it returns true if given or current thread is main HVM thread
    + added new PRG function
         hb_mutexExists( <pMtx> ) -> <lExists>
      it returns true if passed <pMtx> parameter is pointer item to
      fully functional mutex

  * src/rtl/tpersist.prg
    ! fixed problem with array item deserialization - many thanks
      to Peter Rees for exact information about the problem.

  * src/rtl/val.c
    * minor simplification

2017-07-03 18:36 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    ! reverted order of indexes and dimensions in conversions of
      multidimensional arrays.
      This modification affects both conversions (1) from Harbour array
      to OLE variant SafeArray and (2) from OLE variant SafeArray to Harbour
      array. The first one is new Harbour extension of __oleVariantNew() so
      here above modification should not create any backward compatibility
      problems but the second interacts with code which existed in Harbour
      from early OLE implementation so if someone already encoded hacks
      to revert array indexes and dimensions at .prg level then now he has
      to remove it.
      Please not that above modification affects only for multidimensional
      OLE typed arrays. It does not change anything for single dimension
      arrays or single dimension arrays of variants which contains other
      similar arrays in their items.

2017-06-27 12:37 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    + added support for multidimensional typed OLE arrays, now
      __oleVariantNew() accepts the following parameters:
         __oleVariantNew( <nVariantType>, [<xInitValue>], [<nDims,...>] )
               -> <pVariant>
      i.e.:
         pOleArray := __oleVariantNew( WIN_VT_VARIANT, aVal, ;
                                       len( aVal ), len( aVal[ 1 ] ) )
         pOleArray2 := __oleVariantNew( WIN_VT_I4, ;
                                        { { 1, 2, 3 }, { 4, 5, 6 } }, 2, 3 )
      If initialization array is smaller the declared size then in OLE array
      uninitialized items have default value for given type. NIL array items
      are ignored other non array values in nodes generate errors. Strings
      can be used on last level to initialize OLE arrays with ASCII values of
      their characters.
      Please test it in real MS-Window environment.

  * contrib/hbexpat/3rd/expat/_hbconf.h
    ! fixed MS-Windows builds

2017-06-27 10:42 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  + contrib/hbexpat/3rd/expat/siphash.h
    + new expat file, missing in previous commit by mistake

  * ChangeLog.txt
    * formatting

2017-06-26 08:55 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbexpat/3rd/expat/*
    ! updated to 2.2.1 (from 2.1.0) using 3rdpatch.hb, expat.dif(f) from
      Viktor's 3.4 fork was used - but adapted for DOS 8.3 naming
      scheme. According to issue #157, previous revisions of expat have
      security vulnerabilities, for more information refer to:
      https://github.com/libexpat/libexpat/blob/master/expat/Changes
      Many thanks to Sebastian Pipping for the information.

  * contrib/hbexpat/hbexpat.ch
    + new constant HB_XML_ERROR_INVALID_ARGUMENT added

2017-05-20 02:25 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * utils/hbmk2/hbmk2.prg
    * remove `_HBSHELL_EXEC_PRE` macro
    + add `_HBSHELL_EXTRA_HEADER` macro that can be defined to a header
      (.ch) filename which will be included in all dot prompt and script
      execution sessions. The header will also be embedded in
      hbmk2/hbrun at build-time, so it's not necessary to be present at
      runtime. The macro may also be defined in the `hbmk2_extra.prg`
      source.

2017-05-19 17:03 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * utils/hbmk2/hbmk2.prg
    + add ability to inject extra code/directives to the hbmk2/hbrun source
      code at build time. It can be enabled by defining
      `_HBMK2_EXTRA_CODE`, when a source file named `hbmk2_extra.prg` will
      be included between the header and code section of hbmk2.prg.
    + display note when above option is enabled
    + add ability to prepend extra code before the shell execution stub via
      the `_HBSHELL_EXEC_PRE` macro. It's initialized by an empty string in
      a default build. This macro can be redefined at will by
      `hbmk2_extra.prg`.

  ; commit backported to 3.2 from the 3.4 fork:
    2017-05-14 19:35 UTC Viktor Szakats (vszakats users.noreply.github.com)
    https://github.com/vszakats/harbour-core/commit/1ee9a9c6dcf10a49b2f0973fa8357990b823bca4

2017-05-19 16:08 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * config/android/gcc.mk
  * config/global.mk
  * config/linux/gcc.mk
  * config/postinst.hb
  * contrib/hbpost.hbm
    ! removed version number from dynamic libraries for Android.
      Pure Linux style dynamic library numbers in Android systems can be used
      only with system libraries but it's not supported inside .apk packages
      so our dynamic libraries were unusable for Android programmers unless
      someone plans to install more then one version of Harbour dynamic
      libraries as Android system libraries. It's rather unusual situation
      and I believe that in such case he can easy create such libraries
      building Harbour for Linux with NDK.
    * enabled by default building contrib dynamic libraries in Harbour
      Android build.
    + added -Wl,--no-undefined to linker parameters when dynamic libraries
      are created to verify if dynamic libraries can be used in Android .apk
      packages during Harbour build process.
    ; After above modification dynamic (*.so) libraries created in Harbour
      build process can be used in .apk packages. It means that projects
      like HDroidGUI do not longer need their own custom versions of
      libharbour.so but can use the one from standard Harbour Android build.
      They can also use Harbour contrib dynamic libraries.
    ; TODO: add support for automatic NDK detection in Harbour build process
    ; TODO: add to HBMK2 basic support for generating .apk packages

  * contrib/gtqtc/gtqtc.hbp
    * disabled dynamic GTQTC library in Android builds until we set explicit
      bindings with QT/C++ dynamic libs

2017-05-19 00:54 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/rddads/ads1.c
    + added support for "VarCharFox" and "VarBinaryFox" field types.
    ! fixed accessing "VarChar" fields longer then their size defined in
      table header (rest of longer fields is stored in memo file)
    ! do not reduce size of data stored in "VarChar" fields to the size
      of region allocated for them in table record. Such fields allows
      to store up to 64000 bytes and rest is saved in memo file.
    ! fixed RTE when strings longer then 64000 bytes are assigned to
      "VarChar" fields.
    ! fixed RTE when strings longer then declared field size are assigned
      to Unicode character fields (i.e. "nChar" or "C:U")
    ! fixed possible use of memcpy() with the same source and destination
      addresses

2017-05-15 14:34 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbgs/hbgs.hbp
    ! respect HB_BUILD_3RDEXT=no

  * contrib/hbwin/olecore.c
    ! fixed updating unnamed parameters passed by reference together
      with named parameters

2017-05-12 22:17 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    ! do not use SafeArrayGetVartype() with some chosen builds C compilers
      which do not support it

2017-05-12 21:18 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    * changed tagVARIANT member used in hack extracting variant value
      address from ullVal to bVal to avoid problems with some old header
      files which do not support LONGLONG values

2017-05-12 17:37 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    + added support for typed variant array references created
      by __oleVariantNew()

2017-05-12 17:21 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/oleauto.prg
  * contrib/hbwin/olecore.c
  * contrib/hbwin/hbwin.hbx
    * code cleanups and some synchronizations with Viktor's branch
    + added new PRG function borrowed from Viktor's branch:
         win_oleClassExists( <cOleName> | <cCLSID> ) -> <lExists>

2017-05-12 14:12 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    + added support for typed variant references created by __oleVariantNew()

2017-05-12 09:57 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    + added support for VT_VARIANT items to __oleVariantNew()

2017-05-11 18:05 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    * create resizable array instead of fixed size array when empty OLE
      array is created by __oleVariantNew()

2017-05-10 17:21 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    + added functions which changes default method of NIL conversion to
      OLE variant:
         __oleVariantNil2Null( [<lNewNil2NullFlag>] ) -> <lPrevNil2NullFlag>
      By default NIL values passed to foreign OLE code are converted to
      VT_EMPTY variants. __oleVariantNil2Null( .t. ) changes this behavior
      so NIL values are converted to VT_NULL variants.
    ; Warning: This function was added for tests. Looks that it's expected
               behavior for communication with MS-Excel and allows to use
               NIL as default parameter value but potentially it may create
               problems with some custom OLE interfaces so this modification
               should be widely tested in real life before we change the
               default behavior.

2017-05-10 16:39 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    - removed support for VT_DECIMAL and VT_PTR arrays from
      __oleVariantNew() - I found in MSDN that such types are
      unsupported in SAFEARRAYs
    ! fixed indexes in array conversion in __oleVariantNew()
    ! fixed conversion to VT_BSTR arrays in __oleVariantNew()

2017-05-10 12:27 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    + automatically add WIN_VT_ARRAY bit in 1st parameter of
      __oleVariantNew() when 2nd parameter is an array
    + added support for typed variant arrays to __oleVariantNew()
      Now it's possible to create strong typed one dimensional arrays and
      pass them as parameters to foreign OLE code, i.e.
         oOle:setArrayOfStrings( ;
               __oleVariantNew( WIN_VT_BSTR, { "1st", "2nd", "3rd" } ) )
         oOle:setArrayOfIntegers( ;
               __oleVariantNew( WIN_VT_INT, { 1, 2, 3, 4 } )
    + added support for array of integers initialization from strings
      passed to __oleVariantNew() in 2nd parameter.
      Now it's possible to create strong typed one dimensional OLE array
      initialized with string bytes ASCII values, i.e.
         oOle:setUcharStr( ;
               __oleVariantNew( hb_bitOr( WIN_VT_ARRAY, WIN_VT_UI8 ), ;
                                "ABCDEF" ) )
         oOle:setArrayOfIntegers( ;
               __oleVariantNew( hb_bitOr( WIN_VT_ARRAY, WIN_VT_INT ), ;
                                "ABCDEF" ) )
    ; warning: code not tested at all, written in my Linux box,
               please make real life tests in MS-Windows

2017-05-10 07:55 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    * minor modification in order of helper functions

2017-05-10 07:50 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    * added additional protection to reduce hb_oleSafeArrayToString()
      functionality to arrays of VT_I1 and VT_UI1 items so other types
      which may also allocate 1 byte for each item are not converted.

2017-05-09 17:04 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    % small optimization in hb_oleSafeArrayFromString()
    ! fixed named parameter conversion - the last one was ignored

2017-05-09 10:57 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/rddads/ads1.c
  * src/rdd/workarea.c
    * simplified the code and eliminated wrong /* fallthrough */ comments
      inside case block reported by Viktor

2017-05-09 09:14 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/olecore.c
    + added support for named parameters in OLE method calls,
      named parameters should be passed inside hash array in
      first parameter, i.e.:
         oWorksheets:add( { "Before" => oWS, "Count" => 3 } )
      next parameters if exist are passed as unnamed ones, i.e.
         oOle:add( { "name" => "test", "value" => 12345 }, 1, 2, 3 )
    ; warning: code not tested at all, written in my Linux box,
               please make real life tests in MS-Windows
    ! fixed __oleGetNameId()

2017-05-09 09:12 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbct/charswap.c
  * contrib/hbct/token1.c
  * contrib/hbnetio/netiosrv.c
  * contrib/hbssl/ssl_sock.c
  * contrib/rddads/ads1.c
  * include/hbexprb.c
  * src/common/hbprintf.c
  * src/compiler/cmdcheck.c
  * src/compiler/complex.c
  * src/compiler/gencc.c
  * src/compiler/hbmain.c
  * src/compiler/hbopt.c
  * src/pp/ppcore.c
  * src/rdd/dbf1.c
  * src/rdd/dbfcdx/dbfcdx1.c
  * src/rdd/dbffpt/dbffpt1.c
  * src/rdd/dbfntx/dbfntx1.c
  * src/rdd/hsx/hsx.c
  * src/rdd/workarea.c
  * src/rtl/dates.c
  * src/rtl/gtclip.c
  * src/rtl/gtwin/gtwin.c
  * src/rtl/gtwvt/gtwvt.c
  * src/rtl/hbgtcore.c
  * src/rtl/itemseri.c
  * src/rtl/strtoexp.c
  * src/vm/classes.c
  * src/vm/task.c
    * added and verified (following Viktor's patch)
      /* fallthrough */ comment for GCC >= 7.
    ; I haven't found any errors in existing code.
      /cc @vszakats

  * src/rdd/dbf1.c
    * minor improvement in dbf1.c

2017-05-04 14:48 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/compiler/hbcomp.c
    ! restored protection against multiple free of the same expression
      I removed by mistake in one of my recent commits.

2017-05-03 09:10 UTC Viktor Szakats (vszakats users.noreply.github.com)
  * *
    * copyright name cleanups

2017-04-26 14:11 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/harbour.def
    ! added missing hb_itemPutNil()

2017-04-25 17:45 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * src/harbour.def
    ! add hb_rand*() functions, fixing hbtip regression (#154) after
      1938dd0a7094ddf0cd3cdcb2ef9954afe99f969d

  ; import of 2014-12-10 14:38 UTC+0100 functions from Viktor's 3.4 fork
  * src/rtl/hbrand.c
    ! hb_randStr(): fixed possible GPF and other errors when passing
       negative size

  * include/harbour.hbx
  * include/hbapi.h
  * src/rtl/hbrandom.c
    + added C level hb_random_num_secure() which works like hb_random_num()
      but uses arc4 internally
    + added hb_randInt() which works the same as hb_RandomInt() but uses
      arc4 internally
    + added hb_randNum() which works the same as hb_Random() but uses
      arc4 internally

2017-04-25 15:59 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbexprb.c
    ! added missing code to restore original expression type after
      direct type change in code like:
         <var> := <var> + <exp>
      It created problems when <var> was reused later, i.e. in FOR loop:
         FOR v := v + x TO 3
    * simplified code to restore original expression type and updated
      comments

  * src/compiler/harbour.y
    * minor cleanup

2017-04-22 21:22 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbamf/amfenc.c
    ! fix trivial mistake in AMF3_ENCODE(), which broke string
      deduplication after hash with string-keys was serialized
      in object tree. The hash itself was serialized correctly
      because keys are by definition unique.

2017-04-20 10:01 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/3rd/zlib/*
    * updated to version 1.2.11

2017-04-20 09:14 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbcomp.h
  * src/compiler/hbmain.c
    * removed not longer necessary calls to hb_compExprLstDealloc()

  * src/compiler/hbcomp.c
    ! do not generate internal error when nested expression deallocation
      is activated

  * contrib/rddads/ads1.c
    ! fixed bad typo which effectively completely broke
      AdsTestRecLocks( .t. ) mode

2017-04-19 18:20 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/common/hbdate.c
    ! fixed compilation with HB_TR_LEVEL_DEBUG in C mode

2017-04-15 21:35 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbcompdf.h
  * include/hbexprb.c
  * src/common/expropt1.c
    * redefined all HB_ET_MACRO_* macros as bitfields

  * src/compiler/complex.c
    * small modification for future extensions in macro usage

  * src/compiler/hbcomp.c
    ! replaced old temporrary hack with internal error.

  * src/compiler/hbmain.c
    * code reformating

  * src/compiler/harbour.y
    * separated DECLARE tokens

  * src/compiler/harbour.yyc
  * src/compiler/harbour.yyh
    * regenerated

  * src/rdd/dbffpt/dbffpt1.c
    ! fixed possible bad interaction (modified default memo type) due to
      uninitialized item returned by hb_stackAllocItem(). Such items may
      contain any simple value.

  * src/vm/memvars.c
    * minor variable name cleanup

  * utils/hbtest/rt_math.prg
    * repeat tests for macro messages and macro <op>=, pre/post ++/--
      operations with and without pass by reference (-ks) optimization

2017-04-15 21:19 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/common/hbdate.c
    * implemented monotonic timers in POSIX and MS-Windows builds

  * config/wce/global.mk
  * config/wce/mingwarm.mk
  * config/win/global.mk
  * utils/hbmk2/hbmk2.prg
    * added winmm/mmtimer to list of system libraries - required
      for timeGetTime()

  * ChangeLog.txt
    ! typos

2017-04-14 17:17 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/harbour.def
    * removed hb_fsPoll() added by mistake - it's only in *nix builds

2017-04-14 16:36 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapifs.h
  * src/rtl/filesys.c
    + added new C functions for UNIX and DJGPP builds:
         int hb_fsPoll( PHB_POLLFD pPollSet, int iCount,
                        HB_MAXINT nTimeOut );
         int hb_fsCanRead( HB_FHANDLE hFileHandle, HB_MAXINT nTimeOut );
         int hb_fsCanWrite( HB_FHANDLE hFileHandle, HB_MAXINT nTimeOut );
      These functions should be used instead of select() in C code to hide
      low level access to select()/poll() functionality in *nix builds
      (they are supported by DJGPP only to simplify existing code common
      for DJGPP and *nix builds). Maximum file handle value which can be
      used in select() is limited by FD_SETSIZE. Please note that it's
      file handle value not number of file handles in the set. It creates
      serious problem for applications which operate on great number of
      handles (i.e. servers which have to keep open many sockets, pipes,
      files, etc. for their clients) so the new file/socket/pipe/...
      handle value can easy exceed FD_SETSIZE limit and in such case
      cannot be used with select(). The modification on
         2016-04-05 21:24 UTC+0200 Przemyslaw Czerpak
      resolved the problem only for sockets and pipes in code which uses
      corresponding hb_socket*() and hb_fsPipe*() API but not for all
      other cases. This one is for POSIX compilant code which needs pure
      POSIX select()/poll() functionality.
      Please note that HB_POLLFD structure should be compatible with
      struct pollfd defined by POSIX.1-2001 anyhow not all platforms
      confirm this standard so portable Harbour code should always use
      HB_POLLFD and HB_POLL* constant values instead of POLL* ones.

  * include/hbdate.h
  * src/common/hbdate.c
    + added new C functions to calculate timeouts:
         HB_MAXUINT hb_timerGet( void );
         HB_MAXUINT hb_timerInit( HB_MAXINT nTimeOut );
         HB_MAXINT  hb_timerTest( HB_MAXINT nTimeOut, HB_MAXUINT * pnTimer );
      They are designed to be used instead of direct access to
      hb_dateMilliSeconds(). Now they internally use hb_dateMilliSeconds()
      but it can be easy replaced by any other system monotonic clock by
      one local modification inside hb_timerGet() function.

  * src/rtl/filesys.c
    * use hb_timer*() functions instead of hb_dateMilliSeconds()
    * use hb_fsCanRead()/hb_fsCanWrite() instead of select()/poll()
      It also fixed timeout processing inside hb_fsPipeIsData() and
      hb_fsPipeWrite() in builds using poll()

  * src/rtl/filesys.c
  * src/rtl/gtcrs/gtcrs.h
  * src/rtl/gtcrs/gtcrs.c
  * src/rtl/gtpca/gtpca.c
  * src/rtl/gtsln/gtsln.c
  * src/rtl/gtsln/mousesln.c
  * src/rtl/gtstd/gtstd.c
  * src/rtl/gttrm/gttrm.c
  * src/rtl/gtxwc/gtxwc.c
    * use hb_timer*() functions instead of hb_dateMilliSeconds()
    * use hb_fsCanRead()/hb_fsCanWrite() instead of select()/poll()

  * src/vm/thread.c:
  * src/rtl/gtwin/gtwin.c
  * src/rtl/hbcom.c
  * src/rtl/hbgtcore.c
  * src/rtl/hblpp.c
  * src/rtl/idle.c
  * contrib/hbnetio/netiosrv.c:
  * contrib/hbssl/ssl_sock.c:
    * use hb_timer*() functions instead of hb_dateMilliSeconds()

  * contrib/xhb/hboutdbg.c
    * use hb_fsCanWrite() instead of select()

  * src/rtl/hbsocket.c
    ! repeat select() interrupted by signal inside hb_socketSelect()
      when poll() function is not available

  * src/3rd/hbdossrl/serial.c
    ! fixed -Wshift-negative-value GCC warnings

2017-04-14 13:22 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbtip/ccgi.prg
  * contrib/hbtip/client.prg
  * contrib/hbtip/encb64.prg
  * contrib/hbtip/encoder.prg
  * contrib/hbtip/encqp.prg
  * contrib/hbtip/encurl.prg
  * contrib/hbtip/ftpcli.prg
  * contrib/hbtip/hbtip.hbp
  * contrib/hbtip/hbtip.hbx
  * contrib/hbtip/httpcli.prg
  * contrib/hbtip/log.prg
  * contrib/hbtip/mail.prg
  * contrib/hbtip/mime.c
  * contrib/hbtip/misc.c
  * contrib/hbtip/popcli.prg
  * contrib/hbtip/sessid.prg
  * contrib/hbtip/smtpcli.prg
  * contrib/hbtip/thtml.ch
  * contrib/hbtip/thtml.prg
  * contrib/hbtip/tip.ch
  * contrib/hbtip/url.prg
  + contrib/hbtip/base64u.prg
  + contrib/hbtip/mailassy.prg
  * contrib/hbtip/sendmail.prg -> [...]/mailsend.prg
  + contrib/hbtip/WARNING.txt
  * contrib/hbtip/tests/base64.prg
  * contrib/hbtip/tests/dbtohtml.prg
  * contrib/hbtip/tests/dnldftp.prg -> [...]/ftp_dl.prg
  * contrib/hbtip/tests/ftpadv.prg -> [...]/ftp_adv.prg
  + contrib/hbtip/tests/email.prg
  + contrib/hbtip/tests/ftp_ul.prg
  - contrib/hbtip/tests/gmail.hbp
  - contrib/hbtip/tests/gmail.prg
  * contrib/hbtip/tests/hbmk.hbm
  * contrib/hbtip/tests/httpadv.prg -> [...]/http_adv.prg
  * contrib/hbtip/tests/httpcli.prg -> [...]/http_cli.prg
  + contrib/hbtip/tests/http_qry.prg
  - contrib/hbtip/tests/loadhtml.prg
  + contrib/hbtip/tests/test.prg
  + contrib/hbtip/tests/url.prg
    * synced with 3.4 fork by Viktor Szakats
    ; the only difference is slightly edited WARNING.txt

  - contrib/hbtip/credent.prg
    % deleted TIPCredentials() class that was never implemented

  ; changes above come from vast number of commits in 3.4 repository - many
    thanks to Viktor Szakats for maintaining

2017-04-06 12:05 UTC+0200 Aleksander Czajczynski (hb fki.pl)
  * contrib/hbtip/httpcli.prg
    ! fixed uploading binary files with TIPClientHTTP:PostMultiPart()
      Thanks to Alexandre Alencar, who informed about the bug, supplied
      example test code and suggested a patch. This commit simplifies patch
      given by Alexandre.

  * ChangeLog.txt
    % stripped spaces before EOLs

2017-03-29 19:50 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/compiler/hbgenerr.c
    * changed "with object" in last error message to upper cases

  * src/rdd/dbf1.c
    + added assigned value to error object ARGS array when data type or
      data width error is generated inside PUTVALUE() method

  * utils/hbtest/hbtest.prg
  * utils/hbtest/rt_array.prg
  * utils/hbtest/rt_hvma.prg
  * utils/hbtest/rt_main.ch
  * utils/hbtest/rt_math.prg
  * utils/hbtest/rt_misc.prg
    + added support for alternative results to HBTEST code.
      It's enabled by default and can be turned off by -noalt hbtest
      parameter.
    + added alternative results for tests which return different then
      Cl*pper results but they are expected and not Harbour bugs.

2017-03-28 23:02 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbcomp.h
  * include/hbcompdf.h
  * include/hberrors.h
  * include/hbexprb.c
  * src/common/expropt1.c
  * src/compiler/hbgenerr.c
  * src/compiler/hbmain.c
    + added new macros HB_ET_MACRO_NOLIST and HB_ET_MACRO_NOPARE
    % use new HB_ET_MACRO_* macros
    + added new compile time error:
         "Code block contains both macro and with object messages ':%s'"
      NOTE: -kd compiler switch allows to compile codeblocks with macros
            and declared symbols / with object messages
    * replaced hb_compErrorCodeblock() with hb_compErrorCodeblockDecl() and
      hb_compErrorCodeblockWith()
    + added new C function hb_compPushMacroVar()
    * code simplification
    ; added few comments

  * utils/hbtest/rt_math.prg
    * extended test code for macro messages and macro <op>=, pre/post ++/--
      operations

  * src/vm/hvm.c
    ! protection against executing hb_threadStateNew() during GC pass
      inside hb_vmRequestReenterExt()

  * src/vm/garbage.c
    ! add volatile attribute to s_bCollecting variable
    * small modification in hb_gcAll() parameter

  * src/rtl/errsys.prg
    ; minor comment cleanup

  * doc/xhb-diff.txt
    * extended a little bit section STRONG TYPED VARIABLES

2017-03-24 20:02 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbcomp.h
  * src/compiler/hbmain.c
    * changed hb_compVariableScope() to static function

  * src/compiler/harbour.y
    ! added protection against GPF when nested function/procedure is
      declared inside extended block code

  * src/compiler/harbour.yyc
  * src/macro/macro.yyc
  * src/macro/macro.yyh
    * regenerated

  * include/hbexprb.c
    * minor simplification

  * include/hbexpra.c
    * use HB_SIZEOFARRAY() macro

2017-03-23 12:15 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/compiler/harbour.y
    * create real function in internal memory instead of dummy flow control
      error for unclosed structures when new function/procedure declaration
      is found just to reset context for farther error reporting. It leaves
      unclosed structure on Bison stack but it's unimportant for us because
      result of such compilation is ignored due to detected errors and this
      modification resolves the problem with ignored pending declarations.

  * src/compiler/harbour.yyc
    * regenerated

2017-03-22 09:39 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/compiler/hbdead.c
  * src/compiler/hbfix.c
  * src/compiler/hblbl.c
  * src/compiler/hbopt.c
  * src/compiler/hbpcode.c
  * src/compiler/hbstripl.c
    * small comment cleanup in PCODE tables

  * include/hberrors.h
  * src/compiler/hbgenerr.c
    + added new compile time error messages for incorrect
      ENDWITH, ENDSWITCH and END SEQUENCE
    * changed error message:
         "CASE or OTHERWISE does not match DO CASE"
      to
         "CASE or OTHERWISE does not match DO CASE or SWITCH"

  * src/compiler/harbour.y
    * if control structure is closed by wrong statement generate
      error and close it. Cl*pper works in similar way so now compile
      time errors are much more close to Clipper in such cases and
      this modification fixes also problem with long list of errors
      reported to the end of function when in fact only one control
      structure was wrongly closed.
    * generate error messages for parts of control structures used
      in wrong context

  * src/compiler/harbour.yyc
  * src/compiler/harbour.yyh
    * regenerated

  * src/compiler/complex.c
    - removed wrongly working old error messages - initially they were
      implemented in old Flex lexer but they couldn't work correctly
      inside any lexer. When I wrote new lexer I simply copied them to
      new code with old broken logic just for backward compatibility.
      Now such messages are generated by grammar parser for all cases
      not only chose ones so I can clean lexer code.
    * set more precisely lexer state for error messages generated by
      grammar parser
    * simplified the code after above modifications

  * tests/speedtst.prg
    ! fixed memory statistic detection

2017-03-20 12:28 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbgs/core.c
    ! fixed to build with new GS versions - fix borrowed from Viktor's
      branch

  * src/rtl/setkey.c
    + in hb_SetKey() and hb_SetKeyCheck() if extended keycode is passed
      and does not have associated action check also for actions bound
      with corresponding standard keycode
    ! honor user parameters passed by reference to hb_SetKeyCheck()
    ! fixed hardcoded 4 parameter limit in hb_SetKeyCheck()

  * src/compiler/hbopt.c
    ! fixed 'assigned but not used' warning detection - it should not
      mark initial HB_P_PUSHLOCALREF PCODE as used when next <op>=
      operation leaves result on HVM stack.
    * optimize 'var <op>= 0', 'var <op>= 1' and 'var <op>= <timestamp>'
      operations
    * small cleanup

2017-03-20 00:58 UTC+0200 Mindaugas Kavaliauskas (dbtopas/at/dbtopas.lt)
  * src/compile/hbopt.c
    ! fixed 'assigned but not used' error detection for 'var op= val' code

2017-03-15 14:39 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbdefs.h
    + added macros HB_CAST_*( double ) for conversions of double values
      to integer types - they are designed to hide some differences
      between C compilers and platforms in such conversions

  * src/common/expropt2.c
  * src/vm/extend.c
  * src/vm/itemapi.c
    * use new HB_CAST_*() macros

2017-03-15 13:54 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbdefs.h
  * include/hbmather.h
  * src/common/hbprintf.c
  * contrib/gtwvg/wvgwing.c
  * contrib/hbfbird/firebird.c
  * contrib/hbxdiff/3rd/libxdiff/_hbconf.h
  * contrib/sddfb/core.c
    * use hexadecimal numbers checking __BORLAND__ macro

  * src/rtl/sha2.c
    * use standard harbour macros from hbdefs.h

2017-03-15 09:50 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * package/harbour.spec
  * contrib/hbbz2/hbbz2.hbp
  * package/mpkg_rpm.sh
    + added support for '--with localbz2' RPM build parameter

  * include/hbpp.h
  * src/pp/ppcore.c
  * src/compiler/hbmain.c
    * modified hb_pp_inBuffer() parameters. Now it supports optional
      szFileName parameter.
      Warning: it's incompatible with previous version but I do not think
      that anyone used this function outside core code so I decided to not
      add new function but simply change the existing one.
      [INCOMPATIBLE]

  * src/rtl/filebuf.c
    ! do not resepct SET DEFAULT/PATH in hb_fileExists() when 2nd parameter
      is NULL in default file IO drivers. It also changes the behvior of
      PRG function hb_vfOpen() which now honors SET DEFAULT/PATH only if
      its 2nd parameter is passed by reference - this modification is
      compatible with 2016-01-25 18:16 UTC+0100 Viktor Szakats in his fork.

  * src/rdd/dbf1.c
  * src/rdd/dbfcdx/dbfcdx1.c
  * src/rdd/dbfnsx/dbfnsx1.c
  * src/rdd/dbfntx/dbfntx1.c
    * updated to work correctly with modified hb_fileExists() behavior
    ; CL5.2 DBFCDX and Six3 CDX/NSX RDDs looking for production indexes
      respect SET PATH but Harbour in core DBF* index RDDs is CL5.3/COMIX
      compatible and looks for production indexes only in the directory
      where DBF file is located and only SIXCDX Harbour RDD is CL5.2/Six3
      compatible.
      Please also note that it's significant only for situations when
      DBF file is located in current directory. If it's open from
      SET DEFAULT/PATH directory then corresponding path is added
      to DBF file name what effectively disables SET DEFAULT/PATH
      processing when production index is open.

  * src/rtl/filebuf.c
  * src/rtl/filebufd.c
  * src/rtl/iousr.c
  * contrib/hbmemio/memio.c
    ; cleaned name of hb_fileCopy() paramter

  * include/hbapifs.h
  * src/rtl/filebuf.c
  * src/harbour.def
    + added new C function:
         HB_BOOL hb_fileMove( const char * pszSrcFile,
                              const char * pszDstFile );
  * src/rtl/vfile.c
  * include/harbour.hbx
  * src/harbour.def
    + added new PRG function:
         hb_vfMoveFile( <cFileSrc>, <cFileDst> ) -> <nResult>

  ; unlike hb_fileRename()/hb_vfRename() new hb_fileMove()/hb_vfMoveFile()
    functions allow to move files between different file systems/drives
    and also different Harbour file IO drivers. Please note that it means
    that file name IO driver prefix is significant in both source and
    destination file names unless it's local FS operation. New functions
    when both file names point to the same Harbour file IO driver try to
    use simple rename operation. If it fails then they try to copy the
    file and remove the source one.

  * ChangeLog.txt
    ! typo

  * include/hbfloat.h
  * contrib/xhb/xhbctbit.c
  * src/compiler/hbcmplib.c
  * src/compiler/hbcomp.c
  * src/compiler/hbusage.c
    ! pacified new GCC warnings and partially synced with Viktor's fork

  * src/compiler/hbusage.c
    * added Klas Engwall to credits list
    * added Rolf to credits list
    * updated April White email address
    ; please verify it and update if necessary

2017-02-08 19:36 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc1.cpp
    ! fixed clipboard selection with shift + left mouse button to not report
      mouse events during selection

  * include/hbdate.h
  * src/common/hbdate.c
    + added support for ISO 8601 week dates (YYYY-Www-D) in timestamp
      literals
    + added support for ISO 8601 ordinal dates (YYYY-DDD) in timestamp
      literals
    + added new C functions:
         HB_BOOL hb_dateDecWeek( long lJulian, int * piYear,
                                 int * piWeek, int * piDay );
         long hb_dateEncWeek( int iYear, int iWeek, int iDay );
      to decode/encode ISO 8601 week dates

  * src/rtl/dateshb.c
    + added new PRG function get week number and other parts ISO 8601
      week date:
         hb_Week( <dDate>, [@<nYear>], [@<nDayOfWeek>] ) -> <nWeek>

  * include/harbour.hbx
  * src/harbour.def
    * updated for new functions

2016-12-16 11:05 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbmisc/dates.c
    ! fixed WOY() to return some reasonable results. I have no idea what
      author wanted to reach but now WOY() be default returns ISO 8601
      week number and simple week number if 2nd parameter is .F.

2016-12-15 12:51 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/harbour.hbx
  * src/harbour.def
  * src/rtl/dateshb.c
    + added new PRG functions which convert time difference to hours,
      minutes, seconds and milliseconds. Except milliseconds the results
      are floating point numbers with fractional part representing the
      rest of conversion:
         hb_NToHour( <nTimeDiff> )  => <nHours>
         hb_NToMin ( <nTimeDiff> )  => <nMinutes>
         hb_NToSec ( <nTimeDiff> )  => <nSeconds>
         hb_NToMSec( <nTimeDiff> )  => <nMilliseconds>
    + added new PRG functions which convert timestamp value to hours,
      minutes, seconds and milliseconds. Except milliseconds the results
      are floating point numbers with fractional part representing the
      rest of conversion:
         hb_TToHour( <tTimeStamp> ) => <nHours>
         hb_TToMin ( <tTimeStamp> ) => <nMinutes>
         hb_TToSec ( <tTimeStamp> ) => <nSeconds>
         hb_TToMSec( <tTimeStamp> ) => <nMilliseconds>

  * src/rtl/gtsln/gtsln.c
    ! fixed cleanup string sent to terminal to remove test UTF-8 character

  * src/rtl/gtsln/kbsln.c
    + added workaround for some broken Linux kernel which wrongly sets
      tty device as ready for reading

  * src/rtl/hbsocket.c
    * added comment

  * src/rdd/dbfnsx/dbfnsx1.c
  * src/rdd/dbfntx/dbfntx1.c
    ! added missing tag root page restoring cleared after discarding buffers
      due to concurrent access to multitag indexes.
      Many thanks for Karsten Stucker for self contain example.

  * src/rdd/dbfntx/dbfntx1.c
    * discard buffers when next free page is changed even without touching
      version number - minor protection for potentially broken 3rd party
      NTX code or very old [x]Harbour NTX RDDs which do not increment
      version number on update.

2016-11-16 16:10 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/hbssl.h
  * contrib/hbssl/evppkey.c
    + added new C function
         void hb_EVP_PKEY_ret( EVP_PKEY * pkey );

  * contrib/hbssl/hbssl.hbx
  * contrib/hbssl/pem.c
    + added new PRG functions:
         PEM_READ_PRIVATEKEY()
         PEM_READ_PUBKEY()

  * contrib/hbssl/ssl_sock.c
    ! added missing HB_SOCKET_ERR_TIMEOUT setting in hb_ssl_socketRead()
    ! fixed cleared to early SSL error code in hb_ssl_socketWrite()

  * contrib/hbssl/tests/inetssl.prg
    ! interrupt test program if server thread stops
    * load server certificates before listen socket is created

  * src/rdd/dbfnsx/dbfnsx1.c
    ! code cleanup to pacify warnings in new GCC versions

  * src/rtl/filesys.c
    ! check if child's fork() was executed successfully

  * src/rtl/hbproces.c
    ! use hb_fsCloseRaw() instead of close() in hb_fsProcessExec() to avoid
      lost handles when close() operation is interrupted by signal.
    ! repeat waitpid() calls interrupted by signal

2016-11-07 14:50 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
  - doc/en/hb_set.txt
  * doc/en/set.txt
  * contrib/hbgd/doc/en/hbgd.txt -> contrib/hbgd/doc/en/gdwrp.txt
  * contrib/hbmisc/doc/en/dates2.txt -> contrib/hbmisc/doc/en/dates.txt
  * contrib/hbmisc/doc/en/ht_class.txt -> contrib/hbmisc/doc/en/fileread.txt
  * contrib/hbmisc/doc/en/ht_conv.txt -> contrib/hbmisc/doc/en/nconvert.txt
  * contrib/hbmisc/doc/en/ht_str.txt -> contrib/hbmisc/doc/en/strfmt.txt
  * contrib/hbxpp/doc/en/browse.txt -> contrib/hbxpp/doc/en/dbcmdx.txt
  * contrib/hbziparc/doc/en/hbziparc.txt -> contrib/hbziparc/doc/en/ziparc.txt
  * contrib/rddads/doc/en/adsfuncs.txt -> contrib/rddads/doc/en/adsfunc.txt
  * doc/en/array.txt -> doc/en/arrayshb.txt
  * doc/en/eval.txt -> doc/en/evalhb.txt
  * doc/en/input.txt -> doc/en/inputall.txt
  * doc/en/lang.txt -> doc/en/langall.txt
  * doc/en/nation.txt -> doc/en/natmsg.txt
  * doc/en/setmode.txt -> doc/en/gx.txt
  * doc/en/tgetlist.txt -> doc/en/readvar.txt
    * renames to sync doc filenames with source filename

  ; Above patches come from 3.4 fork commits below:

    2016-11-03 14:01 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    2016-11-03 13:48 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)

2016-10-28 12:29 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
  * include/hbver.ch
    + add new HB_VER_* constants from 3.4

  * src/rtl/version.c
    + return meaningful value for HB_VERSION_URL_BASE
    * return dummy values for HB_VERSION_URL_SOURCE,
      HB_VERSION_BUILD_TIMESTAMP_UTC, HB_VERSION_OPTIONS

2016-10-26 12:50 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
  - extras/hbdoc/_tmplate.prg
  - extras/hbdoc/hbdoc.ch
  * extras/hbdoc/_genbase.prg
  * extras/hbdoc/_genhtml.prg
  * extras/hbdoc/_gentxt.prg
  * extras/hbdoc/_genxml.prg
  * extras/hbdoc/hbdoc.hbp
  * extras/hbdoc/hbdoc.prg
    + improve readability by paragraphs spacing in DESCRIPTION sections
    + improve divs in section content for better control via CSS
    + improve readability of tables with borders and
      header hightlights
    * change default output to single-file
    + add support for the old <table>/<fixed> tags in html output until they
      are converted to something better
    + add support for <b>/<b>, <URL:url>, Markdown `inline code`,
      _emphasis_, *bold*, character escaping \*, line separators ===/---,
      and fenced code using triple backticks.
      Very limited and not with standard compliance or completeness
      in mind, just to be able to use some basic formatting.
    ; TODO: Markdown URL and lists, then replace all <b>,<URL>,<fixed>
            markup with Markdown equivalents in docs
    + better localization support
    + add support for one file per component output via -output-component
      cmdline option
    % assemble output in memory and write to disk in a single call
    % integrate external header
    % replace almost all internal arrays with hashes
    % replace self-modifying class and macro expansion with
      regular hashes
    % internal cleanups
    % switch to simpler method for sort weighting
    + merge category/subcategory values into tag list. It
      means they will be now be included in the output
    % cleanup/fix/simplify value expansions for 'compliance',
      'status' and 'platform' fields
    % cleanup the way output engines are handles internally
    + add support for 'TAGS' entry to replace/extend the rigid and
      ambiguous CATEGORY/SUBCATEGORY-based categorization. It is meant
      to be a comma-separated list of freeform tags, possibly with a set
      of standard common tags, with the freedom to use anything else deemed
      useful by component/doc authors.
    + add footer showing the build date of the doc
    + include Git revision the doc is based on, link to the relevant
      source tree version.
    * various code refactoring steps to avoid unnecessary
      classes, arrays, macro evaluation, and using undocumented
      functions
    % various HTML5 tag improvements and optimizations
    + load HBX file contents and lookup each referenced
      symbol. Emit warning in verbose mode, if docs refers
      to non-existing one.
      (this replaces slow and broken logic based on hbextern.ch)
    + use core hbdoc API to load the documentation instead
      of locally rolled logic
    * always show those content problems that are considered
      fatal and the input doc to be skipped
    + filter docs to English language by default
    + add ability to choose language using a command-line option
    ! fix faulty validation logic that resulted in
      erronously skipping certain entries
    + identify docs' 'component' property automatically
    ! fix to not eat empty lines from examples
    + convert "see also" items to links (this works correctly only
      in single file output mode)
    ! fix to not break words (f.e. URLs) when outputting HTML
    % use shorter class names
    ! fix invalid element ID generated
    ! fix RTE when trying to create output by category
    % delete dummy "HTML2" output mode
    * convert more ASCII chars to better Unicode equivalents
    + mark more text as code automatically
    * drop MS-DOS compatibility

  * src/rtl/hbdoc.prg
    ! fix filling '_LANG' property with the correct value
    * switch to use LF instead of CRLF in the field contents

  * contrib/hbct/doc/en/*.txt
  * contrib/hbgd/doc/en/hbgd.txt
  * contrib/hbgt/doc/en/hbgt.txt
  * contrib/hbmisc/doc/en/dates2.txt
  * contrib/hbnf/doc/en/*.txt
  * contrib/rddads/doc/en/adsfuncs.txt
  * doc/en/*.txt
    * cleanups and fixes
    ! casing
    ! fix to always delimit "see also" items with comma (",")
    ! fix various casing issues and old typos
    ! various fixes after detecting them using updated hbdoc
    ! eliminate/fix various rare/unnecessary/invalid field values
    ! move some embedded docs from hbdoc into their respective
      doc sources
    ! fix a typo
    * use backtick
    * replace code copyright with reference to COPYING.txt (=LICENSE.txt)
    + mark tables without a header or with double height header

  ; Above patches come from 3.4 fork commits below:

    2016-10-26 12:43 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-26 12:34 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-26 12:20 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-26 03:21 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-26 02:47 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-25 15:05 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-25 14:51 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-25 14:30 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-25 13:19 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-25 12:35 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-25 11:47 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-25 02:48 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-24 22:26 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-24 18:35 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-24 17:58 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-24 16:12 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-24 15:44 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-24 03:36 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-24 02:40 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-24 00:23 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-23 23:09 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-23 16:39 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-23 16:10 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
    2016-10-23 13:15 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)

2016-10-21 07:54 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
  * extras/hbdoc/_genbase.prg
  * extras/hbdoc/_genhtml.prg
  * extras/hbdoc/_gentxt.prg
  * extras/hbdoc/_genxml.prg
  * extras/hbdoc/_tmplate.prg
  * extras/hbdoc/hbdoc.ch
  * extras/hbdoc/hbdoc.css
  * extras/hbdoc/hbdoc.hbp
  * extras/hbdoc/hbdoc.prg
    ! fix linter problems in generated html
    * html5/css cleanups
    * use VF IO
    ! fix double close in hbdoc
    ! fix file handle leak in hbdoc
    * use Class(y) syntax in class definitions
    * remove internal file references
    % use hb_AScanI()
    ! use hb_ATokens() instead of hand-rolled line splitting,
      making this code EOL agnostic
    % use hb_cwd(), hb_FName*(), hb_DirSep*() (also fixes potential portability issues)
    * cleanups/opts
    * cleaned doc tags
    % force disable LTO at link-time
    ! typo in comment
    ; notice that you can regenerate the docs
      for the Harbour website (https://harbour.github.io/doc/)
      using this command:
         extras/hbdoc$ hbmk2 hbdoc -run -runflag=-format=html -runflag=-output-single
      or in this fork, using this command:
         extras/hbdoc$ hbmk2 hbdoc -run
    ; for NF doc parsing I created an internal API long ago
      (it is used by HBIDE f.e.):
         hbmk2 -find __hbdoc_
      usage examples in Harbour:
         grep -R __hbdoc_ *
    % optimized string handling / temp variable usage, IFs cleaned
    % enabled -kmo build options
    % cleaned header inclusion
    % reworked to not use PUBLIC vars at all
    % avoided some more macro expansions
    % converted a public var to hb_StrReplace() with hash
    * minor cleanups and optimizations
    * use PROTECTED obj vars
    % use SWITCH
    % merged some nested branches
    * use #if 0 for commented code
    % cleaned some array declarations
    % use hb_FNameExt()
    * avoid one macro expansion
    + added -run flags to regenarate docs for Harbour website
    * cleaned .AND./.OR. ambiguity
    % converted PUBLIC var to STATIC
    ; Above patches come from 3.4 fork commits below:
      2016-09-20 02:31 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2016-09-19 18:51 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2016-09-19 18:03 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2015-07-18 17:57 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2015-06-28 11:27 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2015-06-05 20:47 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2015-03-17 13:54 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
      2014-12-13 03:15 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
      2014-07-15 23:04 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2014-06-21 12:46 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2014-06-20 15:38 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2014-02-12 01:58 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
      2014-02-03 21:07 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
      2014-02-03 19:19 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
      2014-02-03 18:37 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
      2014-02-03 18:22 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
      2014-02-03 17:45 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)
    ; plus various minor maintenance updates from multiple other commits

2016-10-19 01:24 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
  + contrib/hbxpp/doc/en/binnumx.txt
  + contrib/hbxpp/doc/en/browse.txt
    * sync more docs with 3.4 fork

  * contrib/hbgt/doc/en/hbgt.txt
    * sync some updates from 3.4 fork

2016-10-18 19:16 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
  - contrib/hbct/doc/en/ct.txt
  * contrib/hbct/doc/en/ctc.txt
  * contrib/hbct/doc/en/strdiff.txt
  * contrib/hbct/doc/en/token2.txt
  * contrib/hbgt/doc/en/hbgt.txt
  * contrib/hbmisc/doc/en/dates2.txt
  * contrib/hbmisc/doc/en/ht_class.txt
  * contrib/hbmisc/doc/en/ht_str.txt
  * contrib/hbnf/doc/en/aavg.txt
  * contrib/hbnf/doc/en/acctadj.txt
  * contrib/hbnf/doc/en/acctmnth.txt
  * contrib/hbnf/doc/en/acctqtr.txt
  * contrib/hbnf/doc/en/acctweek.txt
  * contrib/hbnf/doc/en/acctyear.txt
  * contrib/hbnf/doc/en/adapter.txt
  * contrib/hbnf/doc/en/aemaxlen.txt
  * contrib/hbnf/doc/en/aeminlen.txt
  * contrib/hbnf/doc/en/alt.txt
  * contrib/hbnf/doc/en/amedian.txt
  * contrib/hbnf/doc/en/anomatch.txt
  * contrib/hbnf/doc/en/any2any.txt
  * contrib/hbnf/doc/en/aredit.txt
  * contrib/hbnf/doc/en/asum.txt
  * contrib/hbnf/doc/en/at2.txt
  * contrib/hbnf/doc/en/bitclr.txt
  * contrib/hbnf/doc/en/byt2bit.txt
  * contrib/hbnf/doc/en/byt2hex.txt
  * contrib/hbnf/doc/en/calendar.txt
  * contrib/hbnf/doc/en/chdir.txt
  * contrib/hbnf/doc/en/cint86.txt
  * contrib/hbnf/doc/en/clrsel.txt
  * contrib/hbnf/doc/en/cntryset.txt
  * contrib/hbnf/doc/en/ctrl.txt
  * contrib/hbnf/doc/en/d2e.txt
  * contrib/hbnf/doc/en/datecnfg.txt
  * contrib/hbnf/doc/en/default.txt
  * contrib/hbnf/doc/en/dosver.txt
  * contrib/hbnf/doc/en/easter.txt
  * contrib/hbnf/doc/en/elapmil.txt
  * contrib/hbnf/doc/en/elapsed.txt
  * contrib/hbnf/doc/en/eltime.txt
  * contrib/hbnf/doc/en/findith.txt
  * contrib/hbnf/doc/en/firstday.txt
  * contrib/hbnf/doc/en/floptst.txt
  * contrib/hbnf/doc/en/fttext.txt
  * contrib/hbnf/doc/en/getenvrn.txt
  * contrib/hbnf/doc/en/hex2dec.txt
  * contrib/hbnf/doc/en/iamidle.txt
  * contrib/hbnf/doc/en/idle.txt
  * contrib/hbnf/doc/en/inp.txt
  * contrib/hbnf/doc/en/invclr.txt
  * contrib/hbnf/doc/en/isprint.txt
  * contrib/hbnf/doc/en/lastday.txt
  * contrib/hbnf/doc/en/linked.txt
  * contrib/hbnf/doc/en/madd.txt
  * contrib/hbnf/doc/en/menu1.txt
  * contrib/hbnf/doc/en/menutonf.txt
  * contrib/hbnf/doc/en/metaph.txt
  * contrib/hbnf/doc/en/miltime.txt
  * contrib/hbnf/doc/en/min2dhm.txt
  * contrib/hbnf/doc/en/mkdir.txt
  * contrib/hbnf/doc/en/month.txt
  * contrib/hbnf/doc/en/mouse1.txt
  * contrib/hbnf/doc/en/n2color.txt
  * contrib/hbnf/doc/en/netpv.txt
  * contrib/hbnf/doc/en/nooccur.txt
  * contrib/hbnf/doc/en/ntow.txt
  * contrib/hbnf/doc/en/nwlstat.txt
  * contrib/hbnf/doc/en/nwsem.txt
  * contrib/hbnf/doc/en/nwuid.txt
  * contrib/hbnf/doc/en/origin.txt
  * contrib/hbnf/doc/en/outp.txt
  * contrib/hbnf/doc/en/page.txt
  * contrib/hbnf/doc/en/peek.txt
  * contrib/hbnf/doc/en/pickday.txt
  * contrib/hbnf/doc/en/popadder.txt
  * contrib/hbnf/doc/en/proper.txt
  * contrib/hbnf/doc/en/putkey.txt
  * contrib/hbnf/doc/en/qtr.txt
  * contrib/hbnf/doc/en/rand1.txt
  * contrib/hbnf/doc/en/reboot.txt
  * contrib/hbnf/doc/en/rmdir.txt
  * contrib/hbnf/doc/en/round.txt
  * contrib/hbnf/doc/en/savearr.txt
  * contrib/hbnf/doc/en/scancode.txt
  * contrib/hbnf/doc/en/setdate.txt
  * contrib/hbnf/doc/en/settime.txt
  * contrib/hbnf/doc/en/shift.txt
  * contrib/hbnf/doc/en/sinkey.txt
  * contrib/hbnf/doc/en/sleep.txt
  * contrib/hbnf/doc/en/sqzn.txt
  * contrib/hbnf/doc/en/stod.txt
  * contrib/hbnf/doc/en/sysmem.txt
  * contrib/hbnf/doc/en/tbwhile.txt
  * contrib/hbnf/doc/en/tempfile.txt
  * contrib/hbnf/doc/en/vertmenu.txt
  * contrib/hbnf/doc/en/vidcur.txt
  * contrib/hbnf/doc/en/vidmode.txt
  * contrib/hbnf/doc/en/wda.txt
  * contrib/hbnf/doc/en/week.txt
  * contrib/hbnf/doc/en/year.txt
  * contrib/hbziparc/doc/en/hbziparc.txt
  * contrib/rddads/doc/en/adsfuncs.txt
  * contrib/rddads/doc/en/readme.txt
  * doc/en/1stread.txt
  * doc/en/array.txt
  * doc/en/binnum.txt
  * doc/en/browse.txt
  * doc/en/command.txt
  * doc/en/compiler.txt
  * doc/en/datetime.txt
  * doc/en/dbdelim.txt
  * doc/en/dbsdf.txt
  * doc/en/dbstrux.txt
  * doc/en/dir.txt
  * doc/en/diskspac.txt
  * doc/en/errsys.txt
  * doc/en/eval.txt
  * doc/en/file.txt
  * doc/en/garbage.txt
  * doc/en/harbext.txt
  * doc/en/hashes.txt
  * doc/en/hb_set.txt
  * doc/en/hbinet.txt
  * doc/en/hvm.txt
  * doc/en/idle.txt
  * doc/en/input.txt
  * doc/en/lang.txt
  * doc/en/macro.txt
  * doc/en/math.txt
  * doc/en/memo.txt
  * doc/en/memvar.txt
  * doc/en/menu.txt
  * doc/en/misc.txt
  * doc/en/nation.txt
  * doc/en/objfunc.txt
  * doc/en/rdd.txt
  * doc/en/rdddb.txt
  * doc/en/rddmisc.txt
  * doc/en/rddord.txt
  * doc/en/set.txt
  * doc/en/setmode.txt
  * doc/en/string.txt
  * doc/en/tclass.txt
  * doc/en/terminal.txt
  * doc/en/tgetlist.txt
  * doc/en/tlabel.txt
  * doc/en/treport.txt
  * doc/en/var.txt
    * sync with fixes/updates from 3.4 fork

2016-10-04 16:22 UTC+0300 Mindaugas Kavaliauskas (dbtopas/at/dbtopas.lt)
  * contrib/hbwin/hbwin.ch
    + WIN_SERVICE_CONTROL_SHUTDOWN define added
  * contrib/hbwin/win_svc_1.c
    + implemented capability to have custom service control handler. win_serviceStart()
      optional parameter added:
        win_serviceStart( cName, bEntryFunc | sEntryFunc [, bControlFunc | sControlFunc ] )
      The minimal control function implementation is:
        PROC SvcControl(nControl)
           IF nControl == WIN_SERVICE_CONTROL_STOP .OR. ;
              nControl == WIN_SERVICE_CONTROL_SHUTDOWN
              win_serviceSetStatus(WIN_SERVICE_STOP_PENDING)
           ENDIF
        RETURN
      If control function parameter is passed, service state will not be set
      to running by default. This allows to abort service on startup.
      If service is started, service main function should set running status
      by calling win_serviceSetStatus(WIN_SERVICE_RUNNING)

2016-10-02 23:20 UTC+0400 Phil Krylov (phil a t newstar.rinet.ru)
  * config/global.mk
    ! Fix cross-compiler detection when only HB_CCPREFIX is passed from
      environment.

2016-09-28 19:55 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/hbssl.h
  * contrib/hbssl/ssl_sock.c
  * contrib/hbssl/ssl_inet.c
    + added new 'PHB_ITEM pSSL' parameter to hb_sockexNewSSL() and
      hb_ssl_socketNew() C functions - it allows to bind harbour item
      with SSL pointer which should not be released before connection
      is closed. In new OpenSSL version such tricks can be replaced
      by SSL_up_ref()
      This modification also fixes possible GPF trap when SSL filter
      socket was created dynamically from C code without SSL pointer
      item on HVM stack in 2nd parameter and removes old hack which
      saved internally 2nd HVM stack parameter.
    + allow to pass SSL_CTX instead of SSL in "ssl", "ctx" or "key" items
      of hash array used to initialize SSL socket filter. Using SSL_CTX
      allows to use the same hash array to set SSL socket filter for
      different connections
    + allow to use codeblocks or function pointers as "ssl", "ctx" or
      "key" items of hash array used to initialize SSL socket filter

  * contrib/hbssl/hbssl.h
  * contrib/hbssl/sslctx.c
    + added new C function:
         SSL_CTX * hb_SSL_CTX_itemGet( PHB_ITEM pItem )

  * contrib/hbssl/ssl_sock.c
  * src/rtl/hbcom.c
  * src/rtl/hbsocket.c
    ! fixed timeout checking in select()/poll()

  * src/rtl/hbsockhb.c
    ! fixed possible GPF trap when socket filter refuse to create new
      socket wrapper

  * include/hbinit.h
    * in GCC C++ builds for startup code use GCC constructor function
      attribute instead of static variable initialization to avoid
      warnings in new GCC versions

  * src/rtl/hbntos.c
    ! fixed missing '-' in result of negative integer numbers - thanks
      to Luigi Ferraris

  * src/common/hbstr.c
    + added code to round integer part when the size of number is greater
      then double precision (~16 digits).

2016-09-23 11:00 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc1.cpp
    * removed unnecessary casting after recent modification

  * src/3rd/jpeg/Makefile
  * src/3rd/jpeg/jconfig.h
    ! moved definitions which interacts with 3rd party code using libjpeg
      header files to jconfig.h

2016-09-23 09:47 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc1.cpp
    ! fixed C++ casting in MS-Windows builds

2016-09-22 15:47 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapi.h
  * include/hbvmpub.h
    * removed casting C style casting from commonly used macros

  * contrib/gtqtc/gtqtc1.cpp
    * use C++ casting instead of C casting

  * contrib/rddads/ads1.c
  * contrib/rddads/adsx.c
  * contrib/rddsql/sqlmix.c
  * src/rdd/dbfcdx/dbfcdx1.c
  * src/rdd/dbfnsx/dbfnsx1.c
  * src/rdd/dbfntx/dbfntx1.c
  * src/rdd/dbsql.c
  * src/rdd/workarea.c
    * cleaned HB_IT_* usage

  * contrib/rddads/ads1.c
    ! fixed typo in low level code of ordDescend() / DBOI_ISDESC,
      now ordDescend() should work with ADS* RDDs just like with
      native RDDs

  * contrib/hbfoxpro/relfunc.c
    ! fixed typo in Between() function - thanks to Petr Chorney

  * src/rtl/gtwvt/gtwvt.c
    ! added workaround for keyboard drivers which sets CTRL key modifier
      flag when only ALTGR is pressed - thanks to Maurizio la Cecilia

2016-09-20 17:38 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * doc/xhb-diff.txt
    + added information about support for strong typed variables in [x]Harbour
    * updated information about typed object items
    ! typos

  * include/hbclass.ch
    * updated information about initialization of typed object items

  * include/hbatomic.h
    * do not force OSSpinLock usage in OSX builds

  * include/hbapifs.h
  * src/rtl/filesys.c
    + added new C function hb_fsCloseRaw() - it works like hb_fsClose() but
      does not change hb_fsError()

  * src/rtl/filebuf.c
    * changed the condition in hb_fileLoadData() used to detect file
      descriptors without full support for file seek - now it's possible
      to use [hb_]MemoRead() to read /proc/* files in Linux

  * src/rtl/filesys.c
    ! detach printer process to not leave zombie processes after printing
      in programs which do not catch SIGCHLD signal in *nixes builds

  * src/rtl/filesys.c
  * src/rtl/hbproces.c
    * use hb_fsCloseRaw() instead of hb_fsClose() to safe original error code

  * src/rtl/hbsocket.c
    ! fixed OpenWatcom Linux builds
    + added HB_WINSOCK_USE_OLDFUNC macro which disables new WinSock functions
      in MS-Windows builds

  * src/rtl/gtxwc/gtxwc.c
    ! fixed recursive mutex lock
    ! added some missing locks
    + added support for X11 XLockDisplay()/XUnlockDisplay() in default builds
      when MT HVM is used. X11 locks can be disabled by HB_XWC_XLOCK_OFF
      macro - it may be necessary on some old platforms which do not support
      them.
    ! disabled resize step when font size is changed to reduce possible
      problem with reduced number of columns and rows by this operation.
      Please remember that X Server/Window Manager may still ignore
      suggested window size and force their own dimensions so application
      has to be ready to accept final screen size set by server/WM.

  * contrib/hbnf/shadow.c
    ! use 8 instead of 7 as default color attribute in FT_Shadow() function

2016-09-05 17:04 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
  * contrib/hbwin/hbwin.ch
  * contrib/hbwin/hbwin.hbp
  * contrib/hbwin/hbwin.hbx
  + contrib/hbwin/win_svc_2.c
  * contrib/hbwin/win_svc.c -> contrib/hbwin/win_svc_1.c
    + add function win_ServiceRun( <cName>, [...] ) -> <lSuccess>
      to start a service by name
    + add WIN_SERVICE_CONTROL_* constants
    + add function win_ServiceControl( <cName>, <nControlCode> ) -> <lSuccess>
    + add 2nd parameter to win_ServiceDelete( <cName>, <lForce> ) -> <lSuccess>
      <lForce> will attempt to stop the service before deleting it.
    % separate service management functions and Harbour app-as-service
      support functions into separate sources
    ; build-tested only, function names not finalized.
    * set wapi_GetLastError() more consistently
    + win_ServiceInstall() add two new optional parameters:
      <cUsername> (5th) and <cPassword> (6th)
    ! win_ServiceInstall() do not convert an omitted
      <cDisplayName> (2nd) parameter to empty string, pass it
      to Windows as NULL instead
    % use HB_IT_EVALITEM instead of ( HB_IT_BLOCK | HB_IT_SYMBOL )
    ; Above patches come from 3.4 fork commits below:
      2015-09-03 18:52 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2015-09-02 19:54 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2015-09-02 18:43 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2015-04-03 11:43 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
      2014-01-29 02:15 UTC+0100 Viktor Szakats (vszakats users.noreply.github.com)

2016-08-10 20:12 UTC+0300 Mindaugas Kavaliauskas (dbtopas/at/dbtopas.lt)
  * contrib/rddads/ads.ch
    + 64bit server type constants included

  * include/dbinfo.ch
  * contrib/rddsql/hbrddsql.h
  * contrib/rddsql/rddsql.hbc
  - contrib/rddsql/hbrddsql.ch
    * definitions of SQL related RDDI_*, DBI_* constants moved from RDDSQL
      to core code
  * include/dbinfo.ch
  * contrib/rddsql/sqlbase.c
    * RDDI_NEWID renamed to more informative RDDI_INSERTID

  * contrib/rddads/ads1.c
  * contrib/rddads/adsfunc.c
  * contrib/rddads/rddads.h
    + RDDI_CONNECT, RDDI_DISCONNECT implemented. RDDINFO() can be used instead
      of RDD specific AdsConnect*() calls
    + other SQL related RDDINFO(), DBINFO() capabilities implemented
    + DBUSEAREA() accepts prefixes "SQL:" and "TABLE:" to indicate if
      given table name should be treated as SQL query or table file name.
      If these prefixes are omitted, function parameter is treated as table
      file name except in case it begins with "SELECT " (compatibility).

2016-07-18 20:32 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbssl/hbssl.hbx
  * contrib/hbssl/pem.c
  * contrib/hbssl/x509.c
    + added new prg functions: PEM_READ_X509(), PEM_READ_X509_AUX() and
      X509_get_PubKey()

  * src/debug/dbgmenu.prg
    ! fixed wrong method name :ToggleBreakPoint() -> BreakPointToggle()
      Thanks to Viktor.

  * src/rtl/gtwin/gtwin.c
    * hardcoded some LEFT_ALT + <key> to return K_ALT_* value instead of
      national characters, i.e. in EL keyboard layout. Please test it.
      I cannot check it in my MS-Windows version.

2016-07-04 19:01 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtwvg/wvgcore.c
  * contrib/gtwvg/wvgcuig.c
    ! use HB_MIN() macro instead of non-standard min() function
    ! use casting to double instead of float which may strip significant
      bits from 32bit numbers

  * include/hbapicdp.h
    + added hb_cdpGetID() macro
    * formatting

  * src/rtl/hbjson.c
    * modified codepage parameter behavior in JSON encode/decode functions.
      Now they can be used for codepage translation.

  * src/rtl/gtwvt/gtwvt.c
    * ignore national characters when WM_SYSCHAR message is generated.
      It should resolve the problem with Greek keyboard layout reported
      by Pete anyhow it's possible that it may create new problems with
      some other keyboard layouts so please report them if any.

2016-06-29 23:02 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rdd/dbfcdx/dbfcdx1.c
  * src/rdd/dbffpt/dbffpt1.c
  * src/rdd/dbfnsx/dbfnsx1.c
  * src/rdd/dbfntx/dbfntx1.c
  * src/rdd/delim1.c
  * src/rdd/sdf1.c
  * src/rdd/hsx/hsx.c
  * src/rdd/dbcmd.c
  * src/rdd/dbcmd53.c
    * next SELF_INFO() and SELF_RDDINFO() cleanups

  * src/rtl/gtwvt/gtwvt.c
    ! fixed reverted LEFT and RIGHT ALT modifiers in my last commit

2016-06-23 00:54 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapiitm.h
  * src/vm/itemapi.c
    + added new C function:
         PHB_ITEM hb_itemPutNil( PHB_ITEM pItem );

  * src/rdd/dbf1.c
    ! fixed yet another RDDI_SETHEADER clearing in internal DBF RDD code
    * clear few passed variables before internal SELF_INFO() and
      SELF_RDDINFO() read calls - they were safe in current code but
      potentially may badly interact with 3rd party DBF RDD wrappers.

2016-06-22 23:58 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/dbinfo.ch
    * updated few comments

  * src/rdd/dbf1.c
  * src/rdd/delim1.c
    ! fixed dbInfo( DBI_SETHEADER ) and hb_rddInfo( RDDI_SETHEADER )
      to not changer previous settings
    ! set DB_SETHEADER_APPENDSYNC as default update header mode

2016-06-20 21:59 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * doc/cmpopt.txt
    * enumeration
    ! typos

  * src/codepage/uckam.c
    + added info about Kamenicky codepage number: CP895

  * include/hbapi.h
  * src/common/hbstr.c
    + added new C function:
         char * hb_dblToStr( char * szBuf, HB_SIZE nSize,
                             double dNumber, int iMaxDec );
      it converts numeric value to string trying to keep all significant
      digits in double numbers

  * include/harbour.hbx
  * src/rtl/hbntos.c
    + added new PRG function:
         hb_ntoc( <nValue> ) -> cValue
      it converts numeric value to string trying to keep all significant
      digits in double numbers

  * src/rtl/hbsocket.c
    + added support for error codes returned by
      getaddrinfo() / getnameinfo() and gethostbyname() / gethostbyaddr()

  * src/rtl/hbinet.c
    + set HB_SOCKET_ERR_WRONGADDR error code if hb_socketResolveAddr()
      returns NULL without setting error code

  * src/vm/arrays.c
  * src/vm/hashfunc.c
    ! fix hb_HScan(), AScan(), hb_AScan() and hb_RAScan() for very large
      integers with more then 53 significant bits. Such bits were lost
      after conversion to double value used in scan process

  * src/vm/itemapi.c
    * formatting

  * src/rtl/gtwvt/gtwvt.c
    ! do not convert characters received with ALTGR or ALT+CTRL flags to
      extended keycodes - some national keyboards may use such combination
      for national characters and even pure ASCII ones

2016-05-04 15:50 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/hbsocket.c
    ! fixed very bad typo which caused buffer overflow on 32bit
      platforms using poll() instead of select() in hb_socketSelect()

2016-05-04 13:29 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/gtwin/gtwin.c
    ! strip ALT+CTRL and ALTGR from extended keycode when these modifiers
      are used with ASCII characters - it should fix problem with some
      national keyboards

2016-04-29 16:25 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/filesys.c
  * src/rtl/hbcom.c
  * src/rtl/hbproces.c
  * src/rtl/hbsocket.c
    + added support for user build time macro HB_NO_POLL which disables
      poll() usage

  * src/rtl/hbsocket.c
    ! fixed bug which caused that structure passed to poll() had
      uninitialized events member.

  * include/hbclass.ch
    * disabled by default VO compatible object constructors:
         <className>{ <params,...> }
      If someone needs them then he should add:
         #define HB_VO_CONSTRUCTOR
      before:
         #include "hbclass.ch"

  * src/compiler/harbour.y
    * typo in comment

2016-04-20 18:03 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/hbstrfmt.c
    ! restored pointer incrementation I removed unintentionally

2016-04-20 17:31 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/hbstrfmt.c
    * add to output trailing % in format pattern just like other % characters
      which are not part of valid format string, i.e. in this code:
         ? hb_StrFormat( "%-% %1%q%*%" )
      only the last % was silently eaten from output

2016-04-20 17:19 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/hbstrfmt.c
    ! fixed wrongly added to output character after unclosed format strings,
      i.e.
         ? hb_StrFormat( "%1" )
         ? hb_StrFormat( "%1%s", "x" )

2016-04-19 23:14 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/common/hbffind.c
    * in *nix builds of hb_fsFind*() show "." leading file names if file
      mask also starts with "." regardless of hidden attribute state.
      This modification restores previous Harbour behavior keeping the
      new functionality.

2016-04-19 14:49 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/gtwin/gtwin.c
    ! fixed wrong translation in my previous commit

2016-04-18 18:41 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc1.cpp
  * src/rtl/gtwin/gtwin.c
  * src/rtl/gtwvt/gtwvt.c
    ! fixed stupid C&P typo in my previous modification - thanks to Lorenzo.

2016-04-18 18:05 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/strrepl.c
    ! fixed hb_strReplace() for strings longer then 1024 bytes and
      array used in 3rd parameter.

2016-04-18 17:33 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/gtqtc/gtqtc1.cpp
  * src/rtl/gtwin/gtwin.c
  * src/rtl/gtwvt/gtwvt.c
    ! changed extended keycodes generated for ASCII characters
      combined with ALT and/or CTRL flags. It fixes problems with
      code giving the highest priority for:
         ! hb_keyChar( nKey ) == ""
      i.e. MemoEdit()

  * contrib/hbmzip/mziperr.prg
    % replaced DO CASE / ENDCASE with SWITCH / ENDSWITCH
    ! fixed repeated error codes

2016-04-08 14:30 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbsocket.ch
  * src/rtl/hbsocket.c
    + added support for high-priority/out-of-bound data in select()
      emulated by poll()
    + added macros for socket send()/recv() flags: HB_SOCKET_MSG_*

  * src/rtl/filesys.c
  * src/rtl/hbcom.c
  * src/rtl/hbproces.c
    * include <poll.h> when HB_HAS_POLL macro is set manually by user
      (thanks to Teo)

  * contrib/hbnetio/netiosrv.c
    * minor optimization

2016-04-07 18:48 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  + tests/pipes.prg
    + added demonstration/test code for communication between processes
      by unnamed pipes. The final output is send to stderr and can be
      redirected to file by 2> pipes.log

2016-04-07 18:34 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/common/hbprintf.c
    * pacified warning

  * src/rtl/filesys.c
    ! return -1 instead of from hb_fsPipeIsData() when poll() detects
      error or end of stream - 0 should indicate timeout only.

  * src/rtl/hbcom.c
    ! fixed bad typo which blocked hb_comSend() in *nixes
      using select() instead of poll()

  * src/rtl/filesys.c
  * src/rtl/hbcom.c
  * src/rtl/hbproces.c
  * src/rtl/hbsocket.c
    ; updated #if/#else/#endif comments

2016-04-06 15:49 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/common/hbprintf.c
    * pacified warnings

2016-04-06 15:18 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/common/hbstr.c
  * src/rtl/hbcom.c
  * src/rtl/hbproces.c
    * pacified few warnings - thanks to Viktor

  * contrib/sddfb/core.c
    ! fixed code which extracted float number from uninitialized memory.
      On some systems it could even cause GPF or other (ie. FPE) exception.

2016-04-06 13:11 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/hbproces.c
    ! fixed infinite loop due to ignored POLLHUP errors reported by poll()
    ! fixed stupid typo

  * src/rtl/hbproces.c
  * src/rtl/hbsocket.c
  * src/rtl/filesys.c
  * src/rtl/hbcom.c
    * emulate read access when poll() used instead of select() reports
      POLLHUP - this poll() behavior is neither consistent within a
      single implementation, nor between different versions of the same
      implementation, and certainly not across platforms
    % optimize read/write access using extended (in comparison to select())
      information reported by poll()
    ; TODO: emulate select() behavior for high priority data. [DONE]

2016-04-05 21:24 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/gttone.c
    ! use asm {} directive only in CLANG BCC builds - asm {} needs TASM
      so using it breaks Harbour compilation with free BorlandC command
      line tools which do not contain TASM.

  * src/rtl/hbsocket.c
  * src/rtl/hbproces.c
  * src/rtl/filesys.c
  * src/rtl/hbcom.c
    ! use poll() instead of select() in POSIX.1-2001 compliant *nix builds
      It fixes the problem with file handles >= 1024
      Please make tests in different *nix builds. It affects sockets, pipes
      and serial ports.

2016-04-05 16:27 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbnetio/netiosrv.c
    * minor optimization

  * src/rdd/dbcmd.c
  * src/rdd/wacore.c
  * src/rdd/wafunc.c
    ! added protection against exceeding the limit of workarea numbers.
      Current maximum is 65534, WA 65535 is reserved for internal RDD
      WA destructor.
    ! fixed possible memory leak in hb_rddInsertAreaNode()

  * src/vm/set.c
    ! fixed typo in device detection code
    + added NUL to list of known device names in DOS, OS2 and MS-Win builds
    + recognize \\<server>\<device>, \\.\PIPE\*, \\.\<device> as
      device names in DOS, OS2 and MS-Win builds.

2016-04-01 00:28 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/direct.c
    ! removed set of MS-Windows attributes passed unconditionally to
      hb_fsFind*() functions in Directory() PRG function.
      It fixes "L" attribute passed in 2nd parameter of Directory()
      function in *nix builds. When "L" is given in attribute list
      then Directory() do not follow links.

  * src/common/strwild.c
    * removed FNM_PERIOD from fnmatch() parameters in *nix builds

  * src/common/hbffind.c
    * in * nix builds set hidden attribute for file and directory
      names starting with "." except "." and ".." which are reported
      as is for Cl*pper and Harbour multiplatform compatibility.

2016-03-30 16:35 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbdefs.h
    ! use "ll" instead of "I64" as 64bit integer modifier in *printf()
      functions in Embarcadero CLANG based compilers

2016-03-30 16:10 UTC+0200 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/gttone.c
    * applied patch from Andi Jahja for new BCC versions - many thanks

  * src/rtl/strrepl.c
    % added optimization code for strings longer then 1024 bytes
      For very long strings it can improve replace performance 20 or
      even more times.

  * src/rtl/sha2.c
  * src/rtl/val.c
  * src/vm/dynsym.c
  * src/vm/eval.c
  * src/vm/thread.c
    * formatting

2016-03-28 13:09 UTC+0200 Viktor Szakats (vszakats users.noreply.github.com)
  * config/dyn.mk
  * config/win/mingw.mk
  * src/dynlib/2nd/Makefile
  * src/dynlib/Makefile
  + src/harbour.def
    + use .def file to specify public symbols of harbour.dll
      for more details, see:
         https://github.com/vszakats/harbour-core/commit/f238e5f81ff07cb07fa3a21d3c82009db79ab7de
         https://github.com/vszakats/harbour-core/commit/b2c9e4a63b1aca42b462cec49d55c4b1cbd1066c
    ; NOTE: please make sure to add any new public (HB_EXPORT)
            symbols to this list. Ordinals are not significant
            ATM so the best is to keep alphabetical order.

2016-03-25 17:05 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbclass.ch
    ! use more restrictive PP rules to avoid possible wrong
      interactions with code using 'var' and 'data' identifiers
    * force class name to be valid identifier
    * commented unused rules

  * include/std.ch
    ! fixed CODEPAGE clause in COPY TO and APPEND FROM commands
    + added VIA and CODEPAGE clauses to JOIN command

  * src/rdd/dbcmd.c
    * updated comments with some function syntax

2016-03-18 17:42 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/harbour.hbx
  * src/rdd/dbcmd.c
    + added new function:
         hb_dbGetFilter() -> <bCode> | NIL
      it returns codeblock used as work area filter or NIL

  * src/debug/dbgwa.prg
    * use hb_dbGetFilter() to check if WA filter was set without
      filter text representation

  ; above modifications created by Rolf - thanks

  * src/rdd/dbcmd.c
    ! clear filter if dbGetFilter( , "" ) is called instead of setting
      dummy one - thanks to Rolf

2016-03-16 14:19 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbclass.ch
    * typo in comment

2016-03-16 14:17 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbclass.ch
    * disabled DECLARE to not generate ignored by compiler noise in .ppo
      files

  * src/rdd/dbcmd.c
    ! allow to use dbSetFilter() with string only parameter without
      codeblock - Cl*pper compatibility fix.
      Cl*pper allows to set text filter without codeblock. In local
      RDDs it effectively does nothing and only dbFilter() returns it
      but RDDs with automatic filter optimization like CL53/DBFCDX /
      COMIX/ClipMore or RDDs working with remote data base servers
      may use only text version of filter and ignore or use with
      lower priority the codeblock so Harbour has to work like
      Cl*pper here.

  * src/rdd/workarea.c
    * typo in comment

  * contrib/rddads/ads1.c
    * do not validate empty text filters

2016-03-10 12:52 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/langcomp.prg
    ! added missing de-AT lang mapping

2016-03-08 22:10 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/isprint.c
    ! HB_ISPRINTER(), ISPRINTER() fix to open the port name with CREATE
      flag (= CREATE_ALWAYS on Windows). It may fix port detection in
      certain situations. Tested on Windows 7 x86 and x64, whereas it
      will now return .T. if the port is associated with a queue,
      and .F. if it isn't. It seems to cause no harm on OS X. Please
      test it on other systems and other LPT scenarios (f.e. with real
      hardware device attached).
    ; borrowed from Viktor's fork: 2016-03-08 18:19 UTC+0100 Viktor Szakats

  * ChangeLog.txt
    ; hide e-mail addresses

2016-03-08 16:18 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbwin/hbwin.ch
    + added macros with printer status errors

  * contrib/hbwin/wapi_wingdi.c
  * contrib/hbwin/win_prn1.c
  * contrib/hbwin/win_prn2.c
  * contrib/hbwin/win_prn3.c
    * clear pointers and memory buffers passed to windows printer functions
    * removed repeated definition

2016-03-08 16:01 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbmzip/mzip.c
    ! fixed memory leak
    ! typo in comment

  * contrib/hbziparc/ziparc.prg
    ! strip leading dir separators from filenames stored in ZIP file when
      <lWithDrive> parameter of hb_ZipFile() is not set.

2016-03-08 14:52 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/lang/Makefile
  + src/lang/l_de_at.c
  * include/hblang.hbx
    + added new DE_AT German-Austria lang module by byte1one/at/gmail.com

  * src/lang/l_is.c
    ! fixes in Icelandic lang module by Isleifur Gislason
      <isleifurgisla/at/gmail.com>

2016-03-01 16:11 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/gttrm/gttrm.c
    + added support for CYGWIN ssh terminal
      (i.e. ssh.exe included in github for MS-Windows)
    ! fixed support for terminals which always scrolls when the most
      bottom/right character is written.
      In current version GTTRM simply ignores this character cell.
      On such terminals it can be shown by writing the last character
      one cell before then sending escape sequences to move cursor back,
      insert one space and finally restoring overwritten character
      cell value. Anyhow it increases number of used escape sequences
      so I decided to not implement it yet.

2016-02-18 17:02 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/fileio.ch
    + added HB_VF_IONAME to hb_vcConfigure() actions

  * contrib/hbbz2io/bz2io.c
  * contrib/hbcomio/comio.c
  * contrib/hbgzio/gzio.c
  * contrib/hbmemio/memio.c
  * contrib/hbnetio/netio.h
  * contrib/hbnetio/netiocli.c
  * contrib/hbpipeio/pipeio.c
  * contrib/hbtcpio/tcpio.c
  * src/rtl/filebuf.c
    + implemented HB_VF_IONAME

  * contrib/hbnetio/netiosrv.c
    ! added protection against possible buffer overflow

  * src/rdd/dbfcdx/dbfcdx1.c
  * src/rdd/dbfnsx/dbfnsx1.c
  * src/rdd/dbfntx/dbfntx1.c
    * restored CL5.[23] compatible tag selection - I had to broke
      it when I was adding SIX3 compatibility functions

2016-02-16 22:30 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * include/hbapirdd.h
  * src/rdd/wacore.c
  * src/rdd/workarea.c
    + added new C function which allows to register RDD redirector
      which depends on used table name:
         typedef LPRDDNODE ( * HB_RDDACCEPT )
               ( LPRDDNODE pRddNode, const char * szFileName );
         void hb_rddSetFileRedirector( HB_RDDACCEPT funcAccept,
                                       HB_BOOL fEnable );
    + added new C functions which allows to find RDD respecting
      active redirectors:
         const char * hb_rddFindDrv( const char * szDriver,
                                     const char * szFileName );
         LPRDDNODE hb_rddFindFileNode( LPRDDNODE pRddNode,
                                       const char * szFileName );
    * cleaned some HB_TRACE messages

  * src/rdd/dbcmd.c
  * src/rdd/wafunc.c
    + use functions which respect redirectors to find RDD

2016-02-16 15:44 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/hbgtcore.c
    ! fill whole box area in DispBpx() when 0 length string or string with
      Chr( 0 ) at the beginning is used as box frame - Cl*pper compatible
      behavior

2016-02-11 11:54 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * ChangeLog.txt
  * include/hbapifs.h
  * src/rtl/filesys.c
    * cleaned hb_fsOpenEx() parameters order

  * src/common/hbprintf.c
    ! typo in comment

2016-02-10 17:17 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/filesys.c
    * replaced hb_fsCreate() and hb_fsCreateEx() with wrappers
      to hb_fsOpenEx()

2016-02-09 20:16 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * src/rtl/filesys.c
    ! pacified BCC warning - thanks to Grigory

2016-02-09 18:11 UTC+0100 Przemyslaw Czerpak (druzus/at/poczta.onet.pl)
  * contrib/hbnetio/hbnetio.hbx
  * contrib/hbnetio/netiocli.c
  * contrib/hbnetio/readme.txt
    + added new client side function:
         netio_SetPath( <pConnection> [, <cPath>] ) -> [<cPrevPath>]
      It set/get path prefix for automatic file redirection to HBNETIO.
      If automatic redirection is activated then <cPath> is removed
      from file name passed to HBNETIO server, i.e.:

         netio_SetPath( netio_GetConnection(), "//myserver/myshare" )
         [...]
         /* open "/data/table" on HBNETIO server */
         use "//myserver/myshare/data/table"
